Type: Package
Package: OlinkAnalyzeVignettes
Title: Vignettes for Analyzing Data using 'OlinkAnalyze'
Version: 1.0.1
Authors@R: c(
    person("Kathleen", "Nevola", , "biostattools@olink.com", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0002-5183-6444", "kathy-nevola")),
    person("Marianne", "Sandin", role = "aut",
           comment = c(ORCID = "0000-0001-6186-963X", "marisand")),
    person("Jamey", "Guess", role = "aut",
           comment = c(ORCID = "0000-0002-4017-0923", "jrguess")),
    person("Simon", "Forsberg", role = "aut",
           comment = c(ORCID = "0000-0002-7451-9222", "simfor")),
    person("Christoffer", "Cambronero", role = "aut",
           comment = c("Orbmac")),
    person("Pascal", "Pucholt", role = "aut",
           comment = c(ORCID = "0000-0003-3342-1373", "AskPascal")),
    person("Boxi", "Zhang", role = "aut",
           comment = c(ORCID = "0000-0001-7758-6204", "boxizhang")),
    person("Masoumeh", "Sheikhi", role = "aut",
           comment = c("MasoumehSheikhi")),
    person("Klev", "Diamanti", role = "aut",
           comment = c(ORCID = "0000-0002-4922-8415", "klevdiamanti")),
    person("Amrita", "Kar", role = "aut",
           comment = c("amrita-kar")),
    person("Lei", "Conze", role = "aut", 
            comment = c("leiliuC")),
    person("Kristyn", "Chin", role = "aut",
            comment = c("kristynchin-olink")),
    person("Danai", "Topouza", role = "aut",
            comment = c("dtopouza", ORCID = "0000-0002-6897-9281")),
    person("Stephen", "Pollo", role = "aut",
            comment = c("spollo-olprot", ORCID = "0000-0001-9252-4976")),
    person("Kang", "Dong", role = "aut",
            comment = c("KangD-dev", ORCID = "0000-0002-4567-5007")),
    person("Kristian", "Hodén", role = "ctb",
           comment = c(ORCID = "0000-0003-0354-0662", "kristianHoden")),
    person("Per", "Eriksson", role = "ctb",
           comment = c(ORCID = "0000-0001-7633-403X", "b_watcher")),
    person("Nicola", "Moloney", role = "ctb",
            comment = c(ORCID = "0000-0003-4967-3284")),
    person("Britta", "Lötstedt", role = "ctb",
            comment = c(ORCID = "0000-0003-3545-5489")),
    person("Emmett", "Sprecher", role = "ctb",
           comment = c(ORCID = "0000-0002-7710-695X")),
    person("Jessica", "Barbagallo", role = "ctb",
           comment = c("jbarbagallo")),
    person("Olof", "Mansson", role = "ctr",
           comment = c("olofmansson")),
    person("Ola", "Caster", role = "ctb",
           comment = c("OlaCaster")),
    person("Olink", role = c("cph", "fnd"))
  )
Description: Exemplifying analysis of large-scale protein
    data from the 'Olink platform', primarily relative protein expression
    data that has been exported from
    'Olink NPX Software', as well as QUANT data from 'Olink'.
    QUANT data is log-transformed. Materials focus on reading data, 
    demonstrating data wrangling and quality control analysis,
    performing statistical analysis and generating
    figures to visualize the results of the statistical analysis. 
    The goal of this package is to guide users extract biological insights 
    from large-scale protein data run on the 'Olink platform'.
    More information on 'Olink' data can be found at <https://olink.com/>.
Contact: biostattools@olink.com
URL: https://olink.com/
        https://github.com/Olink-Proteomics/OlinkRPackage
License: AGPL (>= 3)
Encoding: UTF-8
Depends: R (>= 4.1.0)
Suggests: dplyr (>= 1.2.0), ggplot2, ggpubr, ggrepel, kableExtra,
        knitr, OlinkAnalyze, stringr, tidyr
VignetteBuilder: knitr
Config/roxygen2/version: 8.0.0
NeedsCompilation: no
Packaged: 2026-06-01 18:27:06 UTC; kathy.nevola
Author: Kathleen Nevola [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-5183-6444>, kathy-nevola),
  Marianne Sandin [aut] (ORCID: <https://orcid.org/0000-0001-6186-963X>,
    marisand),
  Jamey Guess [aut] (ORCID: <https://orcid.org/0000-0002-4017-0923>,
    jrguess),
  Simon Forsberg [aut] (ORCID: <https://orcid.org/0000-0002-7451-9222>,
    simfor),
  Christoffer Cambronero [aut] (Orbmac),
  Pascal Pucholt [aut] (ORCID: <https://orcid.org/0000-0003-3342-1373>,
    AskPascal),
  Boxi Zhang [aut] (ORCID: <https://orcid.org/0000-0001-7758-6204>,
    boxizhang),
  Masoumeh Sheikhi [aut] (MasoumehSheikhi),
  Klev Diamanti [aut] (ORCID: <https://orcid.org/0000-0002-4922-8415>,
    klevdiamanti),
  Amrita Kar [aut] (amrita-kar),
  Lei Conze [aut] (leiliuC),
  Kristyn Chin [aut] (kristynchin-olink),
  Danai Topouza [aut] (dtopouza, ORCID:
    <https://orcid.org/0000-0002-6897-9281>),
  Stephen Pollo [aut] (spollo-olprot, ORCID:
    <https://orcid.org/0000-0001-9252-4976>),
  Kang Dong [aut] (KangD-dev, ORCID:
    <https://orcid.org/0000-0002-4567-5007>),
  Kristian Hodén [ctb] (ORCID: <https://orcid.org/0000-0003-0354-0662>,
    kristianHoden),
  Per Eriksson [ctb] (ORCID: <https://orcid.org/0000-0001-7633-403X>,
    b_watcher),
  Nicola Moloney [ctb] (ORCID: <https://orcid.org/0000-0003-4967-3284>),
  Britta Lötstedt [ctb] (ORCID: <https://orcid.org/0000-0003-3545-5489>),
  Emmett Sprecher [ctb] (ORCID: <https://orcid.org/0000-0002-7710-695X>),
  Jessica Barbagallo [ctb] (jbarbagallo),
  Olof Mansson [ctr] (olofmansson),
  Ola Caster [ctb] (OlaCaster),
  Olink [cph, fnd]
Maintainer: Kathleen Nevola <biostattools@olink.com>
Repository: CRAN
Date/Publication: 2026-06-08 14:50:26 UTC
Built: R 4.6.0; ; 2026-06-08 18:47:14 UTC; unix

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  tidy = FALSE,
  tidy.opts = list(width.cutoff = 95),
  fig.width = 6,
  fig.height = 3,
  message = FALSE,
  warning = FALSE,
  time_it = TRUE,
  fig.align = "center"
)

## ----echo = FALSE-------------------------------------------------------------
set.seed(1234)

# Load example dataset (npx_data1)
npx_data1 <- OlinkAnalyze::npx_data1

# NPX file preprocessing
## Generate check log
check_log_npx_data1 <- OlinkAnalyze::check_npx(
  df = npx_data1
)

## Clean NPX
npx_data1_clean <- OlinkAnalyze::clean_npx(
  df = npx_data1,
  check_log = check_log_npx_data1
)

## Generate check log on cleaned data
check_log_npx_data1_clean <- OlinkAnalyze::check_npx(
  df = npx_data1_clean
)

table1 <- npx_data1_clean |>
  dplyr::slice_head(
    n = 6L
  ) |>
  dplyr::select(
    -dplyr::all_of(
      c("Index", "MissingFreq", "Panel_Version", "QC_Warning", "Subject",
        "Treatment", "Site", "Time", "Project", "Panel", "PlateID")
    )
  ) |>
  dplyr::mutate(
    Count = round(
      x = .data[["NPX"]] * (100L + sample(x = seq(from = -5L, to = 15L),
                                          size = 1L))
    )
  ) |>
  dplyr::mutate(
    SampleType = "SAMPLE"
  ) |>
  dplyr::mutate(
    Normalization = "Plate control"
  ) |>
  dplyr::mutate(
    NPX = round(x = .data[["NPX"]], digits = 2L)
  ) |>
  dplyr::mutate(
    LOD = round(x = .data[["LOD"]], digits = 2L)
  ) |>
  dplyr::mutate(
    PCNormalizedNPX = .data[["NPX"]]
  ) |>
  dplyr::mutate(
    PCNormalizedLOD = .data[["LOD"]]
  ) |>
  dplyr::select(
    dplyr::all_of(
      c("SampleID", "SampleType", "OlinkID", "UniProt", "Assay", "Count", "NPX",
        "PCNormalizedNPX", "Normalization", "LOD", "PCNormalizedLOD")
    )
  )

table1 |>
  knitr::kable(
    caption = "Example results from Plate Control Normalized Project"
  ) |>
  kableExtra::kable_styling(
    font_size = 10L
  )

table1 |>
  dplyr::mutate(
    Normalization = "Intensity"
  ) |>
  dplyr::mutate(
    NPX = round(x = .data[["NPX"]] + 4.16, digits = 2L)
  ) |>
  dplyr::mutate(
    LOD = round(x = .data[["LOD"]] + 4.16, digits = 2L)
  ) |>
  dplyr::select(
    dplyr::all_of(
      c("SampleID", "SampleType", "OlinkID", "UniProt", "Assay", "Count", "NPX",
        "PCNormalizedNPX", "Normalization", "LOD", "PCNormalizedLOD")
    )
  ) |>
  knitr::kable(
    caption = "Example results from Intensity Normalized Project"
  ) |>
  kableExtra::kable_styling(
    font_size = 10
  )

## ----npx_data_for_lod, eval = FALSE, message = FALSE, warning = FALSE---------
# # Preprocessing steps for both fixed LOD and Negative Control LOD integration
# 
# ## Load NPX file
# df_npx <- OlinkAnalyze::read_NPX(
#   filename = "Path_to/Explore_NPX_file.parquet"
# )
# 
# ## Check NPX data
# check_log_df_npx <- OlinkAnalyze::check_npx(
#   df = df_npx
# )
# 
# ## Clean NPX data
# df_npx_clean <- OlinkAnalyze::clean_npx(
#   df = df_npx,
#   check_log = check_log_df_npx,
#   # do not remove controls or warnings to ensure LOD can be calculated correctly
#   remove_control_assay = FALSE,
#   remove_control_sample = FALSE,
#   remove_assay_warning = FALSE,
#   remove_qc_warning = FALSE
# )
# 
# ## Generate check log on cleaned data
# check_log_df_npx_clean <- OlinkAnalyze::check_npx(
#   df = df_npx_clean
# )
# 
# # Cleanup intermediate objects
# rm(
#   df_npx,
#   check_log_df_npx
# )

## ----NCLOD_example, eval = FALSE, message = FALSE, warning = FALSE------------
# # Calculate LOD from negative controls
# 
# ## Calculate LOD
# df_npx_nc_lod <- OlinkAnalyze::olink_lod(
#   data = df_npx_clean,
#   lod_method = "NCLOD",
#   check_log = check_log_df_npx_clean
# )
# 
# ## Generate check log on data with LOD
# check_log_df_npx_nc_lod <- OlinkAnalyze::check_npx(
#   df = df_npx_nc_lod
# )
# 
# ## Clean NPX data with LOD
# df_npx_nc_lod_clean <- OlinkAnalyze::clean_npx(
#   df = df_npx_nc_lod,
#   check_log = check_log_df_npx_nc_lod
# )
# 
# ## Generate check log on cleaned data with LOD
# check_log_df_npx_nc_lod_clean <- OlinkAnalyze::check_npx(
#   df = df_npx_nc_lod_clean
# )
# 
# # Cleanup intermediate objects
# rm(
#   df_npx_nc_lod,
#   check_log_df_npx_nc_lod
# )
# 
# # Rename final cleaned data with LOD for clarity
# df_npx_nc_lod <- df_npx_nc_lod_clean
# check_log_df_npx_nc_lod <- check_log_df_npx_nc_lod_clean
# rm(
#   df_npx_nc_lod_clean,
#   check_log_df_npx_nc_lod_clean
# )

## ----FixedLOD, eval = FALSE, message = FALSE, warning = FALSE-----------------
# # Integrating fixed LOD
# 
# ## Fixed LOD file path
# fixedlod_filepath <- "Path_to/ExploreHT_fixedLOD.csv"
# 
# ## Calculate LOD
# df_npx_fixed_lod <- OlinkAnalyze::olink_lod(
#   data = df_npx_clean,
#   lod_method = "FixedLOD",
#   lod_file_path = fixedlod_filepath,
#   check_log = check_log_df_npx_clean
# )
# 
# ## Generate check log on data with LOD
# check_log_df_npx_fixed_lod <- OlinkAnalyze::check_npx(
#   df = df_npx_fixed_lod
# )
# 
# ## Clean NPX data with LOD
# df_npx_fixed_lod_clean <- OlinkAnalyze::clean_npx(
#   df = df_npx_fixed_lod,
#   check_log = check_log_df_npx_fixed_lod
# )
# 
# ## Generate check log on cleaned data with LOD
# check_log_npx_fixed_lod_clean <- OlinkAnalyze::check_npx(
#   df = df_npx_fixed_lod_clean
# )
# 
# # Cleanup intermediate objects
# rm(
#   df_npx_fixed_lod,
#   check_log_df_npx_fixed_lod
# )
# 
# # Rename final cleaned data with LOD for clarity
# df_npx_fixed_lod <- df_npx_fixed_lod_clean
# check_log_df_npx_fixed_lod <- check_log_npx_fixed_lod_clean
# rm(
#   df_npx_fixed_lod_clean,
#   check_log_npx_fixed_lod_clean
# )

## ----echo = FALSE-------------------------------------------------------------
table1 |>
  dplyr::mutate(
    Normalization = "Intensity"
  ) |>
  dplyr::mutate(
    PCNormalizedNPX = round(x = .data[["NPX"]], digits = 2L)
  ) |>
  dplyr::mutate(
    PCNormalizedLOD = round(x = .data[["LOD"]], digits = 2L)
  ) |>
  dplyr::mutate(
    NPX = round(.data[["NPX"]] + 4.16, digits = 2L)
  ) |>
  dplyr::mutate(
    LOD = round(.data[["LOD"]] + 4.16, digits = 2L)
  ) |>
  dplyr::rename(
    "FixedLOD" = "LOD",
    "FixedPCNormalizedLOD" = "PCNormalizedLOD"
  ) |>
  dplyr::mutate(
    NCLOD = .data[["FixedLOD"]] - 2.34,
    NCPCNormalizedLOD = .data[["FixedPCNormalizedLOD"]] - 2.34
  ) |>
  dplyr::select(
    dplyr::all_of(
      c("SampleID", "SampleType", "OlinkID", "UniProt", "Assay", "Count", "NPX",
        "Normalization", "PCNormalizedNPX", "FixedLOD", "FixedPCNormalizedLOD",
        "NCLOD", "NCPCNormalizedLOD")
    )
  ) |>
  knitr::kable(
    caption = "Example results using both LOD calculation methods"
  ) |>
  kableExtra::kable_styling(
    font_size = 10L
  )

## ----explore_npx_export, eval = FALSE, message = FALSE, warning = FALSE-------
# # Exporting Olink NGS data with LOD information as a parquet file
# 
# ## Integrate both Negative Control LOD and fixed LOD before NPX preprocessing
# df_npx_both_lod <- OlinkAnalyze::olink_lod(
#   data = df_npx_clean,
#   lod_file_path = fixedlod_filepath,
#   lod_method = "Both",
#   check_log = check_log_df_npx_clean
# )
# 
# ## Generate check log
# check_log_df_npx_both_lod <- OlinkAnalyze::check_npx(
#   df = df_npx_both_lod
# )
# 
# ## Clean NPX
# df_npx_both_lod_clean <- OlinkAnalyze::clean_npx(
#   df = df_npx_both_lod,
#   check_log = check_log_df_npx_both_lod
# )
# 
# ## Generate check log on cleaned data
# check_log_npx_both_lod_clean <- OlinkAnalyze::check_npx(
#   df = df_npx_both_lod_clean
# )
# 
# # Cleanup intermediate objects
# rm(
#   df_npx_both_lod,
#   check_log_df_npx_both_lod
# )
# 
# # Rename final cleaned data with both LOD for clarity
# df_npx_both_lod <- df_npx_both_lod_clean
# check_log_df_npx_both_lod <- check_log_npx_both_lod_clean
# rm(
#   df_npx_both_lod_clean,
#   check_log_npx_both_lod_clean
# )
# 
# # Add metadata for export
# df_npx_both_lod_arrow <- df_npx_both_lod |>
#   arrow::as_arrow_table()
# 
# df_npx_both_lod_arrow$metadata$FileVersion <- "NA"
# df_npx_both_lod_arrow$metadata$ExploreVersion <- "NA"
# df_npx_both_lod_arrow$metadata$ProjectName <- "NA"
# df_npx_both_lod_arrow$metadata$SampleMatrix <- "NA"
# df_npx_both_lod_arrow$metadata$DataFileType <- "Olink Analyze Export File"
# # One of "ExploreHT", "Explore3072", or "Reveal"
# df_npx_both_lod_arrow$metadata$ProductType <- "ExploreHT"
# # # "ExploreHT", "Explore3072", or "Reveal"
# df_npx_both_lod_arrow$metadata$Product <- "ExploreHT"
# 
# arrow::write_parquet(
#   x = df_npx_both_lod_arrow,
#   sink = "path_to_output.parquet"
# )

## ----setup, include = FALSE, echo = FALSE, eval = TRUE------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  tidy = FALSE,
  tidy.opts = list(width.cutoff = 95),
  fig.width = 6,
  fig.height = 3,
  message = FALSE,
  warning = FALSE,
  time_it = TRUE,
  fig.align = "center"
)
knitr::opts_chunk$set(fig.pos = "H")
knitr::opts_chunk$set(fig.align = "center")
knitr::opts_knit$set(eval.after = "fig.cap")

## ----Outlier_data, include = FALSE, error = TRUE, message = FALSE, warning = FALSE----
try({
# Use provided example dataset (npx_data1)
npx_data1 <- OlinkAnalyze::npx_data1

# NPX file preprocessing

# Generate check log
check_log_npx_data1 <- OlinkAnalyze::check_npx(
  df = npx_data1
)

# Clean NPX
npx_data1_clean <- OlinkAnalyze::clean_npx(
  df = npx_data1,
  check_log = check_log_npx_data1
)

# Generate check log on cleaned data
check_log_npx_data1_clean <- OlinkAnalyze::check_npx(
  df = npx_data1_clean
)

# Create Dataset with outliers
outlier_data <- npx_data1_clean |>
  dplyr::mutate(
    NPX = dplyr::if_else(
      .data[["SampleID"]] == "A25",
      .data[["NPX"]] + 4,
      .data[["NPX"]]
    )
  ) |>
  dplyr::mutate(
    NPX = dplyr::if_else(
      .data[["SampleID"]] == "A52",
      .data[["NPX"]] - 4,
      .data[["NPX"]]
    )
  )

group_data <- npx_data1_clean |>
  dplyr::mutate(
    NPX = dplyr::if_else(
      .data[["Site"]] == "Site_D",
      .data[["NPX"]] + 3,
      .data[["NPX"]]
    )
  )

# Clean up environment
rm(check_log_npx_data1, npx_data1)
})

## ----dataset_generation, eval = FALSE, message = FALSE, warning = FALSE-------
# # Use provided example dataset (npx_data1)
# npx_data1 <- OlinkAnalyze::npx_data1
# 
# # NPX file preprocessing
# 
# # Generate check log
# check_log_npx_data1 <- OlinkAnalyze::check_npx(
#   df = npx_data1
# )
# 
# # Clean NPX
# npx_data1_clean <- OlinkAnalyze::clean_npx(
#   df = npx_data1,
#   check_log = check_log_npx_data1
# )
# 
# # Generate check log on cleaned data
# check_log_npx_data1_clean <- OlinkAnalyze::check_npx(
#   df = npx_data1_clean
# )
# 
# # Create Dataset with outliers
# outlier_data <- npx_data1_clean |>
#   dplyr::mutate(
#     NPX = dplyr::if_else(
#       .data[["SampleID"]] == "A25",
#       .data[["NPX"]] + 4,
#       .data[["NPX"]]
#     )
#   ) |>
#   dplyr::mutate(
#     NPX = dplyr::if_else(
#       .data[["SampleID"]] == "A52",
#       .data[["NPX"]] - 4,
#       .data[["NPX"]]
#     )
#   )
# 
# group_data <- npx_data1_clean |>
#   dplyr::mutate(
#     NPX = dplyr::if_else(
#       .data[["Site"]] == "Site_D",
#       .data[["NPX"]] + 3,
#       .data[["NPX"]]
#     )
#   )

## ----Outlier_example_code, eval = FALSE, fig.show='hide'----------------------
# p1 <- OlinkAnalyze::olink_pca_plot(
#   df = outlier_data,
#   label_samples = TRUE,
#   quiet = TRUE,
#   check_log = check_log_npx_data1_clean
# )
# 
# p2 <- OlinkAnalyze::olink_pca_plot(
#   df = group_data,
#   color_g = "Site",
#   quiet = TRUE,
#   check_log = check_log_npx_data1_clean
# )
# 
# ggpubr::ggarrange(
#   p1[[1L]],
#   p2[[1L]],
#   nrow = 1L,
#   labels = "AUTO"
# )

## ----Outlier_Example, echo = FALSE, fig.cap = fcap----------------------------
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/PCA_Outlier_Fig1.png"
  ),
  error = FALSE
)

fcap <- paste("**Figure 1** **A.** PCA can be used to identify individual",
              "outlier samples as shown by samples A25 and A52. **B.** PCA can",
              "be used to identify difference in groups as seen by Site_D",
              "samples. This is not suggesting Site_D is an outlier, but",
              "rather that there may be a global difference between sites.")

## ----PCA_treatment, eval = FALSE----------------------------------------------
# OlinkAnalyze::olink_pca_plot(
#   df = npx_data1_clean,
#   color_g = "Treatment",
#   check_log = check_log_npx_data1_clean
# )

## ----PCA_treatment_fig, echo = FALSE------------------------------------------
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/PCA_Treatment.png"
  ),
  error = FALSE
)

## ----PCA_Panel, eval = FALSE--------------------------------------------------
# # Use provided example dataset (npx_data2)
# 
# npx_data2 <- OlinkAnalyze::npx_data2
# 
# # NPX file preprocessing
# 
# # Generate check log
# check_log_npx_data2 <- OlinkAnalyze::check_npx(
#   df = npx_data2
# )
# 
# # Clean NPX
# npx_data2_clean <- OlinkAnalyze::clean_npx(
#   df = npx_data2,
#   check_log = check_log_npx_data2
# )
# 
# # Generate check log on cleaned data
# check_log_npx_data2_clean <- OlinkAnalyze::check_npx(
#   df = npx_data2_clean
# )
# 
# # Specify by panel
# OlinkAnalyze::olink_pca_plot(
#   df = npx_data2_clean,
#   byPanel = TRUE,
#   check_log = check_log_npx_data2_clean
# )

## ----PCA_Panel_fig, echo = FALSE----------------------------------------------
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/PCA_Panel.png"
  ),
  error = FALSE
)

## ----PCA_object, eval = FALSE-------------------------------------------------
# # Save the PCA plot to a variable
# # By panel
# # quiet argument suppresses export
# pca_plots <- OlinkAnalyze::olink_pca_plot(
#   df =  npx_data2_clean,
#   byPanel = TRUE,
#   quiet = TRUE,
#   check_log = check_log_npx_data2_clean
# )
# 
# pca_plots[[1L]] # Cardiometabolic PCA
# pca_plots[[2L]] # Inflammation PCA

## ----Outlier_PCA, echo = FALSE------------------------------------------------
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/Outlier_PCA.png"
  ),
  error = FALSE
)

## ----eval = FALSE-------------------------------------------------------------
# OlinkAnalyze::olink_pca_plot(
#   df = outlier_data,
#   label_samples = TRUE,
#   check_log = check_log_npx_data1_clean
# )

## ----Label_samples, echo = FALSE----------------------------------------------
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/label_samples_pca.png"
  ),
  error = FALSE
)

## ----eval = FALSE-------------------------------------------------------------
# if (requireNamespace(package = "ggrepel", quietly = TRUE)) {
#   OlinkAnalyze::olink_pca_plot(
#     df = outlier_data,
#     outlierDefX = 3L,
#     outlierDefY = 3L,
#     outlierLines = TRUE,
#     label_outliers = TRUE,
#     check_log = check_log_npx_data1_clean
#   )
# }

## ----outlier_line_pca, echo = FALSE-------------------------------------------
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/outlier_line_pca.png"
  ),
  error = FALSE
)

## ----eval = FALSE-------------------------------------------------------------
# if (requireNamespace(package = "ggrepel", quietly = TRUE)) {
#   OlinkAnalyze::olink_pca_plot(
#     df = outlier_data,
#     outlierDefX = 3L,
#     outlierDefY = 3L,
#     outlierLines = FALSE,
#     label_outliers = TRUE,
#     check_log = check_log_npx_data1_clean
#   )
# }

## -----------------------------------------------------------------------------
if (requireNamespace(package = "ggrepel", quietly = TRUE)) {
  outliers_pca_labeled <-
    OlinkAnalyze::olink_pca_plot(
      df = outlier_data,
      outlierDefX = 3L,
      outlierDefY = 3L,
      outlierLines = FALSE,
      label_outliers = TRUE,
      quiet = TRUE,
      check_log = check_log_npx_data1_clean
    )

  outliers_pca_labeled[[1L]]$data |>
    dplyr::filter(
      .data[["Outlier"]] == TRUE
    ) |>
    dplyr::select(
      dplyr::all_of("SampleID")
    ) |>
    dplyr::distinct()
}

## ----eval = FALSE-------------------------------------------------------------
# outlier_data_dist <- outlier_data |>
#   dplyr::filter(
#     .data[["SampleID"]] %in% c("A25", "A52", "A1", "A2", "A3", "A5",
#                                "A15", "A16", "A18", "A19", "A20")
#   )
# 
# OlinkAnalyze::olink_dist_plot(
#   df = outlier_data_dist,
#   check_log = check_log_npx_data1_clean
# )

## ----echo = FALSE-------------------------------------------------------------
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/dist_boxplot.png"
  ),
  error = FALSE
)

## ----eval = FALSE-------------------------------------------------------------
# group_data_dist <- group_data |>
#   # Only visualizing 2 sites to see all samples
#   dplyr::filter(
#     .data[["Site"]] %in% c("Site_A", "Site_D")
#   )
# 
# OlinkAnalyze::olink_dist_plot(
#   df = group_data_dist,
#   color_g = "Site",
#   check_log = check_log_npx_data1_clean
# )

## ----echo = FALSE-------------------------------------------------------------
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/site_boxplot.png"
  ),
  error = FALSE
)

## ----eval = FALSE-------------------------------------------------------------
# # Calculate SampleID Median NPX
# median_npx <- group_data |>
#   dplyr::group_by(
#     .data[["SampleID"]]
#   ) |>
#   dplyr::summarise(
#     Median_NPX = median(.data[["NPX"]])
#   ) |>
#   dplyr::ungroup()
# 
# # Adjust by sample median
# adjusted_data <- group_data |>
#   dplyr::inner_join(
#     median_npx,
#     by = "SampleID"
#   ) |>
#   dplyr::mutate(
#     NPX = .data[["NPX"]] - .data[["Median_NPX"]]
#   )
# 
# adjusted_data_dist <- adjusted_data |>
#   # Only visualizing 2 sites to see all samples
#   dplyr::filter(
#     .data[["Site"]] %in% c("Site_A", "Site_D")
#   )
# 
# OlinkAnalyze::olink_dist_plot(
#   df = adjusted_data_dist,
#   color_g = "Site",
#   check_log = check_log_npx_data1_clean
# )

## ----echo=FALSE---------------------------------------------------------------
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/sample_med_boxplot.png"
  ),
  error = FALSE
)

## ----eval = FALSE-------------------------------------------------------------
# if (requireNamespace(package = "ggrepel", quietly = TRUE)) {
#   OlinkAnalyze::olink_qc_plot(
#     df = outlier_data,
#     label_outliers = TRUE,
#     check_log = check_log_npx_data1_clean
#   )
# }

## ----echo=FALSE---------------------------------------------------------------
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/qc_plot.png"
  ),
  error = FALSE
)

## ----eval = FALSE-------------------------------------------------------------
# if (requireNamespace(package = "ggrepel", quietly = TRUE)) {
#   OlinkAnalyze::olink_qc_plot(
#     df = group_data,
#     color_g = "Site",
#     label_outliers = TRUE,
#     check_log = check_log_npx_data1_clean
#   )
# }

## ----echo = FALSE-------------------------------------------------------------
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/qc_site_plot.png"
  ),
  error = FALSE
)

## ----eval = FALSE-------------------------------------------------------------
# if (requireNamespace(package = "ggrepel", quietly = TRUE)) {
#   OlinkAnalyze::olink_qc_plot(
#     df = outlier_data,
#     median_outlierDef = 2L,
#     IQR_outlierDef = 4L,
#     outlierLines = TRUE,
#     label_outliers = TRUE,
#     check_log = check_log_npx_data1_clean
#   )
# }

## ----echo = FALSE-------------------------------------------------------------
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/qc_label_plot.png"
  ),
  error = FALSE
)

## ----eval = FALSE-------------------------------------------------------------
# if (requireNamespace(package = "ggrepel", quietly = TRUE)) {
#   OlinkAnalyze::olink_qc_plot(
#     df = outlier_data,
#     median_outlierDef = 2L,
#     IQR_outlierDef = 4L,
#     outlierLines = FALSE,
#     label_outliers = TRUE,
#     check_log = check_log_npx_data1_clean
#   )
# }

## -----------------------------------------------------------------------------
if (requireNamespace(package = "ggrepel", quietly = TRUE)) {
  outliers_qc_labeled <- OlinkAnalyze::olink_qc_plot(
    df = outlier_data,
    median_outlierDef = 2L,
    IQR_outlierDef = 4,
    outlierLines = FALSE,
    label_outliers = TRUE,
    check_log = check_log_npx_data1_clean
  )

  outliers_qc_labeled$data |>
    dplyr::filter(
      .data[["Outlier"]] == TRUE
    ) |>
    dplyr::select(
      dplyr::all_of("SampleID")
    ) |>
    dplyr::distinct()
}

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(warning = FALSE,
                      fig.height = 6,
                      fig.width = 6,
                      message = FALSE)

## ----manifest, echo = FALSE, message = FALSE----------------------------------
OlinkAnalyze::manifest |>
  dplyr::slice_head(
    n = 10L
  ) |>
  knitr::kable(
    format = "html",
    booktabs = TRUE,
    linesep = "",
    digits = 4L,
    longtable = TRUE,
    row.names = FALSE,
    caption = "Table 1. Example of Sample manifest",
    label = "manifest"
  )

## ----complete_randomization, message = FALSE, warning = FALSE, results = 'hide'----
randomized_manifest <- OlinkAnalyze::olink_plate_randomizer(
  Manifest = OlinkAnalyze::manifest,
  seed = 123456
)

## ----randomize_subject, message = FALSE, eval = TRUE, echo = TRUE-------------
# Example longitudinal randomization with subjects kept on the same plate.
randomized_manifest_subject <- OlinkAnalyze::olink_plate_randomizer(
  Manifest = OlinkAnalyze::manifest,
  Product = "Explore HT",
  SubjectColumn = "SubjectID",
  num_ctrl = 10L
)

## ----randomize_controls, message = FALSE, eval = FALSE, echo = TRUE-----------
# # Randomize Olink external control samples.
# randomized_manifest_random <- OlinkAnalyze::olink_plate_randomizer(
#   Manifest = OlinkAnalyze::manifest,
#   Product = "Explore HT",
#   SubjectColumn = "SubjectID",
#   num_ctrl = 10L,
#   rand_ctrl = TRUE
# )

## ----randomized_controls_table, echo = FALSE, message = FALSE, warning = FALSE----
randomized_manifest_subject |>
  dplyr::slice_head(
    n = 10L
  ) |>
  knitr::kable(
    format = "html",
    booktabs = TRUE,
    linesep = "",
    digits = 4L,
    longtable = TRUE,
    row.names = FALSE,
    caption = paste0(
      "Table 2. Example of Randomized Sample manifest ",
      "with subjects kept on the same plate."
    ),
    label = "manifest"
  )

## ----subjects_randomization, message = FALSE, results = 'hide'----------------
randomized_manifest_num <- OlinkAnalyze::olink_plate_randomizer(
  Manifest = OlinkAnalyze::manifest,
  SubjectColumn = "SubjectID",
  available.spots = c(48L, 48L, 42L),
  iterations = 500L,
  seed = 123456
)

## -----------------------------------------------------------------------------
randomized_manifest_multi <- OlinkAnalyze::olink_plate_randomizer(
  Manifest = OlinkAnalyze::manifest,
  study = "Site"
)

## ----figure_captions, message = FALSE, echo = FALSE---------------------------
fcap1 <- paste0(
  "Figure 1. Randomized samples in 96 well plate format, ",
  "colored by Subject ID."
)
fcap2 <- paste0(
  "Figure 2. Randomized samples in 96 well plate format ",
  "with labeled wells."
)
fcap3 <- paste0(
  "Figure 3. Randomized samples in a 96-well plate format, ",
  "with the number of samples per plate pre-defined."
)
fcap4 <- paste0(
  "Figure 4. Randomized samples in 96 well plate format, ",
  "colored by Studies."
)
fcap5 <- "Figure 5. Distribution of Subject ID across randomized plates."
fcap6 <- "Figure 6. Distribution of Site across randomized plates."

## ----fig.height = 6, fig.width = 7.5, fig.align = "center", fig.cap = fcap1----
OlinkAnalyze::olink_displayPlateLayout(
  data = randomized_manifest,
  fill.color = "SubjectID",
  include.label = FALSE
)

## ----fig.height = 6, fig.width = 7.5, fig.align = "center", fig.cap = fcap2----
OlinkAnalyze::olink_displayPlateLayout(
  data = randomized_manifest,
  fill.color = "SubjectID",
  include.label = TRUE
)

## ----fig.height = 6, fig.width = 7.5, fig.align = "center", fig.cap = fcap3----
OlinkAnalyze::olink_displayPlateLayout(
  data = randomized_manifest_num,
  fill.color = "SubjectID",
  include.label = FALSE
)

## ----fig.height = 6, fig.width = 7.5, fig.align = "center", fig.cap = fcap4----
OlinkAnalyze::olink_displayPlateLayout(
  data = randomized_manifest_multi,
  fill.color = "Site"
)

## ----fig.align = "center", fig.cap = fcap5------------------------------------
OlinkAnalyze::olink_displayPlateDistributions(
  data = randomized_manifest,
  fill.color = "SubjectID"
)

## ----fig.align = "center", fig.cap= fcap6-------------------------------------
OlinkAnalyze::olink_displayPlateDistributions(
  data = randomized_manifest,
  fill.color = "Site"
)

## ----eval = FALSE-------------------------------------------------------------
# writexl::write_xlsx(
#   x = randomized_manifest,
#   path = "randomized.manifest.xlsx"
# )

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  tidy = FALSE,
  tidy.opts = list(width.cutoff = 95),
  fig.width = 6,
  fig.height = 3,
  message = FALSE,
  warning = FALSE,
  time_it = TRUE,
  fig.align = "center"
)

## ----brnrtab, eval = TRUE, message = FALSE, echo = FALSE----------------------
dplyr::tibble(
  "Olink Product" = c(
    "'Olink Explore 3072' to 'Olink Explore HT'",
    "'Olink Explore 3072' to 'Olink Reveal'",
    "'Olink Explore HT' to 'Olink Reveal'",
    "'Olink Reveal' to 'Olink Explore HT'"
  ),
  "Number of Bridge Samples" = c(
    "40-64",
    "32-48",
    "24-40",
    "24-40"
  )
) |>
  kableExtra::kbl(
    booktabs = TRUE,
    digits = 2L,
    caption = paste("Recommended number of bridge samples for normalizing",
                    "between Olink products.")
  ) |>
  kableExtra::kable_styling(
    bootstrap_options = "striped",
    full_width = FALSE,
    position = "center",
    latex_options = "HOLD_position"
  )

## ----fig.cap = fcap, eval = TRUE, echo = FALSE, out.width = "50%"-------------
knitr::include_graphics(
  normalizePath(
    path = "../man/figures/Bridging_schematic.png"
  ),
  error = FALSE
)

fcap <- "Schematic of Between-Product Bridging Workflow"

## ----message = FALSE, eval = FALSE, echo = TRUE-------------------------------
# ### Use provided example dataset
# 
# # Explore 3072: CSV or parquet file
# data_e3072 <- OlinkAnalyze::read_NPX(
#   filename = "~/NPX_Explore3072_location.parquet"
#   )
# 
# # Explore HT: parquet file
# data_eht <- OlinkAnalyze::read_NPX(
#   filename = "~/NPX_ExploreHT_location.parquet"
# )
# 
# # Reveal: CSV or parquet file
# data_reveal <- OlinkAnalyze::read_NPX(
#   filename = "~/NPX_Reveal_location.parquet"
# )

## ----message = FALSE, eval = FALSE, echo = TRUE-------------------------------
# ### NPX file preprocessing
# 
# # Generate check log
# check_log_data_e3072 <- OlinkAnalyze::check_npx(
#   df = data_e3072
# )
# check_log_data_eht <- OlinkAnalyze::check_npx(
#   df = data_eht
# )
# check_log_data_reveal <- OlinkAnalyze::check_npx(
#   df = data_reveal
# )
# 
# # Clean NPX data
# data_e3072_clean <- OlinkAnalyze::clean_npx(
#   df = data_e3072,
#   check_log = check_log_data_e3072,
#   # keep internal and external controls
#   remove_control_sample = FALSE,
#   remove_control_assay = FALSE,
#   # keep datapoints with samples and assays warnings
#   remove_qc_warning = FALSE,
#   remove_assay_warning = FALSE
# )
# data_eht_clean <- OlinkAnalyze::clean_npx(
#   df = data_eht,
#   check_log = check_log_data_eht,
#   # keep internal and external controls
#   remove_control_sample = FALSE,
#   remove_control_assay = FALSE,
#   # keep datapoints with samples and assays warnings
#   remove_qc_warning = FALSE,
#   remove_assay_warning = FALSE
# )
# data_reveal_clean <- OlinkAnalyze::clean_npx(
#   df = data_reveal,
#   check_log = check_log_data_reveal,
#   # keep internal and external controls
#   remove_control_sample = FALSE,
#   remove_control_assay = FALSE,
#   # keep datapoints with samples and assays warnings
#   remove_qc_warning = FALSE,
#   remove_assay_warning = FALSE
# )
# 
# # Generate check log on cleaned data
# check_log_data_e3072_clean <- OlinkAnalyze::check_npx(
#   df = data_e3072_clean
# )
# check_log_data_eht_clean <- OlinkAnalyze::check_npx(
#   df = data_eht_clean
# )
# check_log_data_reveal_clean <- OlinkAnalyze::check_npx(
#   df = data_reveal_clean
# )
# 
# # clean up environment
# rm(
#   data_e3072,
#   data_eht,
#   data_reveal,
#   check_log_data_e3072,
#   check_log_data_eht,
#   check_log_data_reveal
# )

## ----eval = FALSE, echo = TRUE------------------------------------------------
# # Note that if `SampleType` is not is input data:
# # stringr::str_detect can be used to exclude control samples based on SampleID.
# 
# data_e3072_samples <- data_e3072_clean |>
#   dplyr::filter(
#     .data[["SampleType"]] == "SAMPLE"
#   ) |>
#   dplyr::distinct(
#     .data[["SampleID"]]
#   ) |>
#   dplyr::pull()
# 
# data_eht_samples <- data_eht_clean |>
#   dplyr::filter(
#     .data[["SampleType"]] == "SAMPLE"
#   ) |>
#   dplyr::distinct(
#     .data[["SampleID"]]
#   ) |>
#   dplyr::pull()
# 
# overlapping_samples <- dplyr::intersect(
#   x = data_e3072_samples,
#   y = data_eht_samples
# ) |>
#   unique()

## ----echo=FALSE---------------------------------------------------------------
try(
  readRDS(
    file = normalizePath(
      path = "../man/figures/overlapping_samples_table.rds"
    )
  ) |>
    kableExtra::kbl(
      booktabs = TRUE,
      digits = 2L,
      caption = "List of overlapping samples between the two projects."
    ) |>
    kableExtra::kable_styling(
      bootstrap_options = "striped",
      full_width = FALSE,
      position = "center",
      latex_options = "HOLD_position"
    )
)

## ----include = FALSE----------------------------------------------------------
f3 <- paste0(
  "PCA plot prior to bridging for Explore 3072 data and data from the",
  " reference product. Bridge samples are indicated by color. PCA plots can be",
  " helpful in assessing if any bridge samples were outliers in one of the",
  " platforms."
)

## ----eval = FALSE-------------------------------------------------------------
# #### Extract bridging samples
# 
# data_e3072_before_br <- data_e3072_clean |>
#   dplyr::filter(
#     .data[["SampleType"]] == "SAMPLE"
#   ) |>
#   # Note that if column `SampleType` is not in input data, the function
#   # stringr::str_detect can be used to exclude control samples based on naming
#   # convention.
#   dplyr::mutate(
#     Type = dplyr::if_else(
#       .data[["SampleID"]] %in% .env[["overlapping_samples"]],
#       paste0("Explore 3072 Bridge"),
#       paste0("Explore 3072 Sample")
#     )
#   )
# 
# data_eht_before_br <- data_eht_clean |>
#   dplyr::filter(
#     .data[["SampleType"]] == "SAMPLE"
#   ) |>
#   # Note that if column `SampleType` is not in input data, the function
#   # stringr::str_detect can be used to exclude control samples based on naming
#   # convention.
#   dplyr::mutate(
#     Type = dplyr::if_else(
#       .data[["SampleID"]] %in% .env[["overlapping_samples"]],
#       paste0("Explore HT Bridge"),
#       paste0("Explore HT Sample")
#     )
#   )
# 
# ### PCA plot
# pca_e3072 <- OlinkAnalyze::olink_pca_plot(
#   df = data_e3072_before_br,
#   check_log = check_log_data_e3072_clean,
#   color_g = "Type",
#   quiet = TRUE
# )
# pca_eht <- OlinkAnalyze::olink_pca_plot(
#   df = data_eht_before_br,
#   check_log = check_log_data_eht_clean,
#   color_g = "Type",
#   quiet = TRUE
# )

## ----echo = FALSE, fig.cap = f3, fig.height = 8, fig.width = 6----------------
knitr::include_graphics(
  normalizePath(
    path = "../man/figures/PCA_btw_product_before.png"
  ),
  error = FALSE
)

## ----eval = FALSE, echo = TRUE------------------------------------------------
# ### Perform bridge normalization
# 
# # Note:
# # Project name is assigned by `df1_project_nr` and `df2_project_nr` parameters
# # in `olink_normalization` function
# 
# # Perform between-product bridging without formatting for downstream analysis
# npx_br_data <- OlinkAnalyze::olink_normalization(
#   df1 = data_eht_clean,
#   df2 = data_e3072_clean,
#   overlapping_samples_df1 = overlapping_samples,
#   df1_project_nr = "Explore HT",
#   df2_project_nr = "Explore 3072",
#   reference_project = "Explore HT",
#   format = FALSE,
#   df1_check_log = check_log_data_eht_clean,
#   df2_check_log = check_log_data_e3072_clean
# )
# 
# # Perform between-product bridging with formatting for downstream analysis
# npx_br_data <- OlinkAnalyze::olink_normalization(
#   df1 = data_eht_clean,
#   df2 = data_e3072_clean,
#   overlapping_samples_df1 = overlapping_samples,
#   df1_project_nr = "Explore HT",
#   df2_project_nr = "Explore 3072",
#   reference_project = "Explore HT",
#   format = TRUE,
#   df1_check_log = check_log_data_eht_clean,
#   df2_check_log = check_log_data_e3072_clean
# )

## ----message = FALSE, eval = FALSE, echo = TRUE-------------------------------
# # Generate check log
# check_log_br_data <- OlinkAnalyze::check_npx(
#   df = npx_br_data
# )
# 
# # Clean NPX data
# npx_br_data_clean <- OlinkAnalyze::clean_npx(
#   df = npx_br_data,
#   check_log = check_log_br_data,
#   # keep only control samples as we will need them for downstream QC
#   remove_control_sample = FALSE
# )
# 
# # Generate check log on cleaned data
# check_log_br_data_clean <- OlinkAnalyze::check_npx(
#   df = npx_br_data_clean
# )
# 
# # clean up environment
# rm(
#   npx_br_data,
#   check_log_br_data
# )

## ----echo = FALSE, fig.cap = fcap, out.width = "50%"--------------------------
knitr::include_graphics(
  normalizePath(
    path = "../man/figures/assay_bridgeability.jpg"
  ),
  error = FALSE
)
fcap <- paste(
  "Criteria to determine the bridging recommendation for an assay. The",
  "assessment of linearity ensures bridging between signal in both platforms",
  "or noise in both platforms (but not between signal and noise). Similar NPX",
  "ranges and sufficient counts provide additional insight into an assay's",
  "bridgeability. Distribution shape is assessed to determine recommended",
  "bridging method."
)

## ----eval = FALSE, echo = TRUE------------------------------------------------
# ### Generate olink_bridgeability_plot figures
# 
# npx_br_data_bridgeable_plt <- npx_br_data_clean |>
#   dplyr::filter(
#     .data[["SampleType"]] == "SAMPLE"
#   ) |>
#   OlinkAnalyze::olink_bridgeability_plot(
#     check_log = check_log_br_data_clean,
#     # Important to note that setting `olink_id` to NULL will generate plots for
#     # all assays. This can be computationally intensive if there are many
#     # assays!
#     # To generate plots for a subset of assays, set `olink_id` to a vector of
#     # Olink IDs of interest.
#     olink_id = NULL,
#     median_counts_threshold = 150L,
#     min_count = 10L
#   )
# 
# npx_br_data_bridgeable_plt[[1L]]

## ----message = FALSE, echo = FALSE, out.width = "675px", fig.cap = fcap-------
knitr::include_graphics(
  normalizePath(path = "../man/figures/bridgeable_plt_MedianCenter.png"),
  error = FALSE
)

fcap <- paste("Visualization of an assay's bridgeability criteria as generated",
              "by the `olink_bridgeability_plot()` function.")

## ----eval = TRUE, echo = FALSE------------------------------------------------
try(
  readRDS(
    file = normalizePath("../man/figures/bridging_results.rds")
  ) |>
    kableExtra::kbl(
      booktabs = TRUE,
      digits = 1,
      caption = paste("Table 4. First 5 rows of combined datasets after",
                      "bridging with between-product formatting argument set",
                      "to FALSE.")
    ) |>
    kableExtra::kable_styling(
      bootstrap_options = "striped",
      full_width = FALSE,
      font_size = 10,
      position = "center",
      latex_options = "HOLD_position"
    ) |>
    kableExtra::scroll_box(
      width = "100%"
    )
)

## ----eval = TRUE, echo = FALSE------------------------------------------------
try(
  readRDS(
    normalizePath(path = "../man/figures/bridging_results.rds")
  ) |>
    dplyr::mutate(
      NPX = dplyr::case_when(
        .data[["BridgingRecommendation"]] == "MedianCentering" ~
          .data[["MedianCenteredNPX"]],
        .data[["BridgingRecommendation"]] == "QuantileSmoothing" ~
          .data[["QSNormalizedNPX"]],
        .default = .data[["NPX"]]
      )
    ) |>
    dplyr::mutate(
      SampleID = paste(.data[["SampleID"]], .data[["Project"]], sep = "_")
    ) |>
    dplyr::mutate(
      OlinkID = dplyr::if_else(
        .data[["BridgingRecommendation"]] != "NotBridgeable",
        paste(.data[["OlinkID"]], .data[["OlinkID_E3072"]], sep = "_"),
        .data[["OlinkID_E3072"]]
      )
    ) |>
    dplyr::select(
      -dplyr::all_of(
        c("OlinkID_E3072", "MedianCenteredNPX", "QSNormalizedNPX")
      )
    ) |>
    kableExtra::kbl(
      booktabs = TRUE,
      digits = 1L,
      caption = paste("Table 5. First 5 rows of combined datasets after",
                      "bridging with between-product formatting argument set",
                      "to TRUE.")
    ) |>
    kableExtra::kable_styling(
      bootstrap_options = "striped",
      full_width = FALSE,
      font_size = 10,
      position = "center",
      latex_options = "HOLD_position"
    ) |>
    kableExtra::scroll_box(
      width = "100%"
    )
)

## ----include = FALSE----------------------------------------------------------
f8 <- paste("Combined PCA of sample controls from both platforms prior to",
            "normalization.")
f9 <- paste("Combined PCA of bridging samples from both platforms prior to",
            "normalization.")
f10 <- paste("Combined PCA of sample controls from both platforms after",
             "normalization.")
f11 <- paste("Combined PCA of bridging samples from both platforms after",
             "normalization.")

## ----eval = FALSE, echo = TRUE------------------------------------------------
# # Prepare data for PCA plots - pre-bridging
# 
# npx_pre_data <- data_eht_clean |>
#   dplyr::mutate(
#     Project = "Explore HT"
#   ) |>
#   dplyr::bind_rows(
#     data_e3072_clean |>
#       dplyr::mutate(
#         Project = "Explore 3072"
#       )
#   )
# 
# check_log_pre_data <- OlinkAnalyze::check_npx(
#   df = npx_pre_data
# )
# 
# # no need to clean data set `npx_pre_data`
# # ```

## ----pca_pre_sc, eval = FALSE, echo = TRUE------------------------------------
# # Generate pre-bridging PCA using Sample Control samples
# 
# npx_pre_data |>
#   dplyr::filter(.data[["SampleType"]] == "SAMPLE_CONTROL") |>
#   dplyr::mutate(
#     SampleID = paste(.data[["Project"]], .data[["SampleID"]], sep = "_")
#   ) |>
#   OlinkAnalyze::olink_pca_plot(
#     check_log = check_log_pre_data,
#     color_g = "Project",
#   )

## ----pca_pre_sc_fig, eval = TRUE, echo = FALSE, fig.cap = f8, message = FALSE----
# Generate pre-bridging PCA using Sample Control samples
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/SCs_pre_bridging.png"
  ),
  error = FALSE
)

## ----pca_pre_bridge, eval = FALSE, echo = TRUE--------------------------------
# # Generate pre-bridging PCA using bridging sample
# 
# npx_pre_data |>
#   dplyr::filter(
#     .data[["SampleType"]] == "SAMPLE"
#   ) |>
#   dplyr::filter(
#     .data[["SampleID"]] %in% .env[["overlapping_samples"]]
#   ) |>
#   dplyr::mutate(
#     SampleID = paste(.data[["Project"]], .data[["SampleID"]], sep = "_")
#   ) |>
#   OlinkAnalyze::olink_pca_plot(
#     check_log = check_log_pre_data,
#     color_g = "Project"
#   )

## ----eval = TRUE, echo = FALSE, fig.cap = f9----------------------------------
# Generate pre-bridging PCA using bridging sample

knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/bridges_pre_bridging.png"
  ),
  error = FALSE
)

## ----eval = FALSE, echo = TRUE------------------------------------------------
# ### Format post-bridging data
# 
# ## Keep the data following BridgingRecommendation
# npx_post_br_reco <- npx_br_data_clean |>
#   # Not necessary if olink_normalization() is run with format = TRUE
#   dplyr::filter(
#     .data[["BridgingRecommendation"]] != "NotBridgeable"
#   ) |>
#   dplyr::mutate(
#     NPX = dplyr::case_when(
#       .data[["BridgingRecommendation"]] == "MedianCentering" ~
#         .data[["MedianCenteredNPX"]],
#       .data[["BridgingRecommendation"]] == "QuantileSmoothing" ~
#         .data[["QSNormalizedNPX"]],
#       .default = .data[["NPX"]]
#     )
#   )

## ----pca_post_SC, eval = FALSE, echo = TRUE-----------------------------------
# # Generate PCA plot of post-bridging data from Sample Controls
# 
# npx_post_br_reco |>
#   dplyr::filter(
#     .data[["SampleType"]] == "SAMPLE_CONTROL"
#   ) |>
#   dplyr::mutate(
#     SampleID = paste(.data[["Project"]], .data[["SampleID"]], sep = "_")
#   ) |>
#   OlinkAnalyze::olink_pca_plot(
#     color_g = "Project",
#     check_log = check_log_br_data_clean
#   )

## ----eval = TRUE, echo = FALSE, fig.cap = f10---------------------------------
# Generate PCA plot of post-bridging data from Sample Controls

knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/SCs_post_bridging.png"
  ),
  error = FALSE
)

## ----eval = FALSE, echo = TRUE------------------------------------------------
# # Generate PCA plot of post-bridging data from bridging samples
# 
# npx_post_br_reco |>
#   dplyr::filter(
#     .data[["SampleType"]] == "SAMPLE"
#   ) |>
#   dplyr::filter(
#     .data[["SampleID"]] %in% .env[["overlapping_samples"]]
#   ) |>
#   dplyr::mutate(
#     SampleID = paste0(.data[["Project"]], .data[["SampleID"]])
#   ) |>
#   OlinkAnalyze::olink_pca_plot(
#     color_g = "Project",
#     check_log = check_log_br_data_clean
#   )

## ----echo = FALSE, fig.cap = f11----------------------------------------------
# Generate PCA plot of post-bridging data from bridging samples

knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/bridges_post_bridging.png"
  ),
  error = FALSE
)

## ----eval = FALSE, echo = TRUE------------------------------------------------
# ### Export normalized data
# 
# # Here we will export the full dataset including internal and external controls
# # to follow Olink Software Export File formatting, but the data can be filtered
# # to include only samples and assays of interest prior to export.
# df <- npx_br_data |>
#   dplyr::filter(
#     .data[["Project"]] == "Explore_3072"
#   ) |>
#   arrow::as_arrow_table()
# 
# df$metadata$FileVersion <- "NA"
# df$metadata$ExploreVersion <- "NA"
# df$metadata$ProjectName <- "NA"
# df$metadata$SampleMatrix <- "NA"
# df$metadata$DataFileType <- "R Package Export File"
# df$metadata$ProductType <- "Explore3072"
# df$metadata$Product <- "Explore3072"
# 
# arrow::write_parquet(
#   x = df,
#   sink = "path_to_output.parquet"
# )

## ----eval = FALSE, echo = TRUE------------------------------------------------
# ### npx_post_br_clean generated by olink_normalization with format = TRUE
# 
# ## Option 1: Exclude non-bridgeable assays from both products
# npx_recommended <- npx_br_data_clean |>
#   dplyr::filter(
#     .data[["BridgingRecommendation"]] != "NotBridgeable"
#   )
# 
# ## Option 2: Analyze non-bridgeable assays separately
# # No further preprocessing needed
# npx_recommended <- npx_br_data_clean

## ----eval = FALSE, echo = TRUE------------------------------------------------
# ### npx_post_br_clean generated by olink_normalization with format = FALSE
# 
# ## Option 1: Exclude non-bridgeable assays from both products
# npx_recommended <- npx_br_data_clean |>
#   dplyr::mutate(
#     NPX_original = .data[["NPX"]]
#   ) |>
#   dplyr::filter(
#     .data[["BridgingRecommendation"]] != "Not Bridgeable"
#   ) |>
#   dplyr::mutate(NPX = dplyr::case_when(
#     .data[["BridgingRecommendation"]] == "MedianCentering" ~
#       .data[["MedianCenteredNPX"]],
#     .data[["BridgingRecommendation"]] == "QuantileSmoothing" ~
#       .data[["QSNormalizedNPX"]],
#     .default = .data[["NPX"]]
#   )
#   ) |>
#   dplyr::mutate(
#     OlinkID_HT = .data[["OlinkID"]]
#   ) |>
#   dplyr::mutate(
#     OlinkID = paste0(.data[["OlinkID"]], "_", .data[["OlinkID_E3072"]])
#   )
# 
# # Option 2: Analyze non bridgeable assays separately
# npx_recommended <- npx_br_data_clean |>
#   dplyr::mutate(
#     NPX_original = .data[["NPX"]]
#   ) |>
#   dplyr::mutate(
#     NPX = dplyr::case_when(
#       .data[["BridgingRecommendation"]] == "MedianCentering" ~
#         .data[["MedianCenteredNPX"]],
#       .data[["BridgingRecommendation"]] == "QuantileSmoothing" ~
#         .data[["QSNormalizedNPX"]],
#       .default = .data[["NPX"]]
#     )
#   ) |>
#   dplyr::mutate(
#     OlinkID_HT = .data[["OlinkID"]]
#   ) |>
#   dplyr::mutate(
#     OlinkID = dplyr::if_else(
#       .data[["BridgingRecommendation"]] != "NotBridgeable",
#       paste0(.data[["OlinkID"]], "_", .data[["OlinkID_E3072"]]),
#       # Concatenated OlinkID for bridgeable Assays
#       dplyr::if_else(.data[["Project"]] == "Explore HT",
#                      # replace with reference project name as set in function
#                      .data[["OlinkID"]],
#                      .data[["OlinkID_E3072"]]
#       )
#     )
#   )

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  tidy = FALSE,
  tidy.opts = list(width.cutoff = 95),
  fig.width = 6,
  fig.height = 3,
  message = FALSE,
  warning = FALSE,
  time_it = TRUE,
  fig.align = "center"
)

## ----brnrtab, message = FALSE, echo = FALSE-----------------------------------
dplyr::tibble(
  "Olink Product" = c(
    "Target 96",
    "Explore 384: Cardiometabolic, Inflammation, Neurology, and Oncology",
    paste(
      "Explore 384: Cardiometabolic II, Inflammation II, Neurology II,",
          "and Oncology II"
      ),
    "Explore 3072",
    "Explore HT",
    "Reveal",
    "Explore 3072 to Explore HT",
    "Explore 3072 to Reveal"
  ),
  "Number of Bridge Samples" = c(
    "8-16",
    "8-16",
    "16-24",
    "16-24",
    "16-32",
    "16-24",
    "40-64",
    "32-48"
  )
) |>
  kableExtra::kbl(
    booktabs = TRUE,
    digits = 2L,
    caption =
      paste(
        "Table 1. Recommended number of bridge samples for Olink products."
        )
  ) |>
  kableExtra::kable_styling(
    bootstrap_options = "striped",
    full_width = FALSE,
    position = "center",
    latex_options = "HOLD_position"
  )

## ----preprocessing, eval = TRUE-----------------------------------------------
# Load example dataset (npx_data1)
npx_data1 <- OlinkAnalyze::npx_data1

# NPX file preprocessing
# Generate check log
check_log_npx_data1 <- OlinkAnalyze::check_npx(
  df = npx_data1
)

# Clean NPX
npx_data1_clean <- OlinkAnalyze::clean_npx(
  df = npx_data1,
  check_log = check_log_npx_data1
)

# Generate check log on cleaned data
check_log_npx_data1_clean <- OlinkAnalyze::check_npx(
  df = npx_data1_clean
)

## ----bridge_sample_selection_example, echo = TRUE, eval = TRUE----------------
# Using the already cleaned data from `clean_npx()`
bridge_samples <- OlinkAnalyze::olink_bridge_selector(
  df = npx_data1_clean,
  sample_missing_freq = 0.1,
  n = 16L,
  check_log = check_log_npx_data1_clean
)

# Excluding control samples manually. Naming convention may differ.
bridge_samples_manual <- npx_data1 |>
  dplyr::filter(
    stringr::str_detect(
      string = .data[["SampleID"]],
      pattern = "CONTROL",
      negate = TRUE
    )
  ) |>
  # In this case we skip the argument `check_log`. When `check_log` is not
  # provided, the function will run it internally to check for other
  # inconsistencies in the data such as duplicate sample IDs.
  OlinkAnalyze::olink_bridge_selector(
    sample_missing_freq = 0.1,
    n = 16L
  )

## ----bridge_sample_selection, echo = FALSE------------------------------------
bridge_samples |>
  kableExtra::kbl(
    booktabs = TRUE,
    digits = 2L,
    caption = "Table 2. Selected bridge samples."
  ) |>
  kableExtra::kable_styling(
    bootstrap_options = "striped",
    full_width = FALSE,
    position = "center",
    latex_options = "HOLD_position"
  )

## ----captions, echo = FALSE---------------------------------------------------
f1 <- paste("Figure 1. PCA plot of bridge samples and other samples in",
            "dataset `npx_data1` (control samples excluded).")

f2 <- paste("Figure 2. Density plot of NPX distribution in both datasets",
            "before bridging.")

f3 <- paste("Figure 3. PCA plot of both datasets before bridging.")

f4 <- paste("Figure 4. Density plot of NPX distribution in both datasets after",
            "bridging.")

f5 <- paste("Figure 5. Histogram of adjustment factors in normalized data from",
             "dataset `npx_data2`.")

f6 <- paste("Figure 6. Violin plot of CHL1 in both datasets prior to bridging.",
            "Bridge samples are indicated by black points.")

f7 <- paste("Figure 7. Density plot of inter-project CV before and after",
            "bridging.")

f8 <- paste("Figure 8. PCA plot of both datasets after bridging.")

## ----bridge_sample_selection_example_pca, echo = TRUE, eval = TRUE, fig.cap = f1----
npx_data1_clean |>
  dplyr::mutate(
    Bridge = dplyr::if_else(
      .data[["SampleID"]] %in% bridge_samples[["SampleID"]],
      "Bridge",
      "Sample"
    )
  ) |>
  OlinkAnalyze::olink_pca_plot(
    color_g = "Bridge",
    check_log = check_log_npx_data1_clean
  )

## ----message = FALSE, eval = FALSE, echo = TRUE-------------------------------
# npx_data1 <- OlinkAnalyze::read_NPX(
#   filename = "~/NPX_file1_location.xlsx"
# )
# npx_data2 <- OlinkAnalyze::read_NPX(
#   filename = "~/NPX_file2_location.xlsx"
# )

## ----data_uniq_sid, eval = TRUE, echo = TRUE----------------------------------
# Load example dataset (npx_data1)
npx_data1 <- npx_data1 |>
  # create unique extension as suffix for control samples
  dplyr::mutate(
    sid_ext = stringr::str_remove(
      string = .data[["PlateID"]],
      pattern = ".csv"
    ),
    sid_ext = paste0(
      stringr::str_split_i(.data[["sid_ext"]], "_", 4L),
      stringr::str_split_i(.data[["sid_ext"]], "_", 3L)
    ),
  ) |>
  # rename SampleIDs for control samples
  dplyr::mutate(
    SampleID = dplyr::if_else(
      stringr::str_detect(
        string = .data[["SampleID"]],
        pattern = "CONTROL"
      ),
      paste0(.data[["SampleID"]], "_", .data[["sid_ext"]]),
      .data[["SampleID"]]
    )
  ) |>
  dplyr::select(
    -dplyr::all_of("sid_ext")
  )

# Load example dataset (npx_data2)
npx_data2 <- OlinkAnalyze::npx_data2 |>
  # create unique extension as suffix for control samples
  dplyr::mutate(
    sid_ext = stringr::str_remove(
      string = .data[["PlateID"]],
      pattern = ".csv"
    ),
    sid_ext = paste0(
      stringr::str_split_i(.data[["sid_ext"]], "_", 5L),
      stringr::str_split_i(.data[["sid_ext"]], "_", 4L)
    ),
  ) |>
  # rename SampleIDs for control samples
  dplyr::mutate(
    SampleID = dplyr::if_else(
      stringr::str_detect(
        string = .data[["SampleID"]],
        pattern = "CONTROL"
      ),
      paste0(.data[["SampleID"]], "_", .data[["sid_ext"]]),
      .data[["SampleID"]]
    )
  ) |>
  dplyr::select(
    -dplyr::all_of("sid_ext")
  )

## ----preprocessing2, eval = TRUE----------------------------------------------
# NPX file preprocessing - npx_data1
# Generate check log
check_log_npx_data1 <- OlinkAnalyze::check_npx(
  df = npx_data1
)

# Clean NPX
npx_data1_clean <- OlinkAnalyze::clean_npx(
  df = npx_data1,
  # Retain control samples and assays
  remove_control_assay = FALSE,
  remove_control_sample = FALSE,
  # Retain assay and QC warnings
  remove_assay_warning = FALSE,
  remove_qc_warning = FALSE,
  check_log = check_log_npx_data1
)

# Generate check log on cleaned data
check_log_npx_data1_clean <- OlinkAnalyze::check_npx(
  df = npx_data1_clean
)

# cleanup intermediate variables
rm(
  npx_data1,
  check_log_npx_data1
)

# NPX file preprocessing - npx_data2
# Generate check log
check_log_npx_data2 <- OlinkAnalyze::check_npx(
  df = npx_data2
)

# Clean NPX
npx_data2_clean <- OlinkAnalyze::clean_npx(
  df = npx_data2,
  # Retain control samples and assays
  remove_control_assay = FALSE,
  remove_control_sample = FALSE,
  # Retain assay and QC warnings
  remove_assay_warning = FALSE,
  remove_qc_warning = FALSE,
  check_log = check_log_npx_data2
)

# Generate check log on cleaned data
check_log_npx_data2_clean <- OlinkAnalyze::check_npx(
  df = npx_data2_clean
)

# cleanup intermediate variables
rm(
  npx_data2,
  check_log_npx_data2
)

## ----eval = TRUE--------------------------------------------------------------
overlapping_samples <- dplyr::tibble(
  SampleID = intersect(
    x = npx_data1_clean[["SampleID"]],
    y = npx_data2_clean[["SampleID"]]
  )
) |>
  dplyr::filter(
    stringr::str_detect(
      string = .data[["SampleID"]],
      pattern = "CONTROL",
      negate = TRUE
    )
  ) |>
  dplyr::pull(
    .data[["SampleID"]]
  )

## ----echo = FALSE-------------------------------------------------------------
overlapping_samples |>
  kableExtra::kbl(
    col.names = "SampleID",
    booktabs = TRUE,
    digits = 2L,
    align = "c",
    caption = "Table 3. Overlapping Bridge Samples."
  ) |>
kableExtra::column_spec(
    1, width = "7cm"
  ) |>
  kableExtra::kable_styling(
    bootstrap_options = "striped",
    full_width = FALSE,
    position = "center",
    latex_options = "HOLD_position"
  )

## ----check, message = FALSE, fig.cap = f2-------------------------------------
# Expand the datasets to contain the Project column
npx_1 <- npx_data1_clean |>
  dplyr::mutate(
    Project = "data1"
  )
npx_2 <- npx_data2_clean |>
  dplyr::mutate(
    Project = "data2"
  )

# Combine the two data sets for visualization
npx_df <- dplyr::bind_rows(
  npx_1,
  npx_2
)

# Filter out control samples to avoid skewing the distribution
# and affecting downstream PCA results.
npx_df_no_ctrl <- npx_df |>
  dplyr::filter(
    stringr::str_detect(
      string = .data[["SampleID"]],
      pattern = "CONTROL_SAMPLE",
      negate = TRUE
    )
  ) |>
  # Mark bridge samples
  dplyr::mutate(
    Type = dplyr::if_else(
      .data[["SampleID"]] %in% .env[["overlapping_samples"]],
      paste(Project, "Bridge"),
      paste(Project, "Sample")
      )
    ) |>
  # Ensure that SampleIDs are unique across projects for downstream functions.
  dplyr::mutate(
    SampleID = paste0(.data[["SampleID"]],
                      .data[["Project"]])
  )

# Generate check log
check_log_npx_df_no_ctrl <- OlinkAnalyze::check_npx(
  df = npx_df_no_ctrl
  )

# Plot NPX density before bridging
npx_df_no_ctrl |>
  ggplot2::ggplot(
    mapping = ggplot2::aes(
      x = .data[["NPX"]],
      fill = .data[["Project"]]
    )
  ) +
  ggplot2::geom_density(
    alpha = 0.4
  ) +
  ggplot2::facet_grid(
    cols = ggplot2::vars(.data[["Panel"]])
  ) +
  OlinkAnalyze::olink_fill_discrete(
    coloroption = c("red", "darkblue")
  ) +
  OlinkAnalyze::set_plot_theme() +
  ggplot2::ggtitle(
    label = "Before bridging: NPX distribution"
  ) +
  ggplot2::theme(
    axis.title.x = ggplot2::element_blank(),
    axis.title.y = ggplot2::element_blank(),
    strip.text = ggplot2::element_text(size = 16L),
    legend.title = ggplot2::element_blank(),
    legend.position = "top"
  )

## ----pca1, message = FALSE, fig.cap = f3--------------------------------------
if (requireNamespace(package = "ggpubr", quietly = TRUE)) {
  # PCA plot
  OlinkAnalyze::olink_pca_plot(
    df = npx_df_no_ctrl,
    color_g = "Type",
    byPanel = TRUE,
    check_log = check_log_npx_df_no_ctrl
  )
}

## ----bridging, message = FALSE------------------------------------------------
overlapping_samples_list <- list(
  "DF1" = overlapping_samples,
  "DF2" = overlapping_samples
)

# Perform bridging
npx_df_br <- OlinkAnalyze::olink_normalization_bridge(
  project_1_df = npx_data1_clean,
  project_2_df = npx_data2_clean,
  bridge_samples = overlapping_samples_list,
  project_1_name = "data1",
  project_2_name = "data2",
  project_ref_name = "data1",
  project_1_check_log = check_log_npx_data1_clean,
  project_2_check_log = check_log_npx_data2_clean
)

# generate check log on bridged data
check_log_npx_df_br <- OlinkAnalyze::check_npx(
  df = npx_df_br
)

## ----norm_data_table, echo = FALSE--------------------------------------------
npx_df_br |>
  dplyr::slice_head(
    n = 10L
  ) |>
  kableExtra::kbl(
    booktabs = TRUE,
    digits = 1L,
    caption = "Table 4. First 10 rows of the normalized dataset after bridging."
  ) |>
  kableExtra::kable_styling(
    bootstrap_options = "striped",
    full_width = FALSE,
    font_size = 10L,
    position = "center",
    latex_options = "HOLD_position"
  ) |>
  kableExtra::scroll_box(
    width = "100%"
  )

## ----echo = TRUE, eval = FALSE------------------------------------------------
# overlapping_samples_list <- list(
#   "DF1" = c("A1", "A2", "A3", "Sample_1_Aliquot_1"),
#   "DF2" = c("A1", "A2", "A3", "Sample_1_Aliquot_2")
# )

## ----densitybr, message = FALSE, fig.cap = f4---------------------------------
# Filter out control samples to avoid skewing the distribution
# and affecting downstream PCA results.
npx_df_br_no_ctrl <- npx_df_br |>
  # Remove control samples
  dplyr::filter(
    stringr::str_detect(
      string = .data[["SampleID"]],
      pattern = "CONTROL_SAMPLE",
      negate = TRUE
    )
  ) |>
  # Mark bridge samples
  dplyr::mutate(
    Type = dplyr::if_else(
      .data[["SampleID"]] %in% .env[["overlapping_samples"]],
      paste(.data[["Project"]], "Bridge"),
      paste(.data[["Project"]], "Sample")
    )
  ) |>
  dplyr::mutate(
    SampleID = paste0(.data[["SampleID"]],
                      .data[["Project"]])
  )

# Generate check log
check_log_npx_df_br_no_ctrl <- OlinkAnalyze::check_npx(
  df = npx_df_br_no_ctrl
  )

# Plot NPX density after bridging
npx_df_br_no_ctrl |>
  dplyr::mutate(
    Panel = gsub(
      pattern = "Olink ",
      replacement = "", x = .data[["Panel"]]
    )
  ) |>
  ggplot2::ggplot(
    mapping = ggplot2::aes(
      x = .data[["NPX"]],
      fill = .data[["Project"]]
    )
  ) +
  ggplot2::geom_density(
    alpha = 0.4
  ) +
  ggplot2::facet_grid(
    cols = ggplot2::vars(.data[["Panel"]])
  ) +
  OlinkAnalyze::olink_fill_discrete(
    coloroption = c("red", "darkblue")
  ) +
  OlinkAnalyze::set_plot_theme() +
  ggplot2::ggtitle(
    label = "After bridging: NPX distribution"
  ) +
  ggplot2::theme(
    axis.title.x = ggplot2::element_blank(),
    axis.title.y = ggplot2::element_blank(),
    strip.text = ggplot2::element_text(size = 16L),
    legend.title = ggplot2::element_blank(),
    legend.position = "top"
  )

## ----dist_adj_fct, message = FALSE, echo = FALSE, fig.cap = f5----------------
npx_df_br |>
  # Only looking at Project 2 since project 1 is unadjusted
  dplyr::filter(
    .data[["Project"]] == "data2"
  ) |>
  dplyr::select(
    dplyr::all_of(
      c("OlinkID", "Adj_factor")
    )
  ) |>
  dplyr::distinct() |>
  ggplot2::ggplot(
    mapping = ggplot2::aes(
      x = .data[["Adj_factor"]]
    )
  ) +
  ggplot2::geom_histogram() +
  OlinkAnalyze::set_plot_theme()

## ----violin_plot, fig.cap = f6------------------------------------------------
# Bridge sample data
bridge_samples <- npx_df |>
  dplyr::filter(
    .data[["SampleID"]] %in% .env[["overlapping_samples"]]
  ) |>
  dplyr::filter(
    .data[["Assay"]] == "CHL1"
  ) |>
  dplyr::mutate(
    Assay_OID = paste(.data[["Assay"]], .data[["OlinkID"]], sep = "\n")
  )

# Generate violin plot for CHL1
npx_df_no_ctrl |>
  dplyr::filter(
    .data[["Assay"]] == "CHL1"
  ) |>
  dplyr::mutate(
    Assay_OID = paste(.data[["Assay"]], .data[["OlinkID"]], sep = "\n")
  ) |>
  ggplot2::ggplot(
    mapping = ggplot2::aes(
      x = .data[["Project"]],
      y = .data[["NPX"]]
    )
  ) +
  ggplot2::geom_violin(
    mapping = ggplot2::aes(
      fill = .data[["Project"]]
    )
  ) +
  ggplot2::geom_point(
    data = bridge_samples,
    position = ggplot2::position_jitter(
      width = 0.1
    )
  ) +
  ggplot2::theme(
    legend.position = "none"
  ) +
  OlinkAnalyze::set_plot_theme() +
  ggplot2::facet_wrap(
    facets = ggplot2::vars(.data[["Assay_OID"]]),
    nrow = 1L,
    ncol = 1L
  )

## ----CV_calculation, fig.cap = f7---------------------------------------------
# Olink NGS products CV calculation formula
ngs_cv <- function(npx, na_rm = FALSE) {
  sqrt(exp((log(2) * sd(npx, na.rm = na_rm)) ^ 2) - 1) * 100
}

# Olink qPCR products CV calculation formula
qpcr_cv <- function(npx, na_rm = TRUE) {
  100 * sd(2 ^ npx) / mean(2 ^ npx)
}

tech <- "qPCR"

# Calculate CV for control samples across projects before bridging
cv_before <- npx_df |>
  dplyr::filter(
    stringr::str_detect(
      string = .data[["SampleID"]],
      pattern = "CONTROL*."
    )
  ) |>
  dplyr::filter(
    .data[["NPX"]] > .data[["LOD"]]
  ) |>
  dplyr::group_by(
    .data[["OlinkID"]]
  ) |>
  dplyr::mutate(
    CV = dplyr::if_else(
      .env[["tech"]] == "NGS",
      ngs_cv(npx = .data[["NPX"]]),
      qpcr_cv(npx = .data[["NPX"]])
    )
  ) |>
  dplyr::ungroup() |>
  dplyr::distinct(
    .data[["OlinkID"]], .data[["CV"]]
  )

# Calculate CV for control samples across projects after bridging
cv_after <- npx_df_br |>
  dplyr::filter(
    stringr::str_detect(
      string = .data[["SampleID"]],
      pattern = "CONTROL*."
    )
  ) |>
  dplyr::filter(
    .data[["NPX"]] > .data[["LOD"]]
  ) |>
  dplyr::group_by(
    .data[["OlinkID"]]
  ) |>
  dplyr::mutate(
    CV = dplyr::if_else(
      .env[["tech"]] == "NGS",
      ngs_cv(npx = .data[["NPX"]]),
      qpcr_cv(npx = .data[["NPX"]])
    )
  ) |>
  dplyr::ungroup() |>
  dplyr::distinct(
    .data[["OlinkID"]], .data[["CV"]]
  )

# Plot distribution of CV before and after bridging
cv_before |>
  dplyr::mutate(
    Analysis = "Before"
  ) |>
  dplyr::bind_rows(
    cv_after |>
       dplyr::mutate(
         Analysis = "After"
        )
  ) |>
  ggplot2::ggplot(
    mapping = ggplot2::aes(
      x = .data[["CV"]],
      fill = .data[["Analysis"]]
      )
    ) +
  ggplot2::geom_density(
    alpha = 0.7
    ) +
  OlinkAnalyze::set_plot_theme() +
  OlinkAnalyze::olink_fill_discrete() +
  ggplot2::theme(
    text = ggplot2::element_text(
      size = 20L
      )
  ) +
  ggplot2::xlim(-50L, 400L)

## ----pca2, message = FALSE, fig.cap = f8--------------------------------------
if (requireNamespace(package = "ggpubr", quietly = TRUE)) {
  # PCA plot
  OlinkAnalyze::olink_pca_plot(
    df = npx_df_br_no_ctrl,
    color_g = "Type",
    byPanel = TRUE,
    check_log = check_log_npx_df_br_no_ctrl
  )
}

## ----eval = FALSE-------------------------------------------------------------
# npx_df_br |>
#   dplyr::filter(
#     .data[["Project"]] == "data2"
#   ) |>
#   dplyr::select(
#     -dplyr::all_of(
#       c("Project", "Adj_factor")
#     )
#   ) |>
#   write.table(
#     file = "New_Normalized_NPX_data.csv",
#     sep = ";"
#   )

---
title: "Plate Randomization Vignette"
author: "Olink DS team"
date: "`r Sys.Date()`"
output:
  html_vignette:
    toc: true
    toc_depth: 3
    includes:
      in_header: ../man/figures/logo.html

vignette: >
  %\VignetteIndexEntry{Plate Randomization Vignette}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(warning = FALSE,
                      fig.height = 6,
                      fig.width = 6,
                      message = FALSE)
```

## Introduction

This vignette describes how to use Olink® Analyze to randomize the samples with
an option to keep subjects on the same plate. When a study is well randomized
the experimental variables can be considered to be evenly distributed across
each plate, even for a larger study. What variables to randomize for should be
decided for each study as these vary with the study purpose. Correct sample
randomization will empower your study and minimize the risk of introducing any
bias that can confound downstream analyses. If at all possible, samples from the
same subject that are taken at various times during a longitudinal research
should all be placed on the same plate to further limit data fluctuation. In
order to evenly disperse the remaining experimental variables between plates,
the individuals should subsequently be distributed. If randomization is not
performed, true biological variation may be missed or misidentified as e.g.
technical variations. However, it would be challenging for us to control every
variable. Most of the time, a complete randomization will be carried out, and
the outcomes can be assessed by visualizing the layout of the plates. In this
vignette, you will learn how to achieve this using the
`olink_plate_randomizer()` function. And on top of that, you will also learn how
to use `olink_displayPlateLayout()` and `olink_displayPlateDistributions()` to
evaluate the performed randomization based on a given grouping variable.

## Sample randomization

The input manifest should be a tibble/data frame in long format containing all
sample ID's. Sample ID column must be named SampleID. An example manifest is
shown in Table 1.

```{r manifest, echo = FALSE, message = FALSE}
OlinkAnalyze::manifest |>
  dplyr::slice_head(
    n = 10L
  ) |>
  knitr::kable(
    format = "html",
    booktabs = TRUE,
    linesep = "",
    digits = 4L,
    longtable = TRUE,
    row.names = FALSE,
    caption = "Table 1. Example of Sample manifest",
    label = "manifest"
  )
```

### Complete randomization

The simplest way to randomize the samples is to perform complete randomization.

```{r complete_randomization, message = FALSE, warning = FALSE, results = 'hide'}
randomized_manifest <- OlinkAnalyze::olink_plate_randomizer(
  Manifest = OlinkAnalyze::manifest,
  seed = 123456
)
```

### Generate randomization scheme that keeps subjects on the same plate

In the case of multiple samples per subject (e.g. in longitudinal studies),
Olink recommends keeping each subject on the same plate to further reduce
variation in the data. The individuals should then be distributed so that the
remaining experimental variables of interest are evenly distributed across
plates. This could be achieved by using the `SubjectColumn` argument. The
`SubjectColumn` argument must correspond to a column within the manifest and
cannot be SampleID. If `SubjectColumn` is specified, every SampleID must have a
value in the subject column, even if there is only 1 sample for that subject.

However, if there are too many samples per subject (>8), complete randomization
is recommended. The plate size can be either directly set to 48 or 96 using the `PlateSize`
argument or can be inferred by setting the `Product` argument to "Target 96",
"Target 48", "Explore 384","Explore 3072", or "Explore HT." The number of Olink
external controls can be set using the `num_ctrl` argument, which defaults to 8
controls. The Olink external controls can also be set to be randomized
throughout the plate using the `rand_ctrl` argument.

```{r randomize_subject, message = FALSE, eval = TRUE, echo = TRUE}
# Example longitudinal randomization with subjects kept on the same plate.
randomized_manifest_subject <- OlinkAnalyze::olink_plate_randomizer(
  Manifest = OlinkAnalyze::manifest,
  Product = "Explore HT",
  SubjectColumn = "SubjectID",
  num_ctrl = 10L
)
```

```{r randomize_controls, message = FALSE, eval = FALSE, echo = TRUE}
# Randomize Olink external control samples.
randomized_manifest_random <- OlinkAnalyze::olink_plate_randomizer(
  Manifest = OlinkAnalyze::manifest,
  Product = "Explore HT",
  SubjectColumn = "SubjectID",
  num_ctrl = 10L,
  rand_ctrl = TRUE
)
```


```{r randomized_controls_table, echo = FALSE, message = FALSE, warning = FALSE}
randomized_manifest_subject |>
  dplyr::slice_head(
    n = 10L
  ) |>
  knitr::kable(
    format = "html",
    booktabs = TRUE,
    linesep = "",
    digits = 4L,
    longtable = TRUE,
    row.names = FALSE,
    caption = paste0(
      "Table 2. Example of Randomized Sample manifest ",
      "with subjects kept on the same plate."
    ),
    label = "manifest"
  )
```

The number of samples on each plate could be specified via the `available.spots`
argument. For example, the following code will lead to 48 samples on the first
and the second plate, and 42 samples on the third plate. The number of
iterations for fitting subjects on the same plate can be set by the `iterations`
argument. Increasing the number of iterations allows additional randomization
attempts to the algorithm to satisfy the constraints in the expense of increased
computation time. The randomization can be reproduced by setting the `seed`
argument to a specific number.

```{r subjects_randomization, message = FALSE, results = 'hide'}
randomized_manifest_num <- OlinkAnalyze::olink_plate_randomizer(
  Manifest = OlinkAnalyze::manifest,
  SubjectColumn = "SubjectID",
  available.spots = c(48L, 48L, 42L),
  iterations = 500L,
  seed = 123456
)
```

## Multi-study manifests

In the case of a manifest that includes multiple studies, the optional `study`
argument can be used to group samples by study and randomize the samples within
the study. In the example below, "Site" is used as a surrogate for study. After
randomization the sites are kept together across plates.

```{r}
randomized_manifest_multi <- OlinkAnalyze::olink_plate_randomizer(
  Manifest = OlinkAnalyze::manifest,
  study = "Site"
)
```

## Visualization

To illustrate the goodness of randomization, both `olink_displayPlateLayout()`
and `olink_displayPlateDistributions()` functions could be used.

### Plate layouts

The `olink_displayPlateLayout()` function could be used to visualize the layout
of the plate by specifying the color for the variable of interest using the
`fill.color` argument. The label of the colored variable could be shown in the plot
`fill.color` argument.

```{r figure_captions, message = FALSE, echo = FALSE}
fcap1 <- paste0(
  "Figure 1. Randomized samples in 96 well plate format, ",
  "colored by Subject ID."
)
fcap2 <- paste0(
  "Figure 2. Randomized samples in 96 well plate format ",
  "with labeled wells."
)
fcap3 <- paste0(
  "Figure 3. Randomized samples in a 96-well plate format, ",
  "with the number of samples per plate pre-defined."
)
fcap4 <- paste0(
  "Figure 4. Randomized samples in 96 well plate format, ",
  "colored by Studies."
)
fcap5 <- "Figure 5. Distribution of Subject ID across randomized plates."
fcap6 <- "Figure 6. Distribution of Site across randomized plates."
```

```{r, fig.height = 6, fig.width = 7.5, fig.align = "center", fig.cap = fcap1}
OlinkAnalyze::olink_displayPlateLayout(
  data = randomized_manifest,
  fill.color = "SubjectID",
  include.label = FALSE
)
```

The label of the colored variable could be shown in the plot via the
`include.label` argument.

```{r, fig.height = 6, fig.width = 7.5, fig.align = "center", fig.cap = fcap2}
OlinkAnalyze::olink_displayPlateLayout(
  data = randomized_manifest,
  fill.color = "SubjectID",
  include.label = TRUE
)
```

```{r, fig.height = 6, fig.width = 7.5, fig.align = "center", fig.cap = fcap3}
OlinkAnalyze::olink_displayPlateLayout(
  data = randomized_manifest_num,
  fill.color = "SubjectID",
  include.label = FALSE
)
```

```{r, fig.height = 6, fig.width = 7.5, fig.align = "center", fig.cap = fcap4}
OlinkAnalyze::olink_displayPlateLayout(
  data = randomized_manifest_multi,
  fill.color = "Site"
)
```

### Plate distribution

The distribution of the given grouping variable on each plate could be
visualized with a bar chart using function `olink_displayPlateDistributions()`. By
setting `fill.color = 'SubjectID'`, we could make sure all the samples from the
same subject were put on the same plate.

```{r, fig.align = "center", fig.cap = fcap5}
OlinkAnalyze::olink_displayPlateDistributions(
  data = randomized_manifest,
  fill.color = "SubjectID"
)
```

We could also check the distribution of other variables. For example, the
distribution of the variable `Site` could be visualized by setting
`fill.color = 'Site'`.

```{r, fig.align = "center", fig.cap= fcap6}
OlinkAnalyze::olink_displayPlateDistributions(
  data = randomized_manifest,
  fill.color = "Site"
)
```

If the randomization algorithm fails to converge or it is not performed well,
the randomization could be performed again with different settings for `seed`
and `iterations`.

## Data Output

The output of the randomization function would be a "tibble" including SampleID,
SubjectID etc. assigned to well positions. Columns include same columns as
SubjectID etc. assigned to well positions. Columns include the original Manifest
columns with following additional ones:

  - plate: Plate number

  - column: Column on the plate

  - row: Row on the plate

  - well: Well location on the plate

The randomized manifest could be outputted as an Excel file using the
The randomized manifest could be exported as an Excel spreadsheet using the
function `write_xlsx()` from the R package `writexl`.

```{r, eval = FALSE}
writexl::write_xlsx(
  x = randomized_manifest,
  path = "randomized.manifest.xlsx"
)
```

## Contact Us

We are always happy to help. Email us with any questions:

-   biostat\@olink.com for statistical services and general stats
    questions

-   support\@olink.com for Olink lab product and technical support

-   info\@olink.com for more information

## Legal Disclaimer

© `r format(Sys.Date(), "%Y")` Olink Proteomics AB, part of Thermo Fisher
Scientific.

Olink products and services are For Research Use Only. Not for use in diagnostic
procedures.

All information in this document is subject to change without notice. This
document is not intended to convey any warranties, representations and/or
recommendations of any kind, unless such warranties, representations and/or
recommendations are explicitly stated.

Olink assumes no liability arising from a prospective reader’s actions based on
this document.

OLINK, NPX, PEA, PROXIMITY EXTENSION, INSIGHT and the Olink logotype are
trademarks registered, or pending registration, by Olink Proteomics AB. All
third-party trademarks are the property of their respective owners.

Olink products and assay methods are covered by several patents and patent
applications [https://www.olink.com/patents/](https://olink.com/patents/).

---
title: "Introduction to bridging Olink® NPX datasets"
output: 
  html_vignette:
    toc: true
    toc_depth: 3
    includes:
      in_header: ../man/figures/logo.html
vignette: >
  %\VignetteIndexEntry{Introduction to bridging Olink® NPX datasets}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
date: 'Compiled: `r format(Sys.Date(), "%B %d, %Y")`'
editor_options: 
  markdown: 
    wrap: 72
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  tidy = FALSE,
  tidy.opts = list(width.cutoff = 95),
  fig.width = 6,
  fig.height = 3,
  message = FALSE,
  warning = FALSE,
  time_it = TRUE,
  fig.align = "center"
)
```

Individual Olink® NPX datasets are normalized using either plate control
normalization or intensity normalization methods. Plate control normalization is
generally used for single plate projects or for Explore HT projects, while
intensity normalization is generally used for multi-plate projects.
Additionally, intensity normalization method assumes that all samples within a
project are fully randomized.

In the case where all samples within a project are not fully randomized, or when
a study is separated into separate batches, an additional normalization step is
needed to allow the data to be comparable, since NPX is a relative measurement.
The joint analysis of two or more Olink® NPX datasets often requires an
additional batch correction step to remove technical variations, which is
referred to as overlapping sample reference normalization, bridge normalization,
or simply bridging.

Batches are groups of samples run at different times. They may or may not use
the same lot of reagents, however bridging is recommended because good
randomization across these sample batches is unlikely.

Bridging is also needed if Olink® NPX datasets are:

-   plate control normalized only and run conditions (e.g lab and reagent lots)
    have changes.

-   intensity normalized but from two different sample populations.

To bridge two or more Olink® NPX datasets, bridge samples are needed to
calculate the assay-specific adjustment factors between datasets. Bridging
samples are shared samples among datasets - that is that samples that are
analyzed in both datasets. The recommended number of bridge samples are shown
in the table below. Olink® NPX datasets without shared samples should not be
combined using the bridging approach described below.

```{r brnrtab, message = FALSE, echo = FALSE}
dplyr::tibble(
  "Olink Product" = c(
    "Target 96",
    "Explore 384: Cardiometabolic, Inflammation, Neurology, and Oncology",
    paste(
      "Explore 384: Cardiometabolic II, Inflammation II, Neurology II,",
          "and Oncology II"
      ),
    "Explore 3072",
    "Explore HT",
    "Reveal",
    "Explore 3072 to Explore HT",
    "Explore 3072 to Reveal"
  ),
  "Number of Bridge Samples" = c(
    "8-16",
    "8-16",
    "16-24",
    "16-24",
    "16-32",
    "16-24",
    "40-64",
    "32-48"
  )
) |>
  kableExtra::kbl(
    booktabs = TRUE,
    digits = 2L,
    caption =
      paste(
        "Table 1. Recommended number of bridge samples for Olink products."
        )
  ) |>
  kableExtra::kable_styling(
    bootstrap_options = "striped",
    full_width = FALSE,
    position = "center",
    latex_options = "HOLD_position"
  )
```

The following tutorial is designed to provide an overview of the data combining
methods that are possible using the Olink® bridging process. Before starting
bridging, it is important to check if the same sample IDs were assigned to the
bridge samples in both datasets.

## Selecting bridge samples

Prior to running the second study, bridge samples must be selected from the
reference study and added to the second study. These samples can be selected
using the `olink_bridge_selector()` function in Olink Analyze. The bridge
selection function will select a number of bridge samples based on the reference
data. This function selects samples that pass QC and have high detectability.
In the cases where detectability cannot be calculated from the test data set
(ex: Explore HT data), the function will only select samples which pass QC.
External controls are not selected as bridge samples as they are not 
representative of the study and therefore may not cover the dynamic range of
assays that would be expressed within the samples. Note that due to naming
convention differences, it is necessary to exclude the control samples
automatically using the function `clean_npx()`, or manually using the function
`stringr::str_detect()`.

To select samples across the range of the data, the samples are ordered by mean
NPX value and selected across this range. When running the selector, the
`sampleMissingFreq` value represents the maximum percentage of data below LOD
allowed per sample. When running plasma on smaller panels, such as Target 96,
`sampleMissingFreq = 0.10` can be a good starting point. Larger panels such as
Explore HT have many proteins that are only expressed in certain diseases or
matrices and therefore more data below LOD is expected. In this case
`sampleMissingFreq = 0.5` can be a good starting point. Note that these values
may need to be adjusted based on the Olink product, sample matrix, and
biological context of the samples, for example, specific disease types.
`sampleMissingFreq = 1` will provide a list of all eligible samples, regardless
of the % of data below LOD and the function output provides the percent of
assays below LOD (`PercAssaysBelowLOD`) which can help inform a good starting
point for a specific study.

In this example we will demonstrate how to select 16 bridge samples using the
example data set `npx_data1`. First, we will check the NPX file using the
function `check_npx()` and pre-process it using the function `clean_npx()` to
investigate for potential issues with the data and ensure it is in the correct
format. The check log list generated from the `check_npx()` function is used to
inform the cleaning process, and then the cleaned data can be re-checked to
confirm that the cleaning process has resolved all issues. This process is shown
in the example code below.

```{r preprocessing, eval = TRUE}
# Load example dataset (npx_data1)
npx_data1 <- OlinkAnalyze::npx_data1

# NPX file preprocessing
# Generate check log
check_log_npx_data1 <- OlinkAnalyze::check_npx(
  df = npx_data1
)

# Clean NPX
npx_data1_clean <- OlinkAnalyze::clean_npx(
  df = npx_data1,
  check_log = check_log_npx_data1
)

# Generate check log on cleaned data
check_log_npx_data1_clean <- OlinkAnalyze::check_npx(
  df = npx_data1_clean
)
```

The following code illustrates how to select the 16 bridge samples from the
cleaned reference data. The selected bridge samples are displayed in Table 2.

```{r bridge_sample_selection_example, echo = TRUE, eval = TRUE}
# Using the already cleaned data from `clean_npx()`
bridge_samples <- OlinkAnalyze::olink_bridge_selector(
  df = npx_data1_clean,
  sample_missing_freq = 0.1,
  n = 16L,
  check_log = check_log_npx_data1_clean
)

# Excluding control samples manually. Naming convention may differ.
bridge_samples_manual <- npx_data1 |>
  dplyr::filter(
    stringr::str_detect(
      string = .data[["SampleID"]],
      pattern = "CONTROL",
      negate = TRUE
    )
  ) |>
  # In this case we skip the argument `check_log`. When `check_log` is not
  # provided, the function will run it internally to check for other
  # inconsistencies in the data such as duplicate sample IDs.
  OlinkAnalyze::olink_bridge_selector(
    sample_missing_freq = 0.1,
    n = 16L
  )
```

```{r bridge_sample_selection, echo = FALSE}
bridge_samples |>
  kableExtra::kbl(
    booktabs = TRUE,
    digits = 2L,
    caption = "Table 2. Selected bridge samples."
  ) |>
  kableExtra::kable_styling(
    bootstrap_options = "striped",
    full_width = FALSE,
    position = "center",
    latex_options = "HOLD_position"
  )
```

It is important to confirm that the selected bridge samples are representative
of the overall samples within the study. This can be assessed visually with a
PCA plot generated using the code below, where the bridge samples should be
evenly dispersed among the other samples (Figure 1).

```{r captions, echo = FALSE}
f1 <- paste("Figure 1. PCA plot of bridge samples and other samples in",
            "dataset `npx_data1` (control samples excluded).")

f2 <- paste("Figure 2. Density plot of NPX distribution in both datasets",
            "before bridging.")

f3 <- paste("Figure 3. PCA plot of both datasets before bridging.")

f4 <- paste("Figure 4. Density plot of NPX distribution in both datasets after",
            "bridging.")

f5 <- paste("Figure 5. Histogram of adjustment factors in normalized data from",
             "dataset `npx_data2`.")

f6 <- paste("Figure 6. Violin plot of CHL1 in both datasets prior to bridging.",
            "Bridge samples are indicated by black points.")

f7 <- paste("Figure 7. Density plot of inter-project CV before and after",
            "bridging.")

f8 <- paste("Figure 8. PCA plot of both datasets after bridging.")
```

```{r bridge_sample_selection_example_pca, echo = TRUE, eval = TRUE, fig.cap = f1}
npx_data1_clean |>
  dplyr::mutate(
    Bridge = dplyr::if_else(
      .data[["SampleID"]] %in% bridge_samples[["SampleID"]],
      "Bridge",
      "Sample"
    )
  ) |>
  OlinkAnalyze::olink_pca_plot(
    color_g = "Bridge",
    check_log = check_log_npx_data1_clean
  )
```

## Setup bridging datasets

Bridging datasets are standard Olink® NPX tables. They can be loaded using the
`read_NPX()` function with default Olink Software NPX files as input.

```{r, message = FALSE, eval = FALSE, echo = TRUE}
npx_data1 <- OlinkAnalyze::read_NPX(
  filename = "~/NPX_file1_location.xlsx"
)
npx_data2 <- OlinkAnalyze::read_NPX(
  filename = "~/NPX_file2_location.xlsx"
)
```

## Check bridging datasets

To demonstrate how bridging works, we will use the example datasets (`npx_data1`
and `npx_data2`) from the **Olink Analyze** package. This workflow also uses
functions from the R packages `dplyr`, `stringr`, and `ggplot2`. The example
datasets contain control samples with duplicated `SampleIDs` across datasets.
Because downstream functions do not allow duplicates we will rename the control
samples to have unique SampleIDs by appending a unique suffix to the control
sample IDs in each dataset. This process is shown in the code below.

```{r data_uniq_sid, eval = TRUE, echo = TRUE}
# Load example dataset (npx_data1)
npx_data1 <- npx_data1 |>
  # create unique extension as suffix for control samples
  dplyr::mutate(
    sid_ext = stringr::str_remove(
      string = .data[["PlateID"]],
      pattern = ".csv"
    ),
    sid_ext = paste0(
      stringr::str_split_i(.data[["sid_ext"]], "_", 4L),
      stringr::str_split_i(.data[["sid_ext"]], "_", 3L)
    ),
  ) |>
  # rename SampleIDs for control samples
  dplyr::mutate(
    SampleID = dplyr::if_else(
      stringr::str_detect(
        string = .data[["SampleID"]],
        pattern = "CONTROL"
      ),
      paste0(.data[["SampleID"]], "_", .data[["sid_ext"]]),
      .data[["SampleID"]]
    )
  ) |>
  dplyr::select(
    -dplyr::all_of("sid_ext")
  )

# Load example dataset (npx_data2)
npx_data2 <- OlinkAnalyze::npx_data2 |>
  # create unique extension as suffix for control samples
  dplyr::mutate(
    sid_ext = stringr::str_remove(
      string = .data[["PlateID"]],
      pattern = ".csv"
    ),
    sid_ext = paste0(
      stringr::str_split_i(.data[["sid_ext"]], "_", 5L),
      stringr::str_split_i(.data[["sid_ext"]], "_", 4L)
    ),
  ) |>
  # rename SampleIDs for control samples
  dplyr::mutate(
    SampleID = dplyr::if_else(
      stringr::str_detect(
        string = .data[["SampleID"]],
        pattern = "CONTROL"
      ),
      paste0(.data[["SampleID"]], "_", .data[["sid_ext"]]),
      .data[["SampleID"]]
    )
  ) |>
  dplyr::select(
    -dplyr::all_of("sid_ext")
  )
```

Further, we will preprocess the NPX files using the functions `check_npx()` and
`clean_npx()` as shown earlier.

```{r preprocessing2, eval = TRUE}
# NPX file preprocessing - npx_data1
# Generate check log
check_log_npx_data1 <- OlinkAnalyze::check_npx(
  df = npx_data1
)

# Clean NPX
npx_data1_clean <- OlinkAnalyze::clean_npx(
  df = npx_data1,
  # Retain control samples and assays
  remove_control_assay = FALSE,
  remove_control_sample = FALSE,
  # Retain assay and QC warnings
  remove_assay_warning = FALSE,
  remove_qc_warning = FALSE,
  check_log = check_log_npx_data1
)

# Generate check log on cleaned data
check_log_npx_data1_clean <- OlinkAnalyze::check_npx(
  df = npx_data1_clean
)

# cleanup intermediate variables
rm(
  npx_data1,
  check_log_npx_data1
)

# NPX file preprocessing - npx_data2
# Generate check log
check_log_npx_data2 <- OlinkAnalyze::check_npx(
  df = npx_data2
)

# Clean NPX
npx_data2_clean <- OlinkAnalyze::clean_npx(
  df = npx_data2,
  # Retain control samples and assays
  remove_control_assay = FALSE,
  remove_control_sample = FALSE,
  # Retain assay and QC warnings
  remove_assay_warning = FALSE,
  remove_qc_warning = FALSE,
  check_log = check_log_npx_data2
)

# Generate check log on cleaned data
check_log_npx_data2_clean <- OlinkAnalyze::check_npx(
  df = npx_data2_clean
)

# cleanup intermediate variables
rm(
  npx_data2,
  check_log_npx_data2
)
```

Identify overlapping sample IDs between studies. Often, the same sample IDs are
used as bridge samples in both NPX data sets, as shown in Table 3. Note that
while external controls may share identifiers between datasets, theses samples
are not bridge samples. External control samples often share the same naming
convention across datasets but may represent different samples due to reagent
batch differences. Additionally, external control samples are unlikely to cover
the dynamic range of assays expressed in the study samples.

```{r, eval = TRUE}
overlapping_samples <- dplyr::tibble(
  SampleID = intersect(
    x = npx_data1_clean[["SampleID"]],
    y = npx_data2_clean[["SampleID"]]
  )
) |>
  dplyr::filter(
    stringr::str_detect(
      string = .data[["SampleID"]],
      pattern = "CONTROL",
      negate = TRUE
    )
  ) |>
  dplyr::pull(
    .data[["SampleID"]]
  )
```

```{r, echo = FALSE}
overlapping_samples |>
  kableExtra::kbl(
    col.names = "SampleID",
    booktabs = TRUE,
    digits = 2L,
    align = "c",
    caption = "Table 3. Overlapping Bridge Samples."
  ) |>
kableExtra::column_spec(
    1, width = "7cm"
  ) |>
  kableExtra::kable_styling(
    bootstrap_options = "striped",
    full_width = FALSE,
    position = "center",
    latex_options = "HOLD_position"
  )
```

Then, gain an overview of the datasets that are going to be bridged. For
example, plot and compare NPX distribution between datasets, as shown in Figure
2. By having a sense of how the studies compared to each other before bridging,
we can then determine the success of the bridging process post bridging. Figure
2 shows a large overlap between `npx_data1` and `npx_data2`, however there are
still some differences as indicated by the blue and red areas on the edge of the
distribution.

```{r check, message = FALSE, fig.cap = f2}
# Expand the datasets to contain the Project column
npx_1 <- npx_data1_clean |>
  dplyr::mutate(
    Project = "data1"
  )
npx_2 <- npx_data2_clean |>
  dplyr::mutate(
    Project = "data2"
  )

# Combine the two data sets for visualization
npx_df <- dplyr::bind_rows(
  npx_1,
  npx_2
)

# Filter out control samples to avoid skewing the distribution
# and affecting downstream PCA results.
npx_df_no_ctrl <- npx_df |>
  dplyr::filter(
    stringr::str_detect(
      string = .data[["SampleID"]],
      pattern = "CONTROL_SAMPLE",
      negate = TRUE
    )
  ) |>
  # Mark bridge samples
  dplyr::mutate(
    Type = dplyr::if_else(
      .data[["SampleID"]] %in% .env[["overlapping_samples"]],
      paste(Project, "Bridge"),
      paste(Project, "Sample")
      )
    ) |>
  # Ensure that SampleIDs are unique across projects for downstream functions.
  dplyr::mutate(
    SampleID = paste0(.data[["SampleID"]],
                      .data[["Project"]])
  )

# Generate check log
check_log_npx_df_no_ctrl <- OlinkAnalyze::check_npx(
  df = npx_df_no_ctrl
  )

# Plot NPX density before bridging
npx_df_no_ctrl |>
  ggplot2::ggplot(
    mapping = ggplot2::aes(
      x = .data[["NPX"]],
      fill = .data[["Project"]]
    )
  ) +
  ggplot2::geom_density(
    alpha = 0.4
  ) +
  ggplot2::facet_grid(
    cols = ggplot2::vars(.data[["Panel"]])
  ) +
  OlinkAnalyze::olink_fill_discrete(
    coloroption = c("red", "darkblue")
  ) +
  OlinkAnalyze::set_plot_theme() +
  ggplot2::ggtitle(
    label = "Before bridging: NPX distribution"
  ) +
  ggplot2::theme(
    axis.title.x = ggplot2::element_blank(),
    axis.title.y = ggplot2::element_blank(),
    strip.text = ggplot2::element_text(size = 16L),
    legend.title = ggplot2::element_blank(),
    legend.position = "top"
  )
```

Use a PCA plot as shown in Figure 3 to visualize sample-to-sample distance
before bridging. Typically the project dataset accounts for most of the observed
variation within the combined datasets at this point. Control samples not 
included in the PCA plot because they are not expected to be representative of
the rest of the dataset, and therefore the variation between sample and control
samples could skew the PCA, making it more challenging to see differences
between projects. Additional, the PCA function does not support multiple samples
with the same identifier, which is also why the bridge samples in the second
project are appended with "\_new". In Figure 3, data1 and data2 separate along
PC1, indicating batch differences between the two datasets.

```{r pca1, message = FALSE, fig.cap = f3}
if (requireNamespace(package = "ggpubr", quietly = TRUE)) {
  # PCA plot
  OlinkAnalyze::olink_pca_plot(
    df = npx_df_no_ctrl,
    color_g = "Type",
    byPanel = TRUE,
    check_log = check_log_npx_df_no_ctrl
  )
}
```

## Bridging between two data sets

We can use `olink_normalization_bridge()` function to bridge two datasets. The
bridging procedure is to first calculate **the median of the paired NPX**
**differences** per assay between the bridge samples as adjustment factor then
use these adjustment factors to adjust NPX values between two datasets. In this
process, one dataset is considered the reference dataset (`df1`) and its NPX
values remain unaltered. The other dataset is considered the new dataset (`df2`)
and is adjusted to the reference dataset based on the adjustment factors.

The output from `olink_normalization_bridge()` function is a NPX table with
adjusted NPX value in the column `NPX`, as shown in Table 4.
`olink_normalization_bridge()` is a wrapper for and supersedes
`olink_normalization()` .

`olink_normalization_bridge()` creates a new column `Project` to distinguish
between reference dataset from the other dataset. It is up to the user to define
which dataset is the reference dataset and specify the names of the bridge
samples. The resulting dataset will contain the reference dataset, which will be
identical to the input reference data, with adjustment factors of 0, and the
newly bridged dataset.

**NOTE:** The alternative quantification columns (for example: Quantified value,
count, and Ct data) are not normalized.

```{r bridging, message = FALSE}
overlapping_samples_list <- list(
  "DF1" = overlapping_samples,
  "DF2" = overlapping_samples
)

# Perform bridging
npx_df_br <- OlinkAnalyze::olink_normalization_bridge(
  project_1_df = npx_data1_clean,
  project_2_df = npx_data2_clean,
  bridge_samples = overlapping_samples_list,
  project_1_name = "data1",
  project_2_name = "data2",
  project_ref_name = "data1",
  project_1_check_log = check_log_npx_data1_clean,
  project_2_check_log = check_log_npx_data2_clean
)

# generate check log on bridged data
check_log_npx_df_br <- OlinkAnalyze::check_npx(
  df = npx_df_br
)
```

```{r norm_data_table, echo = FALSE}
npx_df_br |>
  dplyr::slice_head(
    n = 10L
  ) |>
  kableExtra::kbl(
    booktabs = TRUE,
    digits = 1L,
    caption = "Table 4. First 10 rows of the normalized dataset after bridging."
  ) |>
  kableExtra::kable_styling(
    bootstrap_options = "striped",
    full_width = FALSE,
    font_size = 10L,
    position = "center",
    latex_options = "HOLD_position"
  ) |>
  kableExtra::scroll_box(
    width = "100%"
  )
```

## Perform bridging with non-matching sample names

`olink_normalization_bridge()` also supports data where the overlapping samples
(bridge samples) are not named the same in both projects. In this case the
`overlapping_samples_list` will contain 2 arrays of equal length where the index
of each entry corresponds to the same sample. For example, if a sample has the
`SampleID` `Sample_1_Aliquot_1` in the first batch and `Sample_1_Aliquot_2` in
the second batch, then the `overlapping_samples_list` should be defined as 
follows.

```{r, echo = TRUE, eval = FALSE}
overlapping_samples_list <- list(
  "DF1" = c("A1", "A2", "A3", "Sample_1_Aliquot_1"),
  "DF2" = c("A1", "A2", "A3", "Sample_1_Aliquot_2")
)
```

## Bridging evaluation 

First, check the NPX distribution in datasets after bridging, as shown in
Figure 4. Figure 4 shows a larger overlap in projects than seen in Figure 2, as
indicated by fewer areas of red and blue along the outside of the distribution.

```{r densitybr, message = FALSE, fig.cap = f4}
# Filter out control samples to avoid skewing the distribution
# and affecting downstream PCA results.
npx_df_br_no_ctrl <- npx_df_br |>
  # Remove control samples
  dplyr::filter(
    stringr::str_detect(
      string = .data[["SampleID"]],
      pattern = "CONTROL_SAMPLE",
      negate = TRUE
    )
  ) |>
  # Mark bridge samples
  dplyr::mutate(
    Type = dplyr::if_else(
      .data[["SampleID"]] %in% .env[["overlapping_samples"]],
      paste(.data[["Project"]], "Bridge"),
      paste(.data[["Project"]], "Sample")
    )
  ) |>
  dplyr::mutate(
    SampleID = paste0(.data[["SampleID"]],
                      .data[["Project"]])
  )

# Generate check log
check_log_npx_df_br_no_ctrl <- OlinkAnalyze::check_npx(
  df = npx_df_br_no_ctrl
  )

# Plot NPX density after bridging
npx_df_br_no_ctrl |>
  dplyr::mutate(
    Panel = gsub(
      pattern = "Olink ",
      replacement = "", x = .data[["Panel"]]
    )
  ) |>
  ggplot2::ggplot(
    mapping = ggplot2::aes(
      x = .data[["NPX"]],
      fill = .data[["Project"]]
    )
  ) +
  ggplot2::geom_density(
    alpha = 0.4
  ) +
  ggplot2::facet_grid(
    cols = ggplot2::vars(.data[["Panel"]])
  ) +
  OlinkAnalyze::olink_fill_discrete(
    coloroption = c("red", "darkblue")
  ) +
  OlinkAnalyze::set_plot_theme() +
  ggplot2::ggtitle(
    label = "After bridging: NPX distribution"
  ) +
  ggplot2::theme(
    axis.title.x = ggplot2::element_blank(),
    axis.title.y = ggplot2::element_blank(),
    strip.text = ggplot2::element_text(size = 16L),
    legend.title = ggplot2::element_blank(),
    legend.position = "top"
  )
```

Then, summarize number of assays that have adjustment factors in certain ranges.
High adjustment factors can result from variations between projects, such as
panel versions or technical modifications. The cutoff of a deviating adjustment
factor is subjective and depends on a variety of factors including the
distribution of adjustment factors, as shown in Figure 5. While there are a few
assays with adjustment factors between 2 and 4 and -2 and -4, the majority of
the adjustment factors shown in Figure 5 occur between -2 and 2.

Such assays can be visualized individually with violin plots, as shown in Figure
6, and may warrant further investigation to confirm they are still comparable
between projects. For example, if a violin plot exhibits a different range or
truncated distribution, this may suggest that the assay is below LOD or at hook
in one of the data sets. However, as long as the bridge samples are not at hook
or below LOD, this should not impact the bridging quality. For projects with
differing clinical phenotypes, it is more informative to look at the
similarities between the bridge samples than the similarity between the
datasets, as indicated by the overlaid black dots in Figure 6.

```{r dist_adj_fct, message = FALSE, echo = FALSE, fig.cap = f5}
npx_df_br |>
  # Only looking at Project 2 since project 1 is unadjusted
  dplyr::filter(
    .data[["Project"]] == "data2"
  ) |>
  dplyr::select(
    dplyr::all_of(
      c("OlinkID", "Adj_factor")
    )
  ) |>
  dplyr::distinct() |>
  ggplot2::ggplot(
    mapping = ggplot2::aes(
      x = .data[["Adj_factor"]]
    )
  ) +
  ggplot2::geom_histogram() +
  OlinkAnalyze::set_plot_theme()
```

The distribution of CHL1 between projects is visualized for demonstration
purposes.

```{r violin_plot, fig.cap = f6}
# Bridge sample data
bridge_samples <- npx_df |>
  dplyr::filter(
    .data[["SampleID"]] %in% .env[["overlapping_samples"]]
  ) |>
  dplyr::filter(
    .data[["Assay"]] == "CHL1"
  ) |>
  dplyr::mutate(
    Assay_OID = paste(.data[["Assay"]], .data[["OlinkID"]], sep = "\n")
  )

# Generate violin plot for CHL1
npx_df_no_ctrl |>
  dplyr::filter(
    .data[["Assay"]] == "CHL1"
  ) |>
  dplyr::mutate(
    Assay_OID = paste(.data[["Assay"]], .data[["OlinkID"]], sep = "\n")
  ) |>
  ggplot2::ggplot(
    mapping = ggplot2::aes(
      x = .data[["Project"]],
      y = .data[["NPX"]]
    )
  ) +
  ggplot2::geom_violin(
    mapping = ggplot2::aes(
      fill = .data[["Project"]]
    )
  ) +
  ggplot2::geom_point(
    data = bridge_samples,
    position = ggplot2::position_jitter(
      width = 0.1
    )
  ) +
  ggplot2::theme(
    legend.position = "none"
  ) +
  OlinkAnalyze::set_plot_theme() +
  ggplot2::facet_wrap(
    facets = ggplot2::vars(.data[["Assay_OID"]]),
    nrow = 1L,
    ncol = 1L
  )
```

Another way to determine if bridging decreased variability between projects is
to calculate the coefficient of variation (CV) of the control samples across
both projects before and after bridging, as shown in Figure 7. The CV after
normalization is expected to be smaller than the CV prior to normalization.

Note that the CV calculation formula differs between Olink qPCR and Olink NGS
products. More information of CV calculation can be found in the
[Olink FAQ](https://olink.com/knowledge/faq).

```{r CV_calculation, fig.cap = f7}
# Olink NGS products CV calculation formula
ngs_cv <- function(npx, na_rm = FALSE) {
  sqrt(exp((log(2) * sd(npx, na.rm = na_rm)) ^ 2) - 1) * 100
}

# Olink qPCR products CV calculation formula
qpcr_cv <- function(npx, na_rm = TRUE) {
  100 * sd(2 ^ npx) / mean(2 ^ npx)
}

tech <- "qPCR"

# Calculate CV for control samples across projects before bridging
cv_before <- npx_df |>
  dplyr::filter(
    stringr::str_detect(
      string = .data[["SampleID"]],
      pattern = "CONTROL*."
    )
  ) |>
  dplyr::filter(
    .data[["NPX"]] > .data[["LOD"]]
  ) |>
  dplyr::group_by(
    .data[["OlinkID"]]
  ) |>
  dplyr::mutate(
    CV = dplyr::if_else(
      .env[["tech"]] == "NGS",
      ngs_cv(npx = .data[["NPX"]]),
      qpcr_cv(npx = .data[["NPX"]])
    )
  ) |>
  dplyr::ungroup() |>
  dplyr::distinct(
    .data[["OlinkID"]], .data[["CV"]]
  )

# Calculate CV for control samples across projects after bridging
cv_after <- npx_df_br |>
  dplyr::filter(
    stringr::str_detect(
      string = .data[["SampleID"]],
      pattern = "CONTROL*."
    )
  ) |>
  dplyr::filter(
    .data[["NPX"]] > .data[["LOD"]]
  ) |>
  dplyr::group_by(
    .data[["OlinkID"]]
  ) |>
  dplyr::mutate(
    CV = dplyr::if_else(
      .env[["tech"]] == "NGS",
      ngs_cv(npx = .data[["NPX"]]),
      qpcr_cv(npx = .data[["NPX"]])
    )
  ) |>
  dplyr::ungroup() |>
  dplyr::distinct(
    .data[["OlinkID"]], .data[["CV"]]
  )

# Plot distribution of CV before and after bridging
cv_before |>
  dplyr::mutate(
    Analysis = "Before"
  ) |>
  dplyr::bind_rows(
    cv_after |>
       dplyr::mutate(
         Analysis = "After"
        )
  ) |>
  ggplot2::ggplot(
    mapping = ggplot2::aes(
      x = .data[["CV"]],
      fill = .data[["Analysis"]]
      )
    ) +
  ggplot2::geom_density(
    alpha = 0.7
    ) +
  OlinkAnalyze::set_plot_theme() +
  OlinkAnalyze::olink_fill_discrete() +
  ggplot2::theme(
    text = ggplot2::element_text(
      size = 20L
      )
  ) +
  ggplot2::xlim(-50L, 400L)
```

Finally, use PCA plot to check whether bridging has effect in correcting batch
effects (Figure 8). In the example below, it is clear that before bridge samples
from data 1 and 2 are divided into separate clusters due to the batch effects
(Figure 3), but after bridging they are shown as one cluster in the PCA plot
(Figure 8). Bridging has sufficiently removed the batch effects between two data
sets.

```{r pca2, message = FALSE, fig.cap = f8}
if (requireNamespace(package = "ggpubr", quietly = TRUE)) {
  # PCA plot
  OlinkAnalyze::olink_pca_plot(
    df = npx_df_br_no_ctrl,
    color_g = "Type",
    byPanel = TRUE,
    check_log = check_log_npx_df_br_no_ctrl
  )
}
```

## Export Bridged data

Normalized data in long format can be exported using the `write.table()`
function. Note that 2 columns are added during the bridging process, so to have
the export format match the input format, the columns "Project" and "Adj_factor"
need to be removed. To export exclusively the non-reference project, the
`dplyr::filter()` function can be used.

```{r, eval = FALSE}
npx_df_br |>
  dplyr::filter(
    .data[["Project"]] == "data2"
  ) |>
  dplyr::select(
    -dplyr::all_of(
      c("Project", "Adj_factor")
    )
  ) |>
  write.table(
    file = "New_Normalized_NPX_data.csv",
    sep = ";"
  )
```

## Contact Us

We are always happy to help. Email us with any questions:

-   biostat\@olink.com for statistical services and general stats
    questions

-   support\@olink.com for Olink lab product and technical support

-   info\@olink.com for more information

## Legal Disclaimer

© `r format(Sys.Date(), "%Y")` Olink Proteomics AB, part of Thermo Fisher
Scientific.

Olink products and services are For Research Use Only. Not for use in diagnostic
procedures.

All information in this document is subject to change without notice. This
document is not intended to convey any warranties, representations and/or
recommendations of any kind, unless such warranties, representations and/or
recommendations are explicitly stated.

Olink assumes no liability arising from a prospective reader’s actions based on
this document.

OLINK, NPX, PEA, PROXIMITY EXTENSION, INSIGHT and the Olink logotype are
trademarks registered, or pending registration, by Olink Proteomics AB. All
third-party trademarks are the property of their respective owners.

Olink products and assay methods are covered by several patents and patent
applications [https://www.olink.com/patents/](https://olink.com/patents/).

---
title: "Bridging across NGS-based Olink^®^ products"
output: 
  rmarkdown::html_vignette:
    toc: true
    toc_depth: 3
    fig_caption: TRUE
    includes:
      in_header: ../man/figures/logo.html
vignette: >
  %\VignetteIndexEntry{Bridging across NGS-based Olink products}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
date: 'Compiled: `r format(Sys.Date(), "%B %d, %Y")`'
editor_options: 
  markdown: 
    wrap: 72
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  tidy = FALSE,
  tidy.opts = list(width.cutoff = 95),
  fig.width = 6,
  fig.height = 3,
  message = FALSE,
  warning = FALSE,
  time_it = TRUE,
  fig.align = "center"
)
```

## Introduction

Individual Olink^®^ NPX^TM^ projects are generally normalized using either plate
control normalization or intensity normalization methods. Since NPX is a
relative measurement, in the case when a study is separated into multiple
projects, an additional normalization step is needed to allow the data to be
comparable across projects. The following tutorial is designed to give you an
overview of the Olink bridging procedure for combining data sets from Olink^®^
Explore 3072, Olink^®^ Explore HT, and Olink^®^ Reveal products.

### Important Terminology

-   **Bridging samples** – Overlapping samples run on two or more projects
    that are used as references to enable normalization. These
    samples are selected as described in the 
    [Introduction to Bridging tutorial](bridging_introduction.html) to ensure 
    samples are of high quality and span the range of the data. In the case of
    data containing LOD, samples are also filtered for high detectability. 
    Bridging samples are selected from the project that is run first to run with
    the second project.

-   **Project** – A set of plates that run at the same time and have been
    normalized together. If two projects are not randomized or are run at
    different times then additional normalization is required.

-   **Project effect/correction** – As NPX is a relative quantification,
    overall NPX values may shift across projects. This can result in
    separation of projects that are part of the same study which can be
    corrected for using normalization or accounted for within a
    statistical model.
    
-   **Within-product bridging** – Normalization of two or more projects
    run on the same Olink product using bridging samples.

-   **Between-product bridging** - Normalization of two or more projects
    from different Olink products (in this case, Olink Explore 3072 and
    Olink Explore HT) using bridging samples.

-   **Reference data** – The project data which is being normalized to
    is known as the reference data. In the case of between-product
    bridging, the reference project is the Explore HT NPX data or Reveal NPX
    data. The reference data set is not altered during bridging and the other
    data set is adjusted to the reference data set using the bridging samples.

### Within- and between-product bridging

The joint analysis of two or more NPX projects run on the same Olink
product often requires a project correction step to remove
technical variation. One such method of normalizing two projects is referred to
as bridge sample reference normalization, bridge normalization, or simply
bridging. For more information on within-product bridging, see the 
[Introduction to Bridging tutorial](bridging_introduction.html). Bridging makes
certain assumptions on the distributions of the assays, namely that we are
measuring the same true biological range no matter the setting. If an assay
displays different distributions between projects, then both bridging and
downstream statistical analysis will be affected. Within a product, we assume
the variance and shape of the distribution remains constant within assays.

In the case where a study consists of separate projects run on Olink
Explore 3072 and either Olink Explore HT or Olink Reveal, an additional project
correction step is required to allow data from these two products to be analyzed
together, which is referred to as between-product bridging. Olink Explore 3072,
Olink Explore HT, and Olink Reveal are all products that use PEA technology
combined with next generation sequencing (NGS) to calculate NPX for thousands of
proteins. However, assays may vary more between products than within a product,
and fewer assumptions can be made regarding the similarity of assay
distributions and variance between products.

Since many of the assays profiled in Olink Explore 3072 are also found
on Olink Explore HT or Olink Reveal, bridging data across products enables
increased power in studies consisting of data from multiple Olink products,
rather than limiting these studies to meta-analysis. However, differences
between products, such as the number of assays being measured and the reagents
being used, can sometimes lead to signal in one product and noise in another
product. Bridging signal to noise can have detrimental effects on downstream
statistical analysis. This means that while some assays will be able to be
bridged using the same method as in within-product bridging, others will require
a different normalization method, and some will not be bridgeable at all. This
normalization strategy combines median-centering (as is used in within-product
bridging) and quantile smoothing to normalize assays across products based on
the assumption that assays can be bridged provided they have signal in both
products or noise in both products.

### Considerations for between-product bridging

For product bridging between an Olink Explore 3072 project and an Olink Explore
HT project or an Olink Reveal project, the NPX values from the Olink Explore
3072 project can be normalized and made comparable to those from Olink Explore
HT or Olink Reveal. This process is one-directional, and normalizing Olink
Explore HT or Olink Reveal NPX values to Olink Explore 3072 is not supported.
For product bridging between an Olink Explore HT project and an Olink Reveal
project, normalization is supported in both directions.

The product bridging normalization uses the assays that are overlapping between
the two products. ~2900 assays overlap between Olink Explore HT and Olink
Explore 3072, ~850 assays overlap between Olink Reveal and Olink Explore 3072,
~1000 assays overlap between Olink Explore HT and Olink Reveal.

Each overlapping assay undergoes a series of checks that evaluate the number of
counts, correlation, and difference of NPX ranges between the two data sets. If
an assay has enough counts and comparable metrics between the two data sets, it
is determined to be suitable for bridging (referred to as a "bridgeable assay").
Assays that are not suitable for bridging can either be excluded from downstream
analysis in one or both products or results can be integrated across products
using meta-analysis. The set of bridgeable assays across products will vary from
data set to data set, based on the samples present within the studies. Depending
on the NPX distribution of each bridgeable assay in the two data sets, the assay
is normalized using either median normalization or quantile smoothing.

Bridging an Explore 3072 data set to an Explore HT NPX data set requires 40-64
bridging samples, bridging an Olink Explore 3072 data set to an Olink Reveal
data set requires 32-48 bridging samples, while the bridging between Olink
Explore HT data set and Olink Reveal data set requires 24-40 bridging samples.
Bridging samples are shared samples among data sets and, as such, are analyzed
in both data sets. Olink NPX data sets without shared samples cannot be combined
using the bridging approach described below. More information on bridge sample
selection can be found in the section [selecting bridging samples](bridging_introduction.html#selecting-bridging-samples) of the 
Introduction to Bridging tutorial.

## Bridge Sample Selection

Prior to running a study with Explore HT or Olink Reveal, bridging samples must
be selected from the study run with Explore 3072 and be run on the subsequent
study. These samples can be selected using the `olink_bridgeselector()` function
in Olink Analyze as detailed in the section [selecting bridging samples](bridging_introduction.html#selecting-bridging-samples) of the 
Introduction to Bridging tutorial.

In addition, for studies involving Explore HT and Reveal, bridging can
also be performed directly between Explore HT and Reveal in either direction. In
these cases, bridging samples should be selected from the run used as the
reference and included in the corresponding subsequent run. The recommended
number of bridge samples for within- and between- product bridging is summarized
in the table below. When selecting bridge samples, the aim is to select samples
that represent the dynamic range of the assay expression in the product. As
such, quality control of the sample and, if available, proportion of data above
LOD in the sample are considered when determining if a sample is chosen as a
bridging sample. When LOD data is not available in the data export from Olink
NPX software, LOD can optionally be calculated from fixed LOD or negative
controls as detailed in the
[Calculating LOD from Olink Explore data tutorial](lod.html).

```{r brnrtab, eval = TRUE, message = FALSE, echo = FALSE}
dplyr::tibble(
  "Olink Product" = c(
    "'Olink Explore 3072' to 'Olink Explore HT'",
    "'Olink Explore 3072' to 'Olink Reveal'",
    "'Olink Explore HT' to 'Olink Reveal'",
    "'Olink Reveal' to 'Olink Explore HT'"
  ),
  "Number of Bridge Samples" = c(
    "40-64",
    "32-48",
    "24-40",
    "24-40"
  )
) |>
  kableExtra::kbl(
    booktabs = TRUE,
    digits = 2L,
    caption = paste("Recommended number of bridge samples for normalizing",
                    "between Olink products.")
  ) |>
  kableExtra::kable_styling(
    bootstrap_options = "striped",
    full_width = FALSE,
    position = "center",
    latex_options = "HOLD_position"
  )
```

## Workflow Overview

Olink Explore 3072 to Olink Explore HT bridging requires Explore 3072 data and
Explore HT data which have at least 40 to 64 bridge samples. Olink Explore
3072 to Olink Reveal bridging requires Explore 3072 data and Reveal data which
have at least 32 to 48 bridge samples. Bridging between Olink Explore HT and
Olink Reveal, requires Explore HT data and Reveal data which have at least 24 to
40 bridge samples.

For studies that include multiple Explore 3072 data sets, these data sets should
first be bridged using a within-product approach, as described in the 
[Introduction to bridging tutorial](bridging_introduction.html). The same 
principle applies when bridging data between Explore HT and Olink Reveal. If 
multiple HT or Reveal studies are available, it is recommended to first perform within-product bridging to combine all HT studies or all Reveal studies, 
respectively, before proceeding with between-product bridging.

The assays from Explore 3072 are matched to their corresponding assays in
Explore HT or Reveal and evaluated to determine whether each assay is
bridgeable. For studies involving Explore HT and Olink Reveal, the assays
between these two products are also matched and assessed for bridgeability in
the same manner. All assays are then normalized using both quantile smoothing
and normalization based on the median of paired differences. The output is an
adjusted data set that includes five additional columns, three of which relate
specifically to bridging normalization:

-   `BridgingRecommendation`: a flag which indicates if the assay is bridgeable
    and, if so, which normalization method is recommended. One of the three
    values will be listed in this column: "NotBridgeable", "MedianCentering", or
    "QuantileSmoothing".

-   `MedianCenteredNPX`: NPX values after normalization using the median of
    paired differences.

-   `QSNormalizedNPX`: NPX values after normalization using quantile smoothing.

After bridging, data from Explore 3072 and the reference product (Explore HT or 
Reveal) are exported into a single data set. For studies involving both Explore
HT and Olink Reveal, data are exported in the same way. Two additional columns
are added to facilitate data mapping and export.

-   `Project`: the name of the project as defined in the function input
arguments `df1_project_nr` and `df2_project_nr`.

-   `OlinkID_PRODUCT`: mapped Olink IDs from non-reference Olink product. The
term "PRODUCT" in the column name will be replaced by the non-reference name of
the product: "E3072", "HT" or "Reveal" (e.g. `OlinkID_E3072`). Olink IDs from
the reference product will be listed in the `OlinkID` column.
    
Note that regardless of the bridging recommendation, NPX values will be
available for both normalization methods. A visual representation of the
between-product bridging workflow is shown below.

```{r, fig.cap = fcap, eval = TRUE, echo = FALSE, out.width = "50%"}
knitr::include_graphics(
  normalizePath(
    path = "../man/figures/Bridging_schematic.png"
  ),
  error = FALSE
)

fcap <- "Schematic of Between-Product Bridging Workflow"
```

## Import NPX files

To normalize Explore 3072 data to Explore HT or Olink Reveal data, the data sets
should first be read into R using `read_NPX()`. If more than two datasets are
being normalized, all Explore 3072 studies should first be normalized through within-product bridging. The resulting data set should then be used as input for between-product bridging. In the case of multiple Explore HT studies or multiple
Reveal studies, only one study should be chosen as the reference data set. 

The same principle applies to studies involving Explore HT and Olink Reveal. 
When performing bridging between these products, data sets should be read using `read_NPX()`. If multiple HT or Reveal studies are available, within-product 
bridging should be performed first, and the resulting data set should be used as
the input.

The data can be loaded using `read_NPX()` function with default Olink Software
NPX file as input, as shown below.

```{r message = FALSE, eval = FALSE, echo = TRUE}
### Use provided example dataset

# Explore 3072: CSV or parquet file
data_e3072 <- OlinkAnalyze::read_NPX(
  filename = "~/NPX_Explore3072_location.parquet"
  )

# Explore HT: parquet file
data_eht <- OlinkAnalyze::read_NPX(
  filename = "~/NPX_ExploreHT_location.parquet"
)

# Reveal: CSV or parquet file
data_reveal <- OlinkAnalyze::read_NPX(
  filename = "~/NPX_Reveal_location.parquet"
)
```

The imported data should be further processed using the `check_npx()` and
`clean_npx()` functions to ensure that the data is in the correct format for
bridging and to generate check logs to identify any potential issues with the
data.

```{r message = FALSE, eval = FALSE, echo = TRUE}
### NPX file preprocessing

# Generate check log
check_log_data_e3072 <- OlinkAnalyze::check_npx(
  df = data_e3072
)
check_log_data_eht <- OlinkAnalyze::check_npx(
  df = data_eht
)
check_log_data_reveal <- OlinkAnalyze::check_npx(
  df = data_reveal
)

# Clean NPX data
data_e3072_clean <- OlinkAnalyze::clean_npx(
  df = data_e3072,
  check_log = check_log_data_e3072,
  # keep internal and external controls
  remove_control_sample = FALSE,
  remove_control_assay = FALSE,
  # keep datapoints with samples and assays warnings
  remove_qc_warning = FALSE,
  remove_assay_warning = FALSE
)
data_eht_clean <- OlinkAnalyze::clean_npx(
  df = data_eht,
  check_log = check_log_data_eht,
  # keep internal and external controls
  remove_control_sample = FALSE,
  remove_control_assay = FALSE,
  # keep datapoints with samples and assays warnings
  remove_qc_warning = FALSE,
  remove_assay_warning = FALSE
)
data_reveal_clean <- OlinkAnalyze::clean_npx(
  df = data_reveal,
  check_log = check_log_data_reveal,
  # keep internal and external controls
  remove_control_sample = FALSE,
  remove_control_assay = FALSE,
  # keep datapoints with samples and assays warnings
  remove_qc_warning = FALSE,
  remove_assay_warning = FALSE
)

# Generate check log on cleaned data
check_log_data_e3072_clean <- OlinkAnalyze::check_npx(
  df = data_e3072_clean
)
check_log_data_eht_clean <- OlinkAnalyze::check_npx(
  df = data_eht_clean
)
check_log_data_reveal_clean <- OlinkAnalyze::check_npx(
  df = data_reveal_clean
)

# clean up environment
rm(
  data_e3072,
  data_eht,
  data_reveal,
  check_log_data_e3072,
  check_log_data_eht,
  check_log_data_reveal
)
```

## Checking input datasets and bridging samples

First, confirm that there are overlapping sample IDs within the study. Note that
external controls should not be included in the list of bridging samples, as
detailed in the section [selecting bridging samples](bridging_introduction.html#selecting-bridging-samples) of the 
Introduction to Bridging tutorial. External control samples often share the same
naming convention across data sets but may represent different samples due to
reagent batch differences. Appending the project name to the end of the control
samples can ensure unique Sample IDs. For the example below, Explore HT data is
used as the reference project; however, the same process can be performed using
Reveal as the reference data set. The equivalent workflow also applies when
performing bridging between Explore HT and Reveal, where either product may be
used as the reference.

```{r, eval = FALSE, echo = TRUE}
# Note that if `SampleType` is not is input data:
# stringr::str_detect can be used to exclude control samples based on SampleID.

data_e3072_samples <- data_e3072_clean |>
  dplyr::filter(
    .data[["SampleType"]] == "SAMPLE"
  ) |>
  dplyr::distinct(
    .data[["SampleID"]]
  ) |>
  dplyr::pull()

data_eht_samples <- data_eht_clean |>
  dplyr::filter(
    .data[["SampleType"]] == "SAMPLE"
  ) |>
  dplyr::distinct(
    .data[["SampleID"]]
  ) |>
  dplyr::pull()

overlapping_samples <- dplyr::intersect(
  x = data_e3072_samples,
  y = data_eht_samples
) |>
  unique()
```

```{r, echo=FALSE}
try(
  readRDS(
    file = normalizePath(
      path = "../man/figures/overlapping_samples_table.rds"
    )
  ) |>
    kableExtra::kbl(
      booktabs = TRUE,
      digits = 2L,
      caption = "List of overlapping samples between the two projects."
    ) |>
    kableExtra::kable_styling(
      bootstrap_options = "striped",
      full_width = FALSE,
      position = "center",
      latex_options = "HOLD_position"
    )
)
```

PCA plots for each dataset can be used to assess if any bridge samples are
outliers in the dataset.

```{r, include = FALSE}
f3 <- paste0(
  "PCA plot prior to bridging for Explore 3072 data and data from the",
  " reference product. Bridge samples are indicated by color. PCA plots can be",
  " helpful in assessing if any bridge samples were outliers in one of the",
  " platforms."
)
```

```{r, eval = FALSE}
#### Extract bridging samples

data_e3072_before_br <- data_e3072_clean |>
  dplyr::filter(
    .data[["SampleType"]] == "SAMPLE"
  ) |>
  # Note that if column `SampleType` is not in input data, the function
  # stringr::str_detect can be used to exclude control samples based on naming
  # convention.
  dplyr::mutate(
    Type = dplyr::if_else(
      .data[["SampleID"]] %in% .env[["overlapping_samples"]],
      paste0("Explore 3072 Bridge"),
      paste0("Explore 3072 Sample")
    )
  )

data_eht_before_br <- data_eht_clean |>
  dplyr::filter(
    .data[["SampleType"]] == "SAMPLE"
  ) |>
  # Note that if column `SampleType` is not in input data, the function
  # stringr::str_detect can be used to exclude control samples based on naming
  # convention.
  dplyr::mutate(
    Type = dplyr::if_else(
      .data[["SampleID"]] %in% .env[["overlapping_samples"]],
      paste0("Explore HT Bridge"),
      paste0("Explore HT Sample")
    )
  )

### PCA plot
pca_e3072 <- OlinkAnalyze::olink_pca_plot(
  df = data_e3072_before_br,
  check_log = check_log_data_e3072_clean,
  color_g = "Type",
  quiet = TRUE
)
pca_eht <- OlinkAnalyze::olink_pca_plot(
  df = data_eht_before_br,
  check_log = check_log_data_eht_clean,
  color_g = "Type",
  quiet = TRUE
)
```

```{r, echo = FALSE, fig.cap = f3, fig.height = 8, fig.width = 6}
knitr::include_graphics(
  normalizePath(
    path = "../man/figures/PCA_btw_product_before.png"
  ),
  error = FALSE
)
```

## Normalization

The `olink_normalization()` functionality has been expanded and can be used to
determine which assays are bridgeable and of the bridgeable assays what
normalization method is advised, and to calculate normalized NPX values for the
non-reference project. Normalized NPX values are calculated for all assays 
across products as described in the [Workflow Overview] and in the sections
below. Within this function, the bridging recommendations for each assay are
determined and the NPX values are normalized using the two methods described
below.

The `olink_normalization()` function contains a `format` argument that is set to 
`FALSE` by default. This will export the data frame with the format shown in
Table 4 of the [Function Output] section. The values in the NPX column will
remain unchanged and median-centered NPX values and QS-normalized NPX values
will be populated in the `MedianCenteredNPX` and `QSNormalizedNPX` columns for
all datapoints, regardless of bridging recommendation. 

If the format argument is set to `TRUE`, this will export the data frame with
the NPX values replaced with the bridged NPX values corresponding to the
bridging recommendation (see Table 5 of the [Function Output] section). For more
information, see the [Downstream Analysis] section below. 

```{r, eval = FALSE, echo = TRUE}
### Perform bridge normalization

# Note:
# Project name is assigned by `df1_project_nr` and `df2_project_nr` parameters
# in `olink_normalization` function

# Perform between-product bridging without formatting for downstream analysis
npx_br_data <- OlinkAnalyze::olink_normalization(
  df1 = data_eht_clean,
  df2 = data_e3072_clean,
  overlapping_samples_df1 = overlapping_samples,
  df1_project_nr = "Explore HT",
  df2_project_nr = "Explore 3072",
  reference_project = "Explore HT",
  format = FALSE,
  df1_check_log = check_log_data_eht_clean,
  df2_check_log = check_log_data_e3072_clean
)

# Perform between-product bridging with formatting for downstream analysis
npx_br_data <- OlinkAnalyze::olink_normalization(
  df1 = data_eht_clean,
  df2 = data_e3072_clean,
  overlapping_samples_df1 = overlapping_samples,
  df1_project_nr = "Explore HT",
  df2_project_nr = "Explore 3072",
  reference_project = "Explore HT",
  format = TRUE,
  df1_check_log = check_log_data_eht_clean,
  df2_check_log = check_log_data_e3072_clean
)
```

Use `check_npx()` and `clean_npx()` to ensure that the data is in the correct
format and to clean the data after bridging.

```{r message = FALSE, eval = FALSE, echo = TRUE}
# Generate check log
check_log_br_data <- OlinkAnalyze::check_npx(
  df = npx_br_data
)

# Clean NPX data
npx_br_data_clean <- OlinkAnalyze::clean_npx(
  df = npx_br_data,
  check_log = check_log_br_data,
  # keep only control samples as we will need them for downstream QC
  remove_control_sample = FALSE
)

# Generate check log on cleaned data
check_log_br_data_clean <- OlinkAnalyze::check_npx(
  df = npx_br_data_clean
)

# clean up environment
rm(
  npx_br_data,
  check_log_br_data
)
```

### Determining bridging recommendations

For an assay to be bridgeable across products, it must either have signal in
both products or be primarily background signal in both products. Bridging noise
into signal or signal into noise can negatively impact downstream statistical
analysis. To determine if an assay is bridgeable, the bridge samples from both
products are used to assess the following criteria:

-   Is there a linear relationship between products?
    -   **Assessing linearity across products:** To determine if there
        is a linear relationship between products for an assay, the
        linear coefficient of determination (R^2^) is calculated using
        Pearson correlation. R^2^ is a measure of how much of the
        variation in the data is explained by the linear function
        compared to just using the mean. In this correlation, counts
        below 10 are excluded due to lack of signal. The R^2^ value is
        calculated and an assay is considered to have a linear
        relationship across products if the R^2^ value is above the
        cutoff. A higher R^2^ value indicates, that for both products,
        the assay is in the linear range. Conversely, a low R^2^ means
        that either one or both assays are in background. The default
        cutoff is set to R^2^ \> 0.8 indicating that at least 80% of the
        variation in the data is explained by the linear function.
-   Are the NPX ranges in the two products similar?
    -   **Assessing similarity of NPX ranges:** To determine if the NPX
        ranges are similar across products, the difference in NPX values
        from the 10% to 90% quantile is calculated for each product,
        excluding data points with counts less than 10. If the
        difference in range of NPX between products is greater than the
        cutoff then the ranges are not considered similar across
        products. Since the NPX values are calculated on the same
        samples, it is expected that an increase in 1 NPX in one product
        would correspond to an increase of 1 NPX in the other product.
        If the ranges are not similar, this suggests that 1 NPX is not
        equivalent across products. By default, the cutoff is set to a
        difference of less than 1 NPX between products.
-   Are there sufficient counts in both products?
    -   **Assessing if there are sufficient counts:** An assay's
        absolute level of counts is important to consider as the
        instruments used to generate NPX values have an inherent noise
        level. To determine if there are sufficient counts in an assay
        for bridging, the median number of counts in both products is
        calculated, excluding data points with less than 10 counts. If
        the median number of counts is less than the cutoff then the
        assay does not have sufficient counts to be used for bridging.
        The default cutoff is set to 150 counts, which is based on the
        count quality control metrics for Explore products.

For assays that are bridgeable, the shape of the NPX distribution is
compared between the two products:

-   **Assessing similarity of NPX distribution across products:** If any of the
    three criteria outlined above are met then the assay is considered
    bridgeable. Otherwise, bridging is not recommended for that assay.
    If an assay is bridgeable, the similarity of the NPX distribution is
    used to determine which method is recommended for bridging. The
    Kolmogorov-Smirnov test, or KS test, is used to assess the
    similarity of two distributions by calculating the KS statistic,
    which is based on the empirical cumulative distribution function
    (ECDF). Counts below 10 are excluded and the largest difference seen
    in the ECDF becomes the KS statistic. If the KS statistic is above
    the cutoff, the distributions are considered to have different
    shapes. In this case, a median shift is not sufficient to normalize
    the data, and quantile smoothing is recommended. If the distance is
    less than the cutoff, then normalization using the median of paired
    differences is recommended. By default this cutoff difference is set
    to 0.2.

An overview of these criteria is visualized below.

```{r, echo = FALSE, fig.cap = fcap, out.width = "50%"}
knitr::include_graphics(
  normalizePath(
    path = "../man/figures/assay_bridgeability.jpg"
  ),
  error = FALSE
)
fcap <- paste(
  "Criteria to determine the bridging recommendation for an assay. The",
  "assessment of linearity ensures bridging between signal in both platforms",
  "or noise in both platforms (but not between signal and noise). Similar NPX",
  "ranges and sufficient counts provide additional insight into an assay's",
  "bridgeability. Distribution shape is assessed to determine recommended",
  "bridging method."
)
```
\
\

The `olink_bridgeability_plot` function generates a series of figures on a
per-assay basis for a data set generated from between-product bridging, based
on the bridging samples used in the bridge normalization. The coloration of the
figure headers indicate whether that assay has been defined as bridgeable or not
bridgeable. Red headers indicate that an assay is not bridgeable and blue
headers indicate that an assay is bridgeable. The correlation plot, violin plot,
and bar chart figures illustrate the three criteria described above for
determining whether an assay is bridgeable. 

If an assay is determined to be bridgeable, the ECDF curve and corresponding KS
statistic are used to determine which normalization approach (median centering
or quantile smoothing) is most suitable for between-product normalization.

Prior to assessment, outlier bridging samples are excluded. A sample is
considered an outlier if the NPX value is more than 3 times the interquartile
range above or below the median on either product.

After assessment, an assay is considered bridgeable if it meets any of the first
three criteria. The fourth criterion determines which normalization method is
recommended for bridging. Note that bridgeable assays will differ between
projects based on the expression of bridge samples in the studies. Here, the
Explore 3072 to Explore HT bridging case is shown as the example, although the
same principles apply to other product combinations, including Olink Explore HT
and Olink Reveal.

```{r, eval = FALSE, echo = TRUE}
### Generate olink_bridgeability_plot figures

npx_br_data_bridgeable_plt <- npx_br_data_clean |>
  dplyr::filter(
    .data[["SampleType"]] == "SAMPLE"
  ) |>
  OlinkAnalyze::olink_bridgeability_plot(
    check_log = check_log_br_data_clean,
    # Important to note that setting `olink_id` to NULL will generate plots for
    # all assays. This can be computationally intensive if there are many
    # assays!
    # To generate plots for a subset of assays, set `olink_id` to a vector of
    # Olink IDs of interest.
    olink_id = NULL,
    median_counts_threshold = 150L,
    min_count = 10L
  )

npx_br_data_bridgeable_plt[[1L]]
```

```{r, message = FALSE, echo = FALSE, out.width = "675px", fig.cap = fcap}
knitr::include_graphics(
  normalizePath(path = "../man/figures/bridgeable_plt_MedianCenter.png"),
  error = FALSE
)

fcap <- paste("Visualization of an assay's bridgeability criteria as generated",
              "by the `olink_bridgeability_plot()` function.")
```
\
\

### Normalization using the median of paired differences

If it is expected that both the kind of distribution and the variance
per test between runs are the same, then normalization using the median
of paired differences will be preferred. Normalization using the median
of paired differences based on the bridging samples is performed in the
following steps:

1.  For each assay in the non-reference project (e.g. Explore 3072), the
pairwise difference is calculated for each of the bridging samples with the
Explore HT project.

2.  The normalization factor is estimated for each assay by finding the
median of the pairwise differences.

3.  The assay-specific normalization factor for each assay is used to normalize
each data point from the non-reference to the reference project.

### Quantile smoothing

Since Olink NGS products are distinct with different workflows involved in
generating NPX data, some assays exist in corresponding but distinct NPX spaces.
For those assays, the median of paired differences is insufficient for bridging
because it uses only a single anchor point (the median/50% quantile). Instead,
quantile smoothing (QS) using multiple anchor points (5%, 10%, 25%, 50%, 75%,
90%, and 95% quantiles) is preferred to map data from the non-reference set to 
the distribution of the reference set.

The normalization using QS uses bridging samples to perform the following steps:

1.  Each data point of the samples from the non-reference project is mapped to
the equivalent space in the reference product using an empirical cumulative
distribution function. The empirical cumulative distribution function is a
probability model that uses the observed NPX values of the bridging samples for
an assay to create a step function that interpolates linearly between available
data points.

2.  The empirical distribution function is then used to map the data points from
the source product to the reference product space using the specified quantiles.
At this stage, all data points from the bridging samples have NPX values
normalized to the reference product.

3.  To normalize the remaining data, a spline regression model is constructed
using the sorted data from the source product (prior to mapping) and the mapped
values, along with the anchor points of the spline. A spline regression model
divides the dataset at the quantiles and uses these quantiles as anchor points
or knots; the model then fits the values between each anchor point.

4.  The spline regression model is used to predict all remaining data points
from the non-reference product into the space of the reference product. The
model consists of piecewise linear regressions within the quantile intervals.
The NPX value from the source product is used as the x-value in the appropriate
interval to produce the predicted y-value corresponding to the NPX scale of the
reference product.

### Function Output

The output from `olink_normalization()` function when used for between 
product bridging is a data frame with concatenated data from the two products 
and additional columns including adjusted NPX values, bridging recommendations,
mapping information, and project names. The adjusted NPX values are notated in
the columns `MedianCenteredNPX` and `QSNormalizedNPX`. For each assay a
recommendation is listed in the `BridgingRecommendation` column and
lists what method, if any, should be used for that assay. Additional
columns including `OlinkID` and `OlinkID_PRODUCT` [Workflow Overview] map the
assays across products and the `Project` column lists the name of the project
based on the `df1_project_nr` and `df2_project_nr` arguments. As the reference
data is not altered during normalization, the normalized NPX values
(`MedianCenteredNPX` and `QSNormalizedNPX`) in the reference data will be the
same as the values in the NPX column which contains the non-normalized data.

```{r, eval = TRUE, echo = FALSE}
try(
  readRDS(
    file = normalizePath("../man/figures/bridging_results.rds")
  ) |>
    kableExtra::kbl(
      booktabs = TRUE,
      digits = 1,
      caption = paste("Table 4. First 5 rows of combined datasets after",
                      "bridging with between-product formatting argument set",
                      "to FALSE.")
    ) |>
    kableExtra::kable_styling(
      bootstrap_options = "striped",
      full_width = FALSE,
      font_size = 10,
      position = "center",
      latex_options = "HOLD_position"
    ) |>
    kableExtra::scroll_box(
      width = "100%"
    )
)
```

```{r, eval = TRUE, echo = FALSE}
try(
  readRDS(
    normalizePath(path = "../man/figures/bridging_results.rds")
  ) |>
    dplyr::mutate(
      NPX = dplyr::case_when(
        .data[["BridgingRecommendation"]] == "MedianCentering" ~
          .data[["MedianCenteredNPX"]],
        .data[["BridgingRecommendation"]] == "QuantileSmoothing" ~
          .data[["QSNormalizedNPX"]],
        .default = .data[["NPX"]]
      )
    ) |>
    dplyr::mutate(
      SampleID = paste(.data[["SampleID"]], .data[["Project"]], sep = "_")
    ) |>
    dplyr::mutate(
      OlinkID = dplyr::if_else(
        .data[["BridgingRecommendation"]] != "NotBridgeable",
        paste(.data[["OlinkID"]], .data[["OlinkID_E3072"]], sep = "_"),
        .data[["OlinkID_E3072"]]
      )
    ) |>
    dplyr::select(
      -dplyr::all_of(
        c("OlinkID_E3072", "MedianCenteredNPX", "QSNormalizedNPX")
      )
    ) |>
    kableExtra::kbl(
      booktabs = TRUE,
      digits = 1L,
      caption = paste("Table 5. First 5 rows of combined datasets after",
                      "bridging with between-product formatting argument set",
                      "to TRUE.")
    ) |>
    kableExtra::kable_styling(
      bootstrap_options = "striped",
      full_width = FALSE,
      font_size = 10,
      position = "center",
      latex_options = "HOLD_position"
    ) |>
    kableExtra::scroll_box(
      width = "100%"
    )
)
```

## Evaluating the quality of bridging

PCA is used to assess the quality of bridging by determining if the
sample controls (SCs) and bridging samples appear closer after bridging.
Two PCAs can be generated, one containing the SCs and one containing the
bridging samples. Prior to bridging there will be a noticeable
separation between products which should decrease after bridging.

```{r, include = FALSE}
f8 <- paste("Combined PCA of sample controls from both platforms prior to",
            "normalization.")
f9 <- paste("Combined PCA of bridging samples from both platforms prior to",
            "normalization.")
f10 <- paste("Combined PCA of sample controls from both platforms after",
             "normalization.")
f11 <- paste("Combined PCA of bridging samples from both platforms after",
             "normalization.")
```

```{r, eval = FALSE, echo = TRUE}
# Prepare data for PCA plots - pre-bridging

npx_pre_data <- data_eht_clean |>
  dplyr::mutate(
    Project = "Explore HT"
  ) |>
  dplyr::bind_rows(
    data_e3072_clean |>
      dplyr::mutate(
        Project = "Explore 3072"
      )
  )

check_log_pre_data <- OlinkAnalyze::check_npx(
  df = npx_pre_data
)

# no need to clean data set `npx_pre_data`
# ```
```

```{r pca_pre_sc, eval = FALSE, echo = TRUE}
# Generate pre-bridging PCA using Sample Control samples

npx_pre_data |>
  dplyr::filter(.data[["SampleType"]] == "SAMPLE_CONTROL") |>
  dplyr::mutate(
    SampleID = paste(.data[["Project"]], .data[["SampleID"]], sep = "_")
  ) |>
  OlinkAnalyze::olink_pca_plot(
    check_log = check_log_pre_data,
    color_g = "Project",
  )
```

```{r pca_pre_sc_fig, eval = TRUE, echo = FALSE, fig.cap = f8, message = FALSE}
# Generate pre-bridging PCA using Sample Control samples
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/SCs_pre_bridging.png"
  ),
  error = FALSE
)
```

```{r pca_pre_bridge, eval = FALSE, echo = TRUE}
# Generate pre-bridging PCA using bridging sample

npx_pre_data |>
  dplyr::filter(
    .data[["SampleType"]] == "SAMPLE"
  ) |>
  dplyr::filter(
    .data[["SampleID"]] %in% .env[["overlapping_samples"]]
  ) |>
  dplyr::mutate(
    SampleID = paste(.data[["Project"]], .data[["SampleID"]], sep = "_")
  ) |>
  OlinkAnalyze::olink_pca_plot(
    check_log = check_log_pre_data,
    color_g = "Project"
  )
```

```{r, eval = TRUE, echo = FALSE, fig.cap = f9}
# Generate pre-bridging PCA using bridging sample

knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/bridges_pre_bridging.png"
  ),
  error = FALSE
)
```

```{r, eval = FALSE, echo = TRUE}
### Format post-bridging data

## Keep the data following BridgingRecommendation
npx_post_br_reco <- npx_br_data_clean |>
  # Not necessary if olink_normalization() is run with format = TRUE
  dplyr::filter(
    .data[["BridgingRecommendation"]] != "NotBridgeable"
  ) |>
  dplyr::mutate(
    NPX = dplyr::case_when(
      .data[["BridgingRecommendation"]] == "MedianCentering" ~
        .data[["MedianCenteredNPX"]],
      .data[["BridgingRecommendation"]] == "QuantileSmoothing" ~
        .data[["QSNormalizedNPX"]],
      .default = .data[["NPX"]]
    )
  )
```

```{r pca_post_SC, eval = FALSE, echo = TRUE}
# Generate PCA plot of post-bridging data from Sample Controls

npx_post_br_reco |>
  dplyr::filter(
    .data[["SampleType"]] == "SAMPLE_CONTROL"
  ) |>
  dplyr::mutate(
    SampleID = paste(.data[["Project"]], .data[["SampleID"]], sep = "_")
  ) |>
  OlinkAnalyze::olink_pca_plot(
    color_g = "Project",
    check_log = check_log_br_data_clean
  )
```

```{r, eval = TRUE, echo = FALSE, fig.cap = f10}
# Generate PCA plot of post-bridging data from Sample Controls

knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/SCs_post_bridging.png"
  ),
  error = FALSE
)
```

```{r, eval = FALSE, echo = TRUE}
# Generate PCA plot of post-bridging data from bridging samples

npx_post_br_reco |>
  dplyr::filter(
    .data[["SampleType"]] == "SAMPLE"
  ) |>
  dplyr::filter(
    .data[["SampleID"]] %in% .env[["overlapping_samples"]]
  ) |>
  dplyr::mutate(
    SampleID = paste0(.data[["Project"]], .data[["SampleID"]])
  ) |>
  OlinkAnalyze::olink_pca_plot(
    color_g = "Project",
    check_log = check_log_br_data_clean
  )
```

```{r, echo = FALSE, fig.cap = f11}
# Generate PCA plot of post-bridging data from bridging samples

knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/bridges_post_bridging.png"
  ),
  error = FALSE
)
```

## Exporting Normalized Data

The normalized non-reference data set (e.g. Explore 3072) can be exported using
`arrow::write_parquet()` to create a long format Olink NGS file.

```{r, eval = FALSE, echo = TRUE}
### Export normalized data

# Here we will export the full dataset including internal and external controls
# to follow Olink Software Export File formatting, but the data can be filtered
# to include only samples and assays of interest prior to export.
df <- npx_br_data |>
  dplyr::filter(
    .data[["Project"]] == "Explore_3072"
  ) |>
  arrow::as_arrow_table()

df$metadata$FileVersion <- "NA"
df$metadata$ExploreVersion <- "NA"
df$metadata$ProjectName <- "NA"
df$metadata$SampleMatrix <- "NA"
df$metadata$DataFileType <- "R Package Export File"
df$metadata$ProductType <- "Explore3072"
df$metadata$Product <- "Explore3072"

arrow::write_parquet(
  x = df,
  sink = "path_to_output.parquet"
)
```

## FAQs

### Overlapping Assays within products

Both the Explore 3072 and Explore HT products contain assays that appear
multiple times in the product, known as overlapping assays or correlation
assays. In Explore 3072, these present as overlapping assays across panels. In
Explore HT, these are overlapping assays across blocks. These assays are
included for QC purposes and allow users to evaluate data performance across
panels in Explore 3072 and across blocks in Explore HT. Within each product, the
assays contain unique OlinkID values for each of their corresponding panels and
blocks in Explore 3072 and Explore HT, respectively.

IL6, IL8 (CXCL8), and TNF are included in the Cardiometabolic, Oncology,
Neurology and Inflammation panels, while IDO1, LMOD1, and SCRIB are included in
the Cardiometabolic II, Oncology II, Neurology II and Inflammation II panels.
Each correlation assay is measured four times in an Olink Explore 3072 run. In
Explore HT, GBP1 and MAPK1 serve as overlapping assays and are measured three
times in a run.

### Downstream Analysis

Olink Analyze statistical analysis functions default to use the data in the
`NPX` column. To use the recommended normalized data, set the
`olink_normalization()` format argument to `TRUE` when performing bridge
normalization. The `NPX` column values will be replaced with the recommended
normalized values corresponding to the normalization approach identified in the
`BridgingRecommendation` column. Datapoints identified as `NotBridgeable` will
retain their original NPX values and OlinkIDs. Assays that are not overlapping
between products will be identified as "NotOverlapping" and will retain their
original NPX values and OlinkIDs. External controls will be removed from the
formatted dataframe. Sample IDs will be concatenated with their corresponding
project IDs to ensure that all samples are analyzed individually. Additionally,
to ensure that overlapping assays within products are analyzed individually,
OlinkID can be temporarily assigned to the concatenated version of the OlinkIDs
in the bridgeable assays. The `OlinkID_PRODUCT`, `MedianCenteredNPX`, and
`QSNormalizedNPX` columns will be removed. This dataframe can then be used in
any downstream analysis function within Olink Analyze. 

Alternatively, if the `olink_normalization()` function is run with the format
argument set to 'FALSE', then the `NPX` column will not be modified and the
non-normalized NPX data will be used by default. To use the recommended
normalized data, `dplyr::mutate()` can be used to reassign the NPX data.
Additionally, to ensure that overlapping assays within products are analyzed
individually, `OlinkID` can be temporarily assigned to the concatenated version
of the OlinkIDs. This dataframe can then be used in any downstream analysis
function within Olink Analyze. 

Assays which are not recommended for bridging should be analyzed separately and
can be combined using a meta-analysis. Depending on the study design these
assays can either be excluded from the downstream analysis or the assays can be
treated as non-overlapping assays.

```{r, eval = FALSE, echo = TRUE}
### npx_post_br_clean generated by olink_normalization with format = TRUE

## Option 1: Exclude non-bridgeable assays from both products
npx_recommended <- npx_br_data_clean |>
  dplyr::filter(
    .data[["BridgingRecommendation"]] != "NotBridgeable"
  )

## Option 2: Analyze non-bridgeable assays separately
# No further preprocessing needed
npx_recommended <- npx_br_data_clean
```

```{r, eval = FALSE, echo = TRUE}
### npx_post_br_clean generated by olink_normalization with format = FALSE

## Option 1: Exclude non-bridgeable assays from both products
npx_recommended <- npx_br_data_clean |>
  dplyr::mutate(
    NPX_original = .data[["NPX"]]
  ) |>
  dplyr::filter(
    .data[["BridgingRecommendation"]] != "Not Bridgeable"
  ) |>
  dplyr::mutate(NPX = dplyr::case_when(
    .data[["BridgingRecommendation"]] == "MedianCentering" ~
      .data[["MedianCenteredNPX"]],
    .data[["BridgingRecommendation"]] == "QuantileSmoothing" ~
      .data[["QSNormalizedNPX"]],
    .default = .data[["NPX"]]
  )
  ) |>
  dplyr::mutate(
    OlinkID_HT = .data[["OlinkID"]]
  ) |>
  dplyr::mutate(
    OlinkID = paste0(.data[["OlinkID"]], "_", .data[["OlinkID_E3072"]])
  )

# Option 2: Analyze non bridgeable assays separately
npx_recommended <- npx_br_data_clean |>
  dplyr::mutate(
    NPX_original = .data[["NPX"]]
  ) |>
  dplyr::mutate(
    NPX = dplyr::case_when(
      .data[["BridgingRecommendation"]] == "MedianCentering" ~
        .data[["MedianCenteredNPX"]],
      .data[["BridgingRecommendation"]] == "QuantileSmoothing" ~
        .data[["QSNormalizedNPX"]],
      .default = .data[["NPX"]]
    )
  ) |>
  dplyr::mutate(
    OlinkID_HT = .data[["OlinkID"]]
  ) |>
  dplyr::mutate(
    OlinkID = dplyr::if_else(
      .data[["BridgingRecommendation"]] != "NotBridgeable",
      paste0(.data[["OlinkID"]], "_", .data[["OlinkID_E3072"]]),
      # Concatenated OlinkID for bridgeable Assays
      dplyr::if_else(.data[["Project"]] == "Explore HT",
                     # replace with reference project name as set in function
                     .data[["OlinkID"]],
                     .data[["OlinkID_E3072"]]
      )
    )
  )
```

## Contact Us

We are always happy to help. Email us with any questions:

-   biostat\@olink.com for statistical services and general stats
    questions

-   support\@olink.com for Olink lab product and technical support

-   info\@olink.com for more information

## Legal Disclaimer

© `r format(Sys.Date(), "%Y")` Olink Proteomics AB, part of Thermo Fisher
Scientific.

Olink products and services are For Research Use Only. Not for use in diagnostic
procedures.

All information in this document is subject to change without notice. This
document is not intended to convey any warranties, representations and/or
recommendations of any kind, unless such warranties, representations and/or
recommendations are explicitly stated.

Olink assumes no liability arising from a prospective reader’s actions based on
this document.

OLINK, NPX, PEA, PROXIMITY EXTENSION, INSIGHT and the Olink logotype are
trademarks registered, or pending registration, by Olink Proteomics AB. All
third-party trademarks are the property of their respective owners.

Olink products and assay methods are covered by several patents and patent
applications [https://www.olink.com/patents/](https://olink.com/patents/).

---
title: "Outlier Exclusion Vignette"
author: "Olink DS team"
date: "`r Sys.Date()`"
output: 
  html_vignette:
    toc: true
    toc_depth: 3
    includes:
      in_header: ../man/figures/logo.html
vignette: >
  %\VignetteIndexEntry{Outlier Exclusion Vignette}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE, echo = FALSE, eval = TRUE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  tidy = FALSE,
  tidy.opts = list(width.cutoff = 95),
  fig.width = 6,
  fig.height = 3,
  message = FALSE,
  warning = FALSE,
  time_it = TRUE,
  fig.align = "center"
)
knitr::opts_chunk$set(fig.pos = "H")
knitr::opts_chunk$set(fig.align = "center")
knitr::opts_knit$set(eval.after = "fig.cap")
```

## Introduction

```{r Outlier_data, include = FALSE, error = TRUE, message = FALSE, warning = FALSE}
# Use provided example dataset (npx_data1)
npx_data1 <- OlinkAnalyze::npx_data1

# NPX file preprocessing

# Generate check log
check_log_npx_data1 <- OlinkAnalyze::check_npx(
  df = npx_data1
)

# Clean NPX
npx_data1_clean <- OlinkAnalyze::clean_npx(
  df = npx_data1,
  check_log = check_log_npx_data1
)

# Generate check log on cleaned data
check_log_npx_data1_clean <- OlinkAnalyze::check_npx(
  df = npx_data1_clean
)

# Create Dataset with outliers
outlier_data <- npx_data1_clean |>
  dplyr::mutate(
    NPX = dplyr::if_else(
      .data[["SampleID"]] == "A25",
      .data[["NPX"]] + 4,
      .data[["NPX"]]
    )
  ) |>
  dplyr::mutate(
    NPX = dplyr::if_else(
      .data[["SampleID"]] == "A52",
      .data[["NPX"]] - 4,
      .data[["NPX"]]
    )
  )

group_data <- npx_data1_clean |>
  dplyr::mutate(
    NPX = dplyr::if_else(
      .data[["Site"]] == "Site_D",
      .data[["NPX"]] + 3,
      .data[["NPX"]]
    )
  )

# Clean up environment
rm(check_log_npx_data1, npx_data1)
```

This vignette describes how to use Olink® Analyze to evaluate a dataset for the
presence of outliers. When performing statistical analyses, it is important to
establish the presence of any outlier samples in the data prior to statistical
analysis. There are many reasons why a sample might be an outlier, it could be
due to a data entry or measurement error (i.e. labeling a control sample as a
disease sample), sampling problems or unusual conditions (i.e. contamination),
or natural variation. In many parametric statistics tests the mean of each group
is used to determine differences between groups. Since the mean is highly
sensitive to outliers, it is important to examine datasets for outliers prior to
analysis as these outliers could have a large influence on the statistical
results.

In Olink Analyze, there are three visualization functions that can be used to
identify potential outlier samples. In this vignette, you will learn how to use
`olink_pca_plot()`, `olink_dist_plot()` , and `olink_qc_plot()` to identify and
remove outliers from a dataset.

For demonstration purposes two outlier datasets have been generated to
demonstrate large outlier effects by adjusting the NPX values for specific
Samples or groups.

```{r dataset_generation, eval = FALSE, message = FALSE, warning = FALSE}
# Use provided example dataset (npx_data1)
npx_data1 <- OlinkAnalyze::npx_data1

# NPX file preprocessing

# Generate check log
check_log_npx_data1 <- OlinkAnalyze::check_npx(
  df = npx_data1
)

# Clean NPX
npx_data1_clean <- OlinkAnalyze::clean_npx(
  df = npx_data1,
  check_log = check_log_npx_data1
)

# Generate check log on cleaned data
check_log_npx_data1_clean <- OlinkAnalyze::check_npx(
  df = npx_data1_clean
)

# Create Dataset with outliers
outlier_data <- npx_data1_clean |>
  dplyr::mutate(
    NPX = dplyr::if_else(
      .data[["SampleID"]] == "A25",
      .data[["NPX"]] + 4,
      .data[["NPX"]]
    )
  ) |>
  dplyr::mutate(
    NPX = dplyr::if_else(
      .data[["SampleID"]] == "A52",
      .data[["NPX"]] - 4,
      .data[["NPX"]]
    )
  )

group_data <- npx_data1_clean |>
  dplyr::mutate(
    NPX = dplyr::if_else(
      .data[["Site"]] == "Site_D",
      .data[["NPX"]] + 3,
      .data[["NPX"]]
    )
  )
```

## PCA Plot

### Overview of PCA Plot

Principal Component Analysis (PCA) is a dimensional reduction technique. PCA
plots can be particularly useful to visualize variability within high
dimensional data by plotting the data along the axes of greatest variation. The
first two principal components make up the largest axes of variance between
samples. In `olink_pca_plot()` samples are clustered together based on
similarities in overall expression patterns of the measured proteins. These
samples can be colored by any categorical variable to determine which biological
factors may be contributing to global effects across the samples. PCA plots can
be used to:

-   Identify individual outlier samples (**Figure 1A**)

-   Identify groups of outliers (**Figure 1B**)

-   Identify batch effects (see Bridging Vignette)

Regardless of what the PCA is being used for, PCA plots are great tools to get
an overview of the data prior to analysis and pick up on any global trends.
These samples are not necessarily outliers but might be indicative of a global
difference between groups.

```{r Outlier_example_code, eval = FALSE, fig.show='hide'}
p1 <- OlinkAnalyze::olink_pca_plot(
  df = outlier_data,
  label_samples = TRUE,
  quiet = TRUE,
  check_log = check_log_npx_data1_clean
)

p2 <- OlinkAnalyze::olink_pca_plot(
  df = group_data,
  color_g = "Site",
  quiet = TRUE,
  check_log = check_log_npx_data1_clean
)

ggpubr::ggarrange(
  p1[[1L]],
  p2[[1L]],
  nrow = 1L,
  labels = "AUTO"
)
```

```{r Outlier_Example, echo = FALSE, fig.cap = fcap}
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/PCA_Outlier_Fig1.png"
  ),
  error = FALSE
)

fcap <- paste("**Figure 1** **A.** PCA can be used to identify individual",
              "outlier samples as shown by samples A25 and A52. **B.** PCA can",
              "be used to identify difference in groups as seen by Site_D",
              "samples. This is not suggesting Site_D is an outlier, but",
              "rather that there may be a global difference between sites.")
```

### How to use PCA plot to identify an outlier

As shown above, PCA plots can be used to identify global differences in specific
samples or sets of samples. Often times these samples can be attributed to
natural variations, but sometimes these samples are outliers due to technical or
sample specific issues. To determine if a sample is a true outlier and should be
excluded, consider the following:

-   Did the sample pass QC? - Sometimes samples that are outliers and have a QC
warnings may indicate sample or technical issues. For example, a buffer sample
will often flag on QC and be plotted as an outlier as there are no proteins in
the sample.

-   How far is the sample from other samples? - Samples variability within a
specific group may be larger or there may be global variables within a group. In
this case it is important to consider the sample within the context of the
project.

-   Does the sample appear as an outlier by other plots? - If a sample is an
outlier in the PCA, NPX distribution, and QC plots, that this might indicate a
true outlier.

-   Is the sample an outlier on all panels? - Some samples may perform better on
specific samples. In the next section we will explain how to view samples by
panel.

PCA plots can be generated using `olink_pca_plot()` and specifying the color for
each sample using the `color_g` argument. By default the samples will be colored
by QC_Warning. Prior to generating the PCA plot, the duplicate SampleIDs (often
Control samples) will need to be renamed or filtered out.

```{r PCA_treatment, eval = FALSE}
OlinkAnalyze::olink_pca_plot(
  df = npx_data1_clean,
  color_g = "Treatment",
  check_log = check_log_npx_data1_clean
)
```

```{r PCA_treatment_fig, echo = FALSE}
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/PCA_Treatment.png"
  ),
  error = FALSE
)
```

In this dataset there do not appear to be any outliers in the PCA plot.

### PCA plot by panel

When multiple panels are run, there is a chance a sample may be an outlier on
one panel. To get a global view of the samples per Panel, the `byPanel` argument
can be specified.

```{r PCA_Panel, eval = FALSE}
# Use provided example dataset (npx_data2)

npx_data2 <- OlinkAnalyze::npx_data2

# NPX file preprocessing

# Generate check log
check_log_npx_data2 <- OlinkAnalyze::check_npx(
  df = npx_data2
)

# Clean NPX
npx_data2_clean <- OlinkAnalyze::clean_npx(
  df = npx_data2,
  check_log = check_log_npx_data2
)

# Generate check log on cleaned data
check_log_npx_data2_clean <- OlinkAnalyze::check_npx(
  df = npx_data2_clean
)

# Specify by panel
OlinkAnalyze::olink_pca_plot(
  df = npx_data2_clean,
  byPanel = TRUE,
  check_log = check_log_npx_data2_clean
)
```

```{r PCA_Panel_fig, echo = FALSE}
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/PCA_Panel.png"
  ),
  error = FALSE
)
```

The PCA plots will be saved in a list of ggplot objects and each can be viewed
individually using `[[n]]` syntax as shown below.

```{r PCA_object, eval = FALSE}
# Save the PCA plot to a variable
# By panel
# quiet argument suppresses export
pca_plots <- OlinkAnalyze::olink_pca_plot(
  df =  npx_data2_clean,
  byPanel = TRUE,
  quiet = TRUE,
  check_log = check_log_npx_data2_clean
)

pca_plots[[1L]] # Cardiometabolic PCA
pca_plots[[2L]] # Inflammation PCA
```

The plots above show an example where there are not any clear outliers in the
PCA. For the purposes of this vignette, we have also generated data where 2
samples appear as outliers.

```{r Outlier_PCA, echo = FALSE}
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/Outlier_PCA.png"
  ),
  error = FALSE
)
```

However from this plot, we can not identify which two samples are outliers. In
the next section we will go over how to label outliers in the plot.

### Labeling outliers

There are two ways to label the samples in the PCA plot. The first way is to use
the `label_samples` argument. This argument will label all samples by replacing
the dot with the SampleID.

```{r, eval = FALSE}
OlinkAnalyze::olink_pca_plot(
  df = outlier_data,
  label_samples = TRUE,
  check_log = check_log_npx_data1_clean
)
```

```{r Label_samples, echo = FALSE}
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/label_samples_pca.png"
  ),
  error = FALSE
)
```

Here we can see that samples A25 and A52 appear as outliers. This method can be
useful when there is clear separation in samples. However it can be difficult to
identify additional trends when all samples are labeled. In this case the
samples must also be visually identified as opposed to programmatically
extracted from the plot. For a cleaner plot with only the outliers labeled, we
can use `outlierDefX`, `outlierDefY`, `outlierLines`, and `label_outliers`.
These arguments will plot lines at a number of standard deviations from the mean
of the plotted PC and label the samples outside of these lines. The values of
`outlierDefX` and `outlierDefY` will need to be generated by the users and may
require some manual adjustment to determine the correct number to highlight the
outliers.

```{r, eval = FALSE}
if (requireNamespace(package = "ggrepel", quietly = TRUE)) {
  OlinkAnalyze::olink_pca_plot(
    df = outlier_data,
    outlierDefX = 3L,
    outlierDefY = 3L,
    outlierLines = TRUE,
    label_outliers = TRUE,
    check_log = check_log_npx_data1_clean
  )
}
```

```{r outlier_line_pca, echo = FALSE}
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/outlier_line_pca.png"
  ),
  error = FALSE
)
```

To remove the lines and just keep the outliers labelled, `outlierLines` can be
set to False.

```{r, eval = FALSE}
if (requireNamespace(package = "ggrepel", quietly = TRUE)) {
  OlinkAnalyze::olink_pca_plot(
    df = outlier_data,
    outlierDefX = 3L,
    outlierDefY = 3L,
    outlierLines = FALSE,
    label_outliers = TRUE,
    check_log = check_log_npx_data1_clean
  )
}
```

Once the correct outliers have been highlighted in the graph, we can then
programmatically extract the outlier SampleIDs using *dplyr*.

```{r}
if (requireNamespace(package = "ggrepel", quietly = TRUE)) {
  outliers_pca_labeled <-
    OlinkAnalyze::olink_pca_plot(
      df = outlier_data,
      outlierDefX = 3L,
      outlierDefY = 3L,
      outlierLines = FALSE,
      label_outliers = TRUE,
      quiet = TRUE,
      check_log = check_log_npx_data1_clean
    )

  outliers_pca_labeled[[1L]]$data |>
    dplyr::filter(
      .data[["Outlier"]] == TRUE
    ) |>
    dplyr::select(
      dplyr::all_of("SampleID")
    ) |>
    dplyr::distinct()
}
```

## NPX Distribution Plot

### Overview of NPX Distribution Plot

NPX distribution plots generated by `olink_dist_plot()` consist of box and 
whisker plots of NPX distribution for each sample. These boxplots can be used to
determine if a sample has an unusually large or small distribution or if a
samples NPX distribution is shifted compared to other samples in the study. When
used in combination with PCA and QC plots, NPX distribution plots can give an
additional dimension of data to help identify outlier samples or global trends
within groups of samples.

### How to use NPX distribution plot to identify an outlier

In NPX distribution plot an outlier may show one of the following
characteristics:

-   A larger NPX distribution than other samples suggesting that the sample may
contain a global difference in proteins, potentially indicating a different
sample phenotype or technical error. 
-   A smaller NPX distribution than other samples suggesting that the sample may
contain less protein than other samples, often seen when running buffer samples.
-   A shift in NPX distribution in one or more samples suggesting a difference
in overall protein concentration, a difference in sample collection methodology,
or a batch effect.

If we look at a subset of the outlier data from the PCA example, we can see that
A25 and A52 have shifted NPX distributions, which in combination with the PCA
plot, suggest that these samples may be potential outliers. If there are many
samples in a project, it can be helpful to look at a subset of the samples at a
time as shown below.

```{r, eval = FALSE}
outlier_data_dist <- outlier_data |>
  dplyr::filter(
    .data[["SampleID"]] %in% c("A25", "A52", "A1", "A2", "A3", "A5",
                               "A15", "A16", "A18", "A19", "A20")
  )

OlinkAnalyze::olink_dist_plot(
  df = outlier_data_dist,
  check_log = check_log_npx_data1_clean
)
```

```{r, echo = FALSE}
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/dist_boxplot.png"
  ),
  error = FALSE
)
```

NPX distribution plots can also be useful in identifying group trends, such as a
difference in site D as shown in the figure below. The color of the bars can be
altered using the `color_g` argument.

```{r, eval = FALSE}
group_data_dist <- group_data |>
  # Only visualizing 2 sites to see all samples
  dplyr::filter(
    .data[["Site"]] %in% c("Site_A", "Site_D")
  )

OlinkAnalyze::olink_dist_plot(
  df = group_data_dist,
  color_g = "Site",
  check_log = check_log_npx_data1_clean
)
```

```{r, echo = FALSE}
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/site_boxplot.png"
  ),
  error = FALSE
)
```

In this case, the shift in NPX distribution could be biologically meaningful or
could indicate a sample or technical issue. There are several biological cases
where the total protein concentration in a sample may be larger in one group
than another. However, in some cases the difference in protein concentration can
also lead to skewed results, in which case it may be helpful to normalize the
data for the changes in protein concentration by performing a median adjustment
as shown below.

```{r, eval = FALSE}
# Calculate SampleID Median NPX
median_npx <- group_data |>
  dplyr::group_by(
    .data[["SampleID"]]
  ) |>
  dplyr::summarise(
    Median_NPX = median(.data[["NPX"]])
  ) |>
  dplyr::ungroup()

# Adjust by sample median
adjusted_data <- group_data |>
  dplyr::inner_join(
    median_npx,
    by = "SampleID"
  ) |>
  dplyr::mutate(
    NPX = .data[["NPX"]] - .data[["Median_NPX"]]
  )

adjusted_data_dist <- adjusted_data |>
  # Only visualizing 2 sites to see all samples
  dplyr::filter(
    .data[["Site"]] %in% c("Site_A", "Site_D")
  )

OlinkAnalyze::olink_dist_plot(
  df = adjusted_data_dist,
  color_g = "Site",
  check_log = check_log_npx_data1_clean
)
```

```{r, echo=FALSE}
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/sample_med_boxplot.png"
  ),
  error = FALSE
)
```

## QC Plot (IQR vs Sample Median)

### Overview of QC Plot

Often there are too many samples to identify outliers using `olink_dist_plot()`.
In this case, `olink_qc_plot()` offers an alternative way to visualize the NPX
distribution per sample. In this plot, the sample median and sample
interquartile range (IQR) are plotted to visualize where the sample is centered
and how much variability is within the sample.

### How to use QC plot to identify an outlier

`olink_qc_plot()` contains similar features to `olink_pca_plot()` and can be
used in a similar way. These samples can be colored by any categorical variable
to determine which biological factors may be contributing to global effects
across the samples or individual sample outlier. QC plots can be used to
identify individual outlier samples or identify groups of outliers. In the QC
plot an outlier may show one or more of the following characteristics:

-   A larger IQR than other samples suggesting that the sample may contain a
global difference in proteins, potentially indicating a different sample
phenotype or technical error. 
-   A smaller IQR than other samples suggesting that the sample may contain less
protein than other samples, often seen when running buffer samples.
-   A shift in sample median in one or more samples suggesting a difference in
overall protein concentration, a difference in sample collection methodology, or
a batch effect.

Using the outlier data from the previous plots, we can see that sample A52 has a
lower sample median and sample A25 has a higher sample median in both panels.
Sample A48 has the highest IQR of all samples in the Inflammation panel.
However, we can see many other samples approaching the line threshold line
(default of 3 standard deviation from the mean IQR or sample median), suggesting
that this sample may not be a true outlier.

```{r, eval = FALSE}
if (requireNamespace(package = "ggrepel", quietly = TRUE)) {
  OlinkAnalyze::olink_qc_plot(
    df = outlier_data,
    label_outliers = TRUE,
    check_log = check_log_npx_data1_clean
  )
}
```

```{r, echo=FALSE}
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/qc_plot.png"
  ),
  error = FALSE
)
```

With a standard deviation of 3 and assuming a normal distribution of samples, it
is expected that over 99% of the data will lie within 3 standard deviations from
the mean, however depending on the groups and samples within the study, there
may be global shifts which will result in one or more samples outside of the 3
SD line. These lines should be used as guidelines and not strict thresholds of
outliers.

Similar to what was shown in the NPX distribution plot example, the QC plot can
also be used to see changes in specific groups. In the example below, the
samples are colored by site and Site D appears to have samples with higher
sample median. 

```{r, eval = FALSE}
if (requireNamespace(package = "ggrepel", quietly = TRUE)) {
  OlinkAnalyze::olink_qc_plot(
    df = group_data,
    color_g = "Site",
    label_outliers = TRUE,
    check_log = check_log_npx_data1_clean
  )
}
```

```{r echo = FALSE}
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/qc_site_plot.png"
  ),
  error = FALSE
)
```

### Labeling outliers 

To change the threshold and outliers that are labeled, we can use
`median_outlierDef`, `IQR_outlierDef`, `outlierLines`, and `label_outliers`.
These arguments will plot lines at a number of standard deviations from the mean
of the sample median or IQR and label the samples outside of these lines. The
values of `median_outlierDef` and `IQR_outlierDef` default to 3 and may require
some manual adjustment to determine the correct number to highlight the
outliers.

```{r, eval = FALSE}
if (requireNamespace(package = "ggrepel", quietly = TRUE)) {
  OlinkAnalyze::olink_qc_plot(
    df = outlier_data,
    median_outlierDef = 2L,
    IQR_outlierDef = 4L,
    outlierLines = TRUE,
    label_outliers = TRUE,
    check_log = check_log_npx_data1_clean
  )
}
```

```{r, echo = FALSE}
knitr::include_graphics(
  path = normalizePath(
    path = "../man/figures/qc_label_plot.png"
  ),
  error = FALSE
)
```

To remove the lines and just keep the outliers labelled `outlierLines` can be
set to False.

```{r, eval = FALSE}
if (requireNamespace(package = "ggrepel", quietly = TRUE)) {
  OlinkAnalyze::olink_qc_plot(
    df = outlier_data,
    median_outlierDef = 2L,
    IQR_outlierDef = 4L,
    outlierLines = FALSE,
    label_outliers = TRUE,
    check_log = check_log_npx_data1_clean
  )
}
```

Once the correct outliers have been highlighted in the graph, we can then
programmatically extract the outlier SampleIDs using *dplyr*.

```{r}
if (requireNamespace(package = "ggrepel", quietly = TRUE)) {
  outliers_qc_labeled <- OlinkAnalyze::olink_qc_plot(
    df = outlier_data,
    median_outlierDef = 2L,
    IQR_outlierDef = 4,
    outlierLines = FALSE,
    label_outliers = TRUE,
    check_log = check_log_npx_data1_clean
  )

  outliers_qc_labeled$data |>
    dplyr::filter(
      .data[["Outlier"]] == TRUE
    ) |>
    dplyr::select(
      dplyr::all_of("SampleID")
    ) |>
    dplyr::distinct()
}
```

## Interpreting and Handling Outliers

### When should outliers be removed

After reviewing these plots, a list of potential outliers may be generated.
Whether or not these outliers should be excluded depends on how different from
the other samples the potential outliers appear and if the outliers can be
traced to a biological, sample specific, or technical issue. An outlier could
also be specific to a particular panel, in which case the outlier either be
excluded from just the panel on which it is an outlier or excluded from all
panels.

In the case of a biological issue, it may be useful to keep the potential
outlier within the study as the sample has biological meaning, however
additional normalization may be needed. For example, in a diabetes study,
patients with severe diabetes may have higher protein in their urine as compared
to control subject. In this case it could be useful to normalize based on total
protein concentration or median NPX to set all values within the context of the
study.

Another example is in the case of multiple batches, one batch may appear
to cluster differently from another batch. In this case additional normalization
such as bridging is needed to bridge the studies to the same scale.

## Contact Us

We are always happy to help. Email us with any questions:

-   biostat\@olink.com for statistical services and general stats
    questions

-   support\@olink.com for Olink lab product and technical support

-   info\@olink.com for more information

## Legal Disclaimer

© `r format(Sys.Date(), "%Y")` Olink Proteomics AB, part of Thermo Fisher
Scientific.

Olink products and services are For Research Use Only. Not for use in diagnostic
procedures.

All information in this document is subject to change without notice. This
document is not intended to convey any warranties, representations and/or
recommendations of any kind, unless such warranties, representations and/or
recommendations are explicitly stated.

Olink assumes no liability arising from a prospective reader’s actions based on
this document.

OLINK, NPX, PEA, PROXIMITY EXTENSION, INSIGHT and the Olink logotype are
trademarks registered, or pending registration, by Olink Proteomics AB. All
third-party trademarks are the property of their respective owners.

Olink products and assay methods are covered by several patents and patent
applications [https://www.olink.com/patents/](https://olink.com/patents/).

---
title: "Calculating LOD from Olink® Explore data" 
output: 
  html_vignette:
    toc: true
    toc_depth: 3
    includes:
      in_header: ../man/figures/logo.html
vignette: >
  %\VignetteIndexEntry{Calculating LOD from Olink® Explore data}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
date: 'Compiled: `r format(Sys.Date(), "%B %d, %Y")`'
editor_options: 
  markdown: 
    wrap: 72
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  tidy = FALSE,
  tidy.opts = list(width.cutoff = 95),
  fig.width = 6,
  fig.height = 3,
  message = FALSE,
  warning = FALSE,
  time_it = TRUE,
  fig.align = "center"
)
```

## Introduction

This tutorial describes how to use Olink^®^ Analyze to integrate Limit of
Detection (LOD) into Olink^®^ Explore HT, Olink^®^ Reveal, and Olink^®^ Explore
384/3072 datasets. Although it is recommended to use all Olink Explore and Olink
Reveal data in downstream analyses, LOD information can be useful when 
performing technical evaluations of a dataset.

In this tutorial, you will learn how to use `olink_lod()` to add LOD information
to your Olink Explore or Olink Reveal dataset. Note that Olink Analyze does not 
contain example Olink Explore HT, Olink Reveal, or Olink Explore 384/3072 
datasets within the package, so external data will be necessary for the code 
below to work. The external data should contain internal and external controls 
for proper calculation and normalization. All file paths should be replaced 
with a path to your data and fixed LOD reference file (if applicable).

## Integrating LOD

Limit of Detection (LOD) is a metric that indicates the lowest measurable value
of a protein. LOD can be helpful when performing technical evaluations of NPX™
datasets, such as calculating CVs. As a note, LOD is less important in
downstream statistical analyses as values under LOD typically converge across
groups. As such, including data below LOD is unlikely to increase the risk of
false positive discoveries. Furthermore, data below LOD can be instrumental in
downstream analyses such as biomarker discovery as a protein may be well
expressed in one group and not measured in another group. In this case, this
protein can be a strong biomarker candidate for specific groups.

LOD can be added to Olink Explore or Olink Reveal NPX datasets using
`olink_lod()`. This function can calculate LOD from an NPX dataset using the
dataset's negative controls or a list of predetermined fixed LOD values
(available in the Document Download Center at
[olink.com](https://olink.com/knowledge/documents)). As the default setting,
`olink_lod()` will calculate LOD using a dataset's negative controls.

Olink Explore and Olink Reveal data are delivered as either plate control (PC) 
normalized or intensity normalized (the normalization type employed is 
indicated in the NPX file column Normalization), where the latter is dependent 
on the assumption that the analyzed samples are randomized. These are reported 
in the two respective columns, NPX and PCNormalizedNPX. Please notice that for 
PC normalized datasets the content in these two columns will be identical, 
while for intensity normalized datasets the NPX column will include the 
intensity normalized values. Similarly, the `olink_lod()` function adds two 
columns to your dataset; LOD and PCNormalizedLOD, respectively. For a PC 
normalized dataset, the content in these two columns will be identical, while 
for an intensity normalized dataset the LOD column will contain intensity 
normalized LOD values. Examples of results for plate control and intensity 
normalization are shown in the tables below.

```{r, echo = FALSE}
set.seed(1234)

# Load example dataset (npx_data1)
npx_data1 <- OlinkAnalyze::npx_data1

# NPX file preprocessing
## Generate check log
check_log_npx_data1 <- OlinkAnalyze::check_npx(
  df = npx_data1
)

## Clean NPX
npx_data1_clean <- OlinkAnalyze::clean_npx(
  df = npx_data1,
  check_log = check_log_npx_data1
)

## Generate check log on cleaned data
check_log_npx_data1_clean <- OlinkAnalyze::check_npx(
  df = npx_data1_clean
)

table1 <- npx_data1_clean |>
  dplyr::slice_head(
    n = 6L
  ) |>
  dplyr::select(
    -dplyr::all_of(
      c("Index", "MissingFreq", "Panel_Version", "QC_Warning", "Subject",
        "Treatment", "Site", "Time", "Project", "Panel", "PlateID")
    )
  ) |>
  dplyr::mutate(
    Count = round(
      x = .data[["NPX"]] * (100L + sample(x = seq(from = -5L, to = 15L),
                                          size = 1L))
    )
  ) |>
  dplyr::mutate(
    SampleType = "SAMPLE"
  ) |>
  dplyr::mutate(
    Normalization = "Plate control"
  ) |>
  dplyr::mutate(
    NPX = round(x = .data[["NPX"]], digits = 2L)
  ) |>
  dplyr::mutate(
    LOD = round(x = .data[["LOD"]], digits = 2L)
  ) |>
  dplyr::mutate(
    PCNormalizedNPX = .data[["NPX"]]
  ) |>
  dplyr::mutate(
    PCNormalizedLOD = .data[["LOD"]]
  ) |>
  dplyr::select(
    dplyr::all_of(
      c("SampleID", "SampleType", "OlinkID", "UniProt", "Assay", "Count", "NPX",
        "PCNormalizedNPX", "Normalization", "LOD", "PCNormalizedLOD")
    )
  )

table1 |>
  knitr::kable(
    caption = "Example results from Plate Control Normalized Project"
  ) |>
  kableExtra::kable_styling(
    font_size = 10L
  )

table1 |>
  dplyr::mutate(
    Normalization = "Intensity"
  ) |>
  dplyr::mutate(
    NPX = round(x = .data[["NPX"]] + 4.16, digits = 2L)
  ) |>
  dplyr::mutate(
    LOD = round(x = .data[["LOD"]] + 4.16, digits = 2L)
  ) |>
  dplyr::select(
    dplyr::all_of(
      c("SampleID", "SampleType", "OlinkID", "UniProt", "Assay", "Count", "NPX",
        "PCNormalizedNPX", "Normalization", "LOD", "PCNormalizedLOD")
    )
  ) |>
  knitr::kable(
    caption = "Example results from Intensity Normalized Project"
  ) |>
  kableExtra::kable_styling(
    font_size = 10
  )
```

## Import Olink NGS datasets

Olink Next Generation Sequencing (NGS) datasets are standard Olink Explore HT,
Olink Reveal, and Olink Explore 384/3072 NPX tables. The `read_NPX()` function
can be used to import an NPX file in parquet form as generated by Olink
Software. More information on using `read_NPX()` can be found in the
[Olink Analyze Overview tutorial](https://CRAN.R-project.org/package=OlinkAnalyze).

```{r npx_data_for_lod, eval = FALSE, message = FALSE, warning = FALSE}
# Preprocessing steps for both fixed LOD and Negative Control LOD integration

## Load NPX file
df_npx <- OlinkAnalyze::read_NPX(
  filename = "Path_to/Explore_NPX_file.parquet"
)

## Check NPX data
check_log_df_npx <- OlinkAnalyze::check_npx(
  df = df_npx
)

## Clean NPX data
df_npx_clean <- OlinkAnalyze::clean_npx(
  df = df_npx,
  check_log = check_log_df_npx,
  # do not remove controls or warnings to ensure LOD can be calculated correctly
  remove_control_assay = FALSE,
  remove_control_sample = FALSE,
  remove_assay_warning = FALSE,
  remove_qc_warning = FALSE
)

## Generate check log on cleaned data
check_log_df_npx_clean <- OlinkAnalyze::check_npx(
  df = df_npx_clean
)

# Cleanup intermediate objects
rm(
  df_npx,
  check_log_df_npx
)
```

------------------------------------------------------------------------

#### *A note on calculating LOD with clean_npx()*

*When the function `clean_npx()` is used before calculating LOD, one should
disable exclusion of internal controls, external controls, assay warnings and
sample warnings to ensure that the LOD values are calculated correctly. This can
be done by setting the following parameters to FALSE in the `clean_npx()`
function: `remove_control_assay`, `remove_control_sample`,
`remove_assay_warning` and `remove_qc_warning`. This should be done regardless
of the LOD method that is used (fixed LOD or Negative Control LOD).*

*By default, `clean_npx()` removes both internal and external controls, which 
are required to calculate count-based LOD values. If `olink_lod()` is run 
without the internal or external controls present, the function will still 
execute, but all count-based LODs will be assigned `NA` values. In addition,
the `olink_lod()` function contains code to exclude only the relevant assay and
QC warnings for the LOD calculation, so these warnings do not need to be removed
for LOD to be calculated.*

*The function `clean_npx()` can be applied with default settings after LOD has
been calculated to remove controls and warnings from the dataset and prepare it
for downstream analyses.*

*More information on `clean_npx()` can be found in the
[Olink Analyze Overview tutorial](https://CRAN.R-project.org/package=OlinkAnalyze).*

------------------------------------------------------------------------

## Integrating Negative Control LOD

The negative control (NC) LOD method requires at least 10 negative controls in a
dataset. Negative control data is available in the standard exported Olink NGS
NPX parquet files. NCs can be identified through the SampleID and SampleType
columns.

A negative control will not contribute to the minimum number of required NCs if
the negative control does not pass sample QC criteria (sample QC failure or
warning) in all of the data (i.e. all datapoints measured for that sample).

Negative controls are used to calculate LOD from either PC normalized NPX or
counts. For assays with more than 150 counts in one of the negative controls,
LOD is calculated using the median PC normalized NPX and adding 3 standard
deviations, or 0.2 NPX whichever is larger. For assays with fewer than 150
counts in all negative controls, LOD is calculated using the count values which
are then converted into PC normalized NPX.

------------------------------------------------------------------------

#### *A note on calculating LOD from counts*

*Some assays will use count values as the LOD because the assay receives very
few counts in the negative controls. For the convenience of data processing, the
LOD in count values are converted to NPX values in the `olink_lod()` function.
The LOD value for this assay (in counts) will become many LOD values in NPX (as
extension control counts will vary across all samples). This is due to the fact
that minor changes on the counts scale can result in significant changes on the
NPX scale when working with small counts. The reason for this is that NPX is a
relative scale, which is calculated by dividing the counts of the assay by the
counts of the extension control. For example, given that the extension control
values remain constant, if a count value were to change from 1 count to 2
counts, this would be a change of 1 NPX, while a change from 1000 counts to 1001
counts would be negligible on the NPX scale.*

*Furthermore, due to the low number of counts, the NPX values calculated from
these counts do not correlate to true background levels. The converted NPX
values should not be used as LOD values for these assays.*

------------------------------------------------------------------------

The resulting LOD is the PC normalized negative control LOD. In the event that
the Olink NGS dataset is intensity normalized, an intensity normalization 
adjustment factor is applied and the resulting intensity normalized LOD is 
reported in the LOD column and the PC normalized LOD is reported in the 
PCNormalizedLOD column.

```{r NCLOD_example, eval = FALSE, message = FALSE, warning = FALSE}
# Calculate LOD from negative controls

## Calculate LOD
df_npx_nc_lod <- OlinkAnalyze::olink_lod(
  data = df_npx_clean,
  lod_method = "NCLOD",
  check_log = check_log_df_npx_clean
)

## Generate check log on data with LOD
check_log_df_npx_nc_lod <- OlinkAnalyze::check_npx(
  df = df_npx_nc_lod
)

## Clean NPX data with LOD
df_npx_nc_lod_clean <- OlinkAnalyze::clean_npx(
  df = df_npx_nc_lod,
  check_log = check_log_df_npx_nc_lod
)

## Generate check log on cleaned data with LOD
check_log_df_npx_nc_lod_clean <- OlinkAnalyze::check_npx(
  df = df_npx_nc_lod_clean
)

# Cleanup intermediate objects
rm(
  df_npx_nc_lod,
  check_log_df_npx_nc_lod
)

# Rename final cleaned data with LOD for clarity
df_npx_nc_lod <- df_npx_nc_lod_clean
check_log_df_npx_nc_lod <- check_log_df_npx_nc_lod_clean
rm(
  df_npx_nc_lod_clean,
  check_log_df_npx_nc_lod_clean
)
```

## Integrating Fixed LOD

The fixed LOD method uses fixed LOD values that have been calculated on negative
controls used in Olink reference runs using the method described above for
negative control LOD. These values are specific to the Data Analysis Reference
ID, which can be found in your dataset. The fixed LOD data is available in an
external CSV file which can be downloaded from the Document Download Center at
[olink.com](https://olink.com/knowledge/documents). The fixed LOD values
reported in this CSV file are the PC normalized LODs.

The fixed LOD file is read into the `olink_lod()` function to be integrated into
an Olink NGS dataset. In the event that the NGS dataset is intensity
normalized, an intensity normalization adjustment factor is applied and the
resulting intensity normalized LOD is reported in the LOD column and the PC
normalized LOD is reported in the PCNormalizedLOD column.

```{r FixedLOD, eval = FALSE, message = FALSE, warning = FALSE}
# Integrating fixed LOD

## Fixed LOD file path
fixedlod_filepath <- "Path_to/ExploreHT_fixedLOD.csv"

## Calculate LOD
df_npx_fixed_lod <- OlinkAnalyze::olink_lod(
  data = df_npx_clean,
  lod_method = "FixedLOD",
  lod_file_path = fixedlod_filepath,
  check_log = check_log_df_npx_clean
)

## Generate check log on data with LOD
check_log_df_npx_fixed_lod <- OlinkAnalyze::check_npx(
  df = df_npx_fixed_lod
)

## Clean NPX data with LOD
df_npx_fixed_lod_clean <- OlinkAnalyze::clean_npx(
  df = df_npx_fixed_lod,
  check_log = check_log_df_npx_fixed_lod
)

## Generate check log on cleaned data with LOD
check_log_npx_fixed_lod_clean <- OlinkAnalyze::check_npx(
  df = df_npx_fixed_lod_clean
)

# Cleanup intermediate objects
rm(
  df_npx_fixed_lod,
  check_log_df_npx_fixed_lod
)

# Rename final cleaned data with LOD for clarity
df_npx_fixed_lod <- df_npx_fixed_lod_clean
check_log_df_npx_fixed_lod <- check_log_npx_fixed_lod_clean
rm(
  df_npx_fixed_lod_clean,
  check_log_npx_fixed_lod_clean
)
```

## When to Use Fixed LOD vs NC LOD

For smaller sized studies (\<10 NCs) we recommend using fixed LOD to integrate
LOD values into your NPX dataset, as LOD calculations on fewer NCs may provide
non-accurate values. However, it is important to keep in mind that fixed LOD
values are not specific to your project, rather these values are generated by
Olink when a new lot of reagents is released.

For larger projects we recommend calculating LOD from NC to obtain LOD values
that are specific to your project. However, this requires that the dataset has
at least 10 NCs with passing SampleQC.

## Integrating Both NC LOD and Fixed LOD

There is also the option to calculate both NC LOD and fixed LOD for a data file
by setting `lod_method` to “Both”. The resulting data will have 4 additional
columns, starting with NC or Fixed to indicate the method used to calculate LOD,
followed by LOD or PCNormalizedLOD as explained above. An example of the file
format is shown below. Note that these columns will not automatically be
recognized by other functions within Olink Analyze that use LOD (for example
`olink_bridgeselector()`). To use these functions, the LOD value to be used
should have "LOD" as the column name.

```{r, echo = FALSE}
table1 |>
  dplyr::mutate(
    Normalization = "Intensity"
  ) |>
  dplyr::mutate(
    PCNormalizedNPX = round(x = .data[["NPX"]], digits = 2L)
  ) |>
  dplyr::mutate(
    PCNormalizedLOD = round(x = .data[["LOD"]], digits = 2L)
  ) |>
  dplyr::mutate(
    NPX = round(.data[["NPX"]] + 4.16, digits = 2L)
  ) |>
  dplyr::mutate(
    LOD = round(.data[["LOD"]] + 4.16, digits = 2L)
  ) |>
  dplyr::rename(
    "FixedLOD" = "LOD",
    "FixedPCNormalizedLOD" = "PCNormalizedLOD"
  ) |>
  dplyr::mutate(
    NCLOD = .data[["FixedLOD"]] - 2.34,
    NCPCNormalizedLOD = .data[["FixedPCNormalizedLOD"]] - 2.34
  ) |>
  dplyr::select(
    dplyr::all_of(
      c("SampleID", "SampleType", "OlinkID", "UniProt", "Assay", "Count", "NPX",
        "Normalization", "PCNormalizedNPX", "FixedLOD", "FixedPCNormalizedLOD",
        "NCLOD", "NCPCNormalizedLOD")
    )
  ) |>
  knitr::kable(
    caption = "Example results using both LOD calculation methods"
  ) |>
  kableExtra::kable_styling(
    font_size = 10L
  )
```

## Adjusting LOD for Intensity Normalized Data

If an Olink NGS dataset is intensity normalized, a normalization 
adjustment factor is applied to the PC normalized LOD within the `olink_lod()` 
function.

For each assay, this adjustment factor is calculated as the median NPX of all
samples (excluding Olink's external controls) within each plate. For Olink
Explore 3072, overlapping assays are assessed separately, within their
respective panels. The intensity normalized negative control LOD is calculated
by subtracting this adjustment factor from the PC normalized negative control
LOD.

The intensity normalization LOD adjustment is applied to both the negative
control and fixed LOD methods.

## Handling LOD in Bridge-Normalized Data

When using the `olink_normalization_bridge()` function to bridge two datasets,
the reference project remains unchanged throughout the bridging procedure,
including the NC LOD (calculated from negative controls in the reference
project) and the fixed LOD. In contrast, the LOD values (both NC LOD and fixed
LOD) for the non-reference project are adjusted using the same adjustment factor
that is applied to all other samples for the corresponding assay. This
adjustment factor is the median of the paired NPX differences per assay between
the bridging samples.

Consequently, for **within-product bridging**, LOD values from both the
reference and non-reference projects can be used for downstream analysis. In
contrast, for **between-product bridging**, differences in assay bridgeability
between products and the use of distinct normalization methods (median centering
versus quantile smoothing) should be taken into account. Therefore, we recommend
applying the LOD values from the reference project to the non-reference project
in between-product bridging.

## Export Olink NGS Data with LOD

Olink NGS data with LOD data can be exported using `arrow::write_parquet()` to 
export the data as a parquet file in long format.

```{r explore_npx_export, eval = FALSE, message = FALSE, warning = FALSE}
# Exporting Olink NGS data with LOD information as a parquet file

## Integrate both Negative Control LOD and fixed LOD before NPX preprocessing
df_npx_both_lod <- OlinkAnalyze::olink_lod(
  data = df_npx_clean,
  lod_file_path = fixedlod_filepath,
  lod_method = "Both",
  check_log = check_log_df_npx_clean
)

## Generate check log
check_log_df_npx_both_lod <- OlinkAnalyze::check_npx(
  df = df_npx_both_lod
)

## Clean NPX
df_npx_both_lod_clean <- OlinkAnalyze::clean_npx(
  df = df_npx_both_lod,
  check_log = check_log_df_npx_both_lod
)

## Generate check log on cleaned data
check_log_npx_both_lod_clean <- OlinkAnalyze::check_npx(
  df = df_npx_both_lod_clean
)

# Cleanup intermediate objects
rm(
  df_npx_both_lod,
  check_log_df_npx_both_lod
)

# Rename final cleaned data with both LOD for clarity
df_npx_both_lod <- df_npx_both_lod_clean
check_log_df_npx_both_lod <- check_log_npx_both_lod_clean
rm(
  df_npx_both_lod_clean,
  check_log_npx_both_lod_clean
)

# Add metadata for export
df_npx_both_lod_arrow <- df_npx_both_lod |>
  arrow::as_arrow_table()

df_npx_both_lod_arrow$metadata$FileVersion <- "NA"
df_npx_both_lod_arrow$metadata$ExploreVersion <- "NA"
df_npx_both_lod_arrow$metadata$ProjectName <- "NA"
df_npx_both_lod_arrow$metadata$SampleMatrix <- "NA"
df_npx_both_lod_arrow$metadata$DataFileType <- "Olink Analyze Export File"
# One of "ExploreHT", "Explore3072", or "Reveal"
df_npx_both_lod_arrow$metadata$ProductType <- "ExploreHT"
# # "ExploreHT", "Explore3072", or "Reveal"
df_npx_both_lod_arrow$metadata$Product <- "ExploreHT"

arrow::write_parquet(
  x = df_npx_both_lod_arrow,
  sink = "path_to_output.parquet"
)
```

## Contact Us

We are always happy to help. Email us with any questions:

-   biostat\@olink.com for statistical services and general stats
    questions

-   support\@olink.com for Olink lab product and technical support

-   info\@olink.com for more information

## Legal Disclaimer

© `r format(Sys.Date(), "%Y")` Olink Proteomics AB, part of Thermo Fisher
Scientific.

Olink products and services are For Research Use Only. Not for use in diagnostic
procedures.

All information in this document is subject to change without notice. This
document is not intended to convey any warranties, representations and/or
recommendations of any kind, unless such warranties, representations and/or
recommendations are explicitly stated.

Olink assumes no liability arising from a prospective reader’s actions based on
this document.

OLINK, NPX, PEA, PROXIMITY EXTENSION, INSIGHT and the Olink logotype are
trademarks registered, or pending registration, by Olink Proteomics AB. All
third-party trademarks are the property of their respective owners.

Olink products and assay methods are covered by several patents and patent
applications [https://www.olink.com/patents/](https://olink.com/patents/).
